#ifndef ATA_H
#define ATA_H

#include "cam_con.h"

#define MULTIPLE_CHIP_OFFSET    (0x88 >> 2)
#define MULTIPLE_CHIP_STATUS    (0x8C >> 2)



#define         U66DISK         0x2
#define PTI_NUMBER_DRIVE          8

#define DFLAGS_ATAPI_ATA5            0x1


#define NO_RAINMAKER               0x00
//modified by isaac for SX150 support
/*#define RAINMAKER_33               0x01
#define RAINMAKER_66               0x02
#define RAINMAKER_66B                      0x03 
#define RAINMAKER_100                      0x04  
#define RAINMAKER_INTEL_100        0x05 */
#define RAINMAKER_621              0x01
#define RAINMAKER_622              0x02

#define iNDEXIDEData                0x00
#define iNDEXIDESectorCount		    0x08
#define iNDEXIDECICR               0x60
#define iNDEXIDEFeature				0x04
#define iNDEXIDECommand             0x1c
#define iNDEXIDEDeviceHead          0x18
#define iNDEXIDEAlternateStatus     0x38
#define iNDEXIDECylinderLow         0x10
#define iNDEXIDECylinderHigh        0x14



//
// IDE drive control definitions
//

#define IDE_DC_DISABLE_INTERRUPTS    0x02
#define IDE_DC_RESET_CONTROLLER      0x04
#define IDE_DC_REENABLE_CONTROLLER   0x00
/*
#pragma pack(1)
typedef struct _IDENTIFY_DATA {
    USHORT GeneralConfiguration;            // 00
    USHORT NumberOfCylinders;               // 02
    USHORT Reserved1;                       // 04
    USHORT NumberOfHeads;                   // 06
    USHORT UnformattedBytesPerTrack;        // 08
    USHORT UnformattedBytesPerSector;       // 0A
    USHORT SectorsPerTrack;                 // 0C
    USHORT VendorUnique1[3];                // 0E
    USHORT SerialNumber[10];                // 14
    USHORT BufferType;                      // 28
    USHORT BufferSectorSize;                // 2A
    USHORT NumberOfEccBytes;                // 2C
    USHORT FirmwareRevision[4];             // 2E
    USHORT ModelNumber[20];                 // 36
    UCHAR  MaximumBlockTransfer;            // 5E
    UCHAR  VendorUnique2;                   // 5F
    USHORT DoubleWordIo;                    // 60
    USHORT Capabilities;                    // 62
    USHORT Reserved2;                       // 64
    UCHAR  VendorUnique3;                   // 66
    UCHAR  PioCycleTimingMode;              // 67
    UCHAR  VendorUnique4;                   // 68
    UCHAR  DmaCycleTimingMode;              // 69
    USHORT TranslationFieldsValid:1;        // 6A
    USHORT SpeedFieldsValid:1;              // 6A
    USHORT Reserved3:14;
    USHORT NumberOfCurrentCylinders;        // 6C
    USHORT NumberOfCurrentHeads;            // 6E
    USHORT CurrentSectorsPerTrack;          // 70
    ULONG  CurrentSectorCapacity;           // 72
    USHORT Reserved4[197];                  // 76
} IDENTIFY_DATA, *PIDENTIFY_DATA;




typedef struct _HW_DEVICE_EXTENSION {

   //
   // Timer Type
   //
   UCHAR bTimerType;

   //
   // Current request on controller.
   //
   SCSI_RAID_REQ QueueSrb[NT_MAX_CONCURRENT_THREAD];


   //
   // Pointer to Event of RAID engine.
   //
   bpEVENT pCurrentEvent;

   //
   // Used for Reset, to indicate which channel reset.
   //
   UCHAR bResetChannel;

   //
   // Power Status
   //
   BOOLEAN bSysSuspend;


   //
   // Indicate the interrupt level.
   //
   ULONG InterruptLevel;


   //  To distinguish between FastTrak33 and FastTrak66

   UCHAR PromiseRainMaker;                   

   // ID used to count the driver instance
   ULONG AdapterID;                         //05/06/97 S.Zhu
    // Pointer to adapter data

    PHW_ADAPTER_EXTENSION pPromiseAdapter;

} HW_DEVICE_EXTENSION, *PHW_DEVICE_EXTENSION;




#define GetStatus_62X(IDEBaseAddress, Channel, Status)\
{\
	ReadIDEIndexUchar(IDEBaseAddress, Channel, iNDEXIDECommand, Status);\
}

#define GetBaseStatus_62X(IDEBaseAddress, Channel, Status)\
{\
	ReadIDEIndexUchar(IDEBaseAddress, Channel, iNDEXIDECommand, Status);\
}


#define ReadIDEIndexUshort(IDEBaseAddress,Channel,Index,Data)\
{\
    ULONG   indexReg=(ULONG)(Index);\
    ULONG  lData;\
    ULONG   indexOffset=(ULONG) ((Channel) * 0x10 + INDEX_REGISTER_OFFSET) >> 2;\
    ULONG   DataOffset=(ULONG)((Channel) * 0x10 + DATA_REGISTER_OFFSET ) >> 2;\
\
    ScsiPortWritePortUlong(IDEBaseAddress + indexOffset, indexReg);\
    lData=ScsiPortReadPortUlong(IDEBaseAddress + DataOffset);\
    Data = (USHORT)lData;\
}



#define ReadIDEIndexUchar(IDEBaseAddress, Channel, Index, Data)\
{\
    ULONG   lData;\
    ULONG   indexReg=(ULONG)(Index);\
    ULONG   indexOffset=(ULONG)((Channel) * 0x10 + INDEX_REGISTER_OFFSET) >> 2;\
    ULONG   DataOffset=(ULONG) ((Channel) * 0x10 + DATA_REGISTER_OFFSET) >> 2;\
\
    ScsiPortWritePortUlong(IDEBaseAddress + indexOffset, indexReg);\
    lData=ScsiPortReadPortUlong(IDEBaseAddress + DataOffset);\
    Data = (UCHAR)lData;\
}


#define WaitOnBusy_62X(IDEBaseAddress, Channel, Status)\
{\
    ULONG i;\
	for (i=0; i<20000; i++) {\
        GetStatus_62X(IDEBaseAddress, Channel,Status);\
		if (Status==0xFF)\
			break;\
        if (Status & IDE_STATUS_BUSY) {\
            ScsiPortStallExecution(150);\
            continue;\
        } else {\
            break;\
        }\
    }\
}

#define WaitForDrq_62X(IDEBaseAddress, Channel, Status)\
{\
    ULONG i;\
    for (i=0; i<1000; i++) {\
        GetStatus_62X(IDEBaseAddress, Channel, Status);\
		if (Status==0xFF)\
			break;\
        if (Status & IDE_STATUS_BUSY) {\
            ScsiPortStallExecution(100);\
        } else if (Status & IDE_STATUS_DRQ) {\
            break;\
        } else {\
            ScsiPortStallExecution(200);\
        }\
    }\
}



#define WriteIDEIndexUchar(IDEBaseAddress, Channel, Index, Data)\
{\
    ULONG   lData;\
    ULONG   indexReg=(ULONG)(Index);\
    ULONG   indexOffset=(ULONG)((Channel) * 0x10 + INDEX_REGISTER_OFFSET) >> 2;\
    ULONG   DataOffset=(ULONG) ((Channel) * 0x10 + DATA_REGISTER_OFFSET ) >> 2;\
\
    ScsiPortWritePortUlong(IDEBaseAddress + indexOffset, indexReg);\
    lData = (ULONG)Data;\
    ScsiPortWritePortUlong(IDEBaseAddress + DataOffset, lData);\
}


extern void DriveSetFeature_62X(PHW_ADAPTER_EXTENSION pAdapterExtension, 
                     ULONG bTargetID);

extern void 
SetTransferModeRelated_62X(
      PHW_ADAPTER_EXTENSION pAdapterExtension, 
      IN UCHAR bChannel);            //11/20/97 Q.W


extern BOOLEAN
ChannelIssueIdentify_62X(
    IN PVOID HwDeviceExtension,
    IN ULONG AdapterNumber,
    IN ULONG targetid
    );

extern UCHAR CheckMultipleChip_62X(PHW_ADAPTER_EXTENSION pAdapterExtension);
*/
#endif
