

#ifndef CAM_DEF_H
#define CAM_DEF_H

#ifndef netware
#ifndef __LINUX__
typedef 	U32*	PU32;
typedef 	U16*	PU16;
typedef 	U8*		PU8;
#endif
#endif


#ifdef netware
	#include "cam_patc.h"
#endif


/* &&&&&&& */
typedef struct  _U64{
	U32	data;
	U32	ornament;
}U64,*PU64;
/* &&&&&&& */


/* modified by Jeff for ECC 2001/11/26 */
typedef struct PACKET_HEAD{
	U32  NPA;					/* Next Packet Address*/
	void *PTA;     				/* Parent Task Address, original dTask Point */       /* &&&&&&&&&&*/
	U32  ModelType;				
	U32  Address;				/* packet address of itself */             /*&&&&&&&&&&&*/
}PACKET_HEAD,*PPACKET_HEAD;

typedef struct _ATA_PACKET{

    U8 bControl;
    U8 bReserved;
    U8 bSynSeqID;                /* synchronization sequence ID */
    U8 bDelaySeqID;              /* delay seqence ID           */
                                              
    U32 ulPSG;                    /* point to SG table		*/
    U32 ulNCA;                    /* Pointer to Next ATA Packet  */

    U8 bATRL[MAXREGCNT];

    U32  ulStartLBA;
    U32  ulGasket;

}ATA_PACKET,*PATA_PACKET;

typedef struct _XOR_PACKET {
    U8 bControl;
    U8 bReserved;
    U8 bSynSeqID;                /*synchronization sequence ID */ 
    U8 bDelaySeqID;              /* delay seqence ID*/ 
                                              
    U32 ulPSG[6];                    /* point to SG table 0--5*/ 
    U32 ulNCA;                    /*Pointer to Next XOR Packet */ 
/*    U32 ulPadding;			 &&&&&&&&&&&& 		//removed by Jeff for ECC 2001/11/21*/
}XOR_PACKET,*PXOR_PACKET;

typedef struct _HDMA_PACKET{
    U8 bControl;
    U8 bReserved;
    U8 bSynSeqID;               /*synchronization sequence ID */ 
    U8 bDelaySeqID;             /* delay seqence ID */           
                                              
    U32 ulPSGHost;               /* point to SG table of Host Memory*/ 
    U32 ulPSGLocal;              /* point to SG table of Local Memory*/ 

    U32 ulNCA;                   /* Pointer to Next XOR Packet*/ 

}HDMA_PACKET,*PHDMA_PACKET;

typedef struct _SX4_ATA_PACKET{
	PACKET_HEAD   PacketHead;
	ATA_PACKET    ATAPacket;
}SX4_ATA_PACKET,*PSX4_ATA_PACKET;

typedef struct _SX4_XOR_PACKET{
	PACKET_HEAD   PacketHead;
	XOR_PACKET    XORPacket;
}SX4_XOR_PACKET,*PSX4_XOR_PACKET;

typedef struct _SX4_HDMA_PACKET{
	PACKET_HEAD   PacketHead;
	HDMA_PACKET   HDMAPacket;
}SX4_HDMA_PACKET,*PSX4_HDMA_PACKET;

typedef struct {
#ifdef __LINUX__
	U32 ATABaseAddress[MAX_ADAPTER_NUM];			/*&&&&&&&&&&*/
	U32 XORBaseAddress[MAX_ADAPTER_NUM];			/*&&&&&&&&&&*/
	U32 SEQBaseAddress[MAX_ADAPTER_NUM];			/*&&&&&&&&&&*/
	U32 MMIOBaseAddress[MAX_ADAPTER_NUM];		/*&&&&&&&&&&*/
	PU32 SDRAMBaseAddress[MAX_ADAPTER_NUM];		/*&&&&&&&&&&*/
        U8  bSDRAMWindowsSize[MAX_ADAPTER_NUM];
    							/* 	0x00 - 32K
                              		0x01 - 64K
                                    0x02 - 128K
                                   	0x03 - 2G */
	U16 bus_num[MAX_ADAPTER_NUM];
	U16 devfn[MAX_ADAPTER_NUM];
	U8 IRQ[MAX_ADAPTER_NUM];
#endif /* __LINUX__ */
/*#else*/
#ifdef NT
	PU32 ATABaseAddress[MAX_ADAPTER_NUM];			/*&&&&&&&&&&*/
	PU32 XORBaseAddress[MAX_ADAPTER_NUM];			/*&&&&&&&&&&*/
	PU32 SEQBaseAddress[MAX_ADAPTER_NUM];			/*&&&&&&&&&&*/
	PU32 MMIOBaseAddress[MAX_ADAPTER_NUM];		/*&&&&&&&&&&*/
	PU32 SDRAMBaseAddress[MAX_ADAPTER_NUM];		/*&&&&&&&&&&*/
    U8  bSDRAMWindowsSize[MAX_ADAPTER_NUM];
    U8  IRQ[MAX_ADAPTER_NUM];	
    							/* 	0x00 - 32K
                             		0x01 - 64K
                                    0x02 - 128K
                                   	0x03 - 2G */
#endif /* NT */
#ifdef __FreeBSD__
	U32 ATABaseAddress[MAX_ADAPTER_NUM];			/*&&&&&&&&&&*/
	U32 XORBaseAddress[MAX_ADAPTER_NUM];			/*&&&&&&&&&&*/
	U32 SEQBaseAddress[MAX_ADAPTER_NUM];			/*&&&&&&&&&&*/
	U32 MMIOBaseAddress[MAX_ADAPTER_NUM];		/*&&&&&&&&&&*/
	PU32 SDRAMBaseAddress[MAX_ADAPTER_NUM];		/*&&&&&&&&&&*/
        U8  bSDRAMWindowsSize[MAX_ADAPTER_NUM];
    							/* 	0x00 - 32K
                              		0x01 - 64K
                                    0x02 - 128K
                                   	0x03 - 2G */
	U16 bus_num[MAX_ADAPTER_NUM];
	U16 devfn[MAX_ADAPTER_NUM];
	U8 IRQ[MAX_ADAPTER_NUM];
#endif /* __FreeBSD__ */

#ifdef netware
	U32 ATABaseAddress[MAX_ADAPTER_NUM];			/*&&&&&&&&&&*/
	U32 XORBaseAddress[MAX_ADAPTER_NUM];			/*&&&&&&&&&&*/
	U32 SEQBaseAddress[MAX_ADAPTER_NUM];			/*&&&&&&&&&&*/
	U32 MMIOBaseAddress[MAX_ADAPTER_NUM];		/*&&&&&&&&&&*/
	U32 SDRAMBaseAddress[MAX_ADAPTER_NUM];		/*&&&&&&&&&&*/
    U8  bSDRAMWindowsSize[MAX_ADAPTER_NUM];
    U8  IRQ[MAX_ADAPTER_NUM];	
    							/* 	0x00 - 32K
                             		0x01 - 64K
                                    0x02 - 128K
                                   	0x03 - 2G */
#endif



}ADAPTER_CONFIG_INFO,*PADAPTER_CONFIG_INFO;		

struct pac_q_softc {
    U32 *top;
    U32 *bottom;
    U32 *pcurrent;
};

typedef enum {
    ATA_PAC = 0x00,
    XOR_PAC = 0x01,
    HDMA_PAC = 0x02
} pac_type, pac_q_type;


#ifdef __LINUX__
typedef struct{
	U32 ap_sq;
	U32 p_prd;
	U16 NumOfPSG;
}XOR_SEQ_QUEUE, *pXOR_SEQ_QUEUE;
#endif /* __LINUX__ */
/*#else*/
#ifdef NT
typedef struct{
	bpSEQ ap_sq;
	U32 p_prd;
	U16 NumOfPSG;
}XOR_SEQ_QUEUE, *pXOR_SEQ_QUEUE;
#endif /* NT */
#ifdef __FreeBSD__
typedef struct{
	U32 ap_sq;
	U32 p_prd;
	U16 NumOfPSG;
}XOR_SEQ_QUEUE, *pXOR_SEQ_QUEUE;
#endif /* __FreeBSD__ */


#ifdef netware
typedef struct{
	bpSEQ ap_sq;
	U32 p_prd;
	U16 NumOfPSG;
}XOR_SEQ_QUEUE, *pXOR_SEQ_QUEUE;
#endif /* NT */



#ifndef netware
	XOR_SEQ_QUEUE XorQueue[MAX_ADAPTER_NUM][MAX_XOR_SEQ_QUEUE];
	U16 XORSeqQHead[MAX_ADAPTER_NUM],XORSeqQTail[MAX_ADAPTER_NUM];
#endif


#ifdef netware
typedef struct {
	U8 bCh;
	U8 bID;
	U8 cmd;
	U8 seqid;
	U8 finish;
} SMART_INFO;
#endif




/*fanru added for 48-bit LBA command  & Down speed [2001-10-10] ----  start*/
typedef struct _Disk_Info_{
        U8 bSupport48bitLBA;  /*1 support 48-bit LBA*/
        U8 PIOModeStatus;    /*    */
        U8 DMAModeStatus;
        U8 ULTRAModeStatus;        
}DiskInfoDef, *pDiskInfoDef;
/*fanru added for 48-bit LBA command & Down speed [2001-10-10] ----  end*/

//Label_bp begin
// kernel added for SuperSwap1100/4100

#define	LEDNOCHANGE	0xFF

/* definitions for LED type */
#define	ActiveLED		bit(0)
#define	StatusLED		bit(1)
#define	Global0LED		bit(2)
#define	Global1LED		bit(3)

/* definitions for on/off of ActiveLED/Global0LED/Global1LED */
#define	LEDOFF			0x00
#define	LEDON			0x01

/* definitions for LED flash */
/*#define	FASTFLASH		0x03
#define	SLOWFLASH		0x02
#define	NOFLASH			0x00*/


/* definitions for flash */
#define	HDActiveOFF			0x00
#define	HDActiveON			0x01

/* definitions for disk LED control*/
//#define HD				0x00
#define HDReady			0x01
#define HDFail_Offline	0x02
#define HDRebuild		0x04
#define HDSyn			0x08
#define HDremoved		0x10
#define NOHD			0x80

/* definitions for global LED control*/
#define SW_DiskAccessed		0x01
#define SW_DiskFail			0x02
#define SW_Rebuild			0x04

#define GLED_DARK				0x00
#define GLED_LIGHT				0x01
#define GLED_SLOWBLINKING		0x02
#define GLED_FASTBLINKING		0x03

#define	MAXDELAYFORI2C		0x200
#define	INITI2CTIME			0x20

#define	BayShiftBits		4
/* definition of DEVICE ID */
#define SBOX_4				bit(0)
#define SBOX_NO_PWM			bit(1)

#define	NOSBOX				0x00

#define	SBOXWITHPWM		bit(0)
#define	SBOXEXIST			bit(7)

#define MAX_BAY_PER_BOX		4
#define MAX_I2C_PAC			4*0x10 /* MAX 254 */

typedef struct _CAM_SBOX_LED
{
	union {
		U8		ActiveLed;	/* LEDON/LEDOFF */
		U8		StausLed;		/* LED_Red/LED_Green/LED_Amber */
	} LED;
	U8		Flash;	/* NOFLASH/SLOWFLASH/FASTFLASH */
} CAM_SBOX_LED,  *PCAM_SBOX_LED;

typedef struct _CAM_HDAccess_LED_Buffer
{
	CAM_SBOX_LED Buffer_LED;
	U8 b_ID;
	U8 UsedFlag;
} CAM_HDAccess_LED_Buffer,  *PCAM_HDAccess_LED_Buffer;

typedef struct _CAM_Ctrl_LED
{
	union {
		U8		StausLed;		/* LED_Red/LED_Green/LED_Amber */
		U8		ActiveLed;	/* LEDON/LEDOFF */
		U8		GlobalLed;	/* LEDON/LEDOFF */
	} LED;
	U8		Flash;		/* NOFLASH/SLOWFLASH/FASTFLASH */
	U8		LED_Type;	/* ActiveLED/StatusLED/Global0LED/Global1LED */
} CAM_Ctrl_LED,   *PCAM_Ctrl_LED;

typedef struct _CAM_HDAccess_LED
{
	U8		Flash;		/* NOFLASH/SLOWFLASH/FASTFLASH */
	U8		LED_OnOff;	/* LEDON/LEDOFF */
} CAM_HDAccess_LED,   *PCAM_HDAccess_LED;

typedef struct _CAM_HDAccess_LED_All
{
	CAM_HDAccess_LED Active_LED;
	CAM_HDAccess_LED Status_LED;
	CAM_HDAccess_LED Global0_LED;
	CAM_HDAccess_LED Global1_LED;
} CAM_HDAccess_LED_All,   *PCAM_HDAccess_LED_All;


/* definitions for BOXLEDConfig */
#define	WITH_STATUS_LED					0x01
#define	WITH_FLASH_OF_STATUS_LED		0x02
#define	WITH_ACTIVE_LED					0x04
#define	WITH_FLASH_OF_ACTIVE_LED		0x08
#define	WITH_GLOBAL0_LED				0x10
#define	WITH_FLASH_OF_GLOBAL0_LED		0x20
#define	WITH_GLOBAL1_LED				0x40
#define	WITH_FLASH_OF_GLOBAL1_LED		0x80

/* definitions for PowerState */
#define	PowerOFF		0x01
#define	PowerON			0x00

//Label_bp end

struct sx_ad_softc {
    struct  sx_pci_softc *sx_pci;
    int     unit;
    int     lun;
    U32     start_addr_port;
    U32     index_port;
    U32     data_port;

    struct  sx_ad_param *ad_param;
    U32     total_secs;     /* total number of sectors (LBA) */
    U16      heads;
    U16      sectors;
    U32     cyls;
    U32     transfersize;   /* size of each xfer */
    U8      current_mode;
    U8	arr;
    U8	strm;
    U8	valid;
    U8	cpending;
    int     num_tags;       /* number of tags supported */
    U32     flags;
#define     AD_F_LABELLING      0x0001
#define     AD_F_LBA_ENABLED    0x0002
#define     AD_F_32B_ENABLED    0x0004
#define     AD_F_TAG_ENABLED    0x0008
};

/* definitions for BOXConfig of SBOX_Type*/
//#define	SBOXEXIST					bit(0)
//#define	SBOXWITHPWM					bit(1)
#define	SBOXWITHPWMUNASSIGNED		bit(2)
#define	SBOXCOMBO					bit(7)		/* has muitible bays */

/* definition of 10398 Chip control register */
#define	PWMCOMPARE				bit(2)
#define	PWMCOMPARERESULT		bit(3)

#define IDE_STATUS_ERROR             0x01
#define IDE_STATUS_INDEX             0x02
#define IDE_STATUS_CORRECTED_ERROR   0x04
#define IDE_STATUS_DRQ               0x08
#define IDE_STATUS_DSC               0x10
#define IDE_STATUS_DRDY              0x40
#define IDE_STATUS_IDLE              0x50
#define IDE_STATUS_BUSY              0x80

#endif
