#ifndef CAM_MACR_H
#define CAM_MACR_H



#ifndef _MMMAP_
/*#define _MMMAP_     1*/
#endif

#ifdef __LINUX__
#ifndef bit
	#define bit(x) (1 << x)
#endif
       #define ReadATAPort(ATABaseAddress, Offset, Data) { U32 lOffset=Offset<<2; Data = inl(ATABaseAddress + lOffset); }

	#define WriteATAPort(ATABaseAddress, Offset, Data) { U32 lOffset=Offset<<2; outl(Data,ATABaseAddress + lOffset); }

	#define ReadSEQPort(SEQBaseAddress, Offset, Data) { U32 lOffset=Offset<<2; Data = inl(SEQBaseAddress + lOffset); }

	#define WriteSEQPort(SEQBaseAddress, Offset, Data) { U32 lOffset=Offset<<2;  outl(Data,SEQBaseAddress + lOffset); }


#define CHIP_CONTROL_OFFSET   (0x80 >> 2)

#define ReadHDMAIndex(HDMABaseAddress, CID, IndexReg, Data){ULONG indexOffset = (CID) * 0x10 + INDEX_REGISTER_OFFSET ;ULONG DataOffset = (CID) * 0x10 + DATA_REGISTER_OFFSET;ScsiPortWritePortUlong(HDMABaseAddress + indexOffset, IndexReg);Data = ScsiPortReadPortUlong(HDMABaseAddress + DataOffset);}

#define WriteHDMAIndex(HDMABaseAddress, CID, IndexReg, Data){ULONG indexOffset = (CID) * 0x10 + INDEX_REGISTER_OFFSET;ULONG DataOffset = (CID) * 0x10 + DATA_REGISTER_OFFSET;ScsiPortWritePortUlong(HDMABaseAddress + indexOffset, IndexReg);ScsiPortWritePortUlong(HDMABaseAddress + DataOffset , Data);}

#define XOR_OFFSET (0x40)

#define ReadXORIndex(XORBaseAddress, Port, IndexReg, Data){ULONG indexOffset = (Port) * 0x10 + INDEX_REGISTER_OFFSET; ULONG DataOffset = (Port) * 0x10 + DATA_REGISTER_OFFSET; ScsiPortWritePortUlong(XORBaseAddress + indexOffset + XOR_OFFSET, IndexReg);Data = ScsiPortReadPortUlong(XORBaseAddress + DataOffset + XOR_OFFSET);}

#define WriteXORIndex(XORBaseAddress, CID, IndexReg, Data){ULONG indexOffset = (CID) * 0x10 + INDEX_REGISTER_OFFSET;ULONG DataOffset = (CID) * 0x10 + DATA_REGISTER_OFFSET; ScsiPortWritePortUlong(XORBaseAddress + indexOffset + XOR_OFFSET, IndexReg);ScsiPortWritePortUlong(XORBaseAddress + DataOffset + XOR_OFFSET, Data);}

#define ReadIDEIndex(IDEBaseAddress, Channel, Index, Data){ULONG   indexReg=(ULONG)(Index);ULONG   indexOffset=(ULONG)(Channel) * 0x10 + INDEX_REGISTER_OFFSET; ULONG   DataOffset=(ULONG)(Channel) * 0x10 + DATA_REGISTER_OFFSET; ScsiPortWritePortUlong(IDEBaseAddress + indexOffset, indexReg);Data=ScsiPortReadPortUlong(IDEBaseAddress + DataOffset);}

extern void WriteChipControlIndex(U32 XorBaseAddress,U32 CID, U32 IndexReg,U32 Data);
extern void ReadChipControlIndex(U32 XorBaseAddress,U32 CID, U32 IndexReg,PU32 Data);
extern void ReadIDEIndexUchar(unsigned int,unsigned char,unsigned char,unsigned char *);
extern void WriteIDEIndexUchar(unsigned int,unsigned char,unsigned char,unsigned char);
extern void ReadIDEIndexUshort(unsigned int,unsigned char,unsigned char,unsigned short *);
extern U32 ScsiPortReadPortUlong(U32 dest);
extern void ScsiPortWritePortUlong(ULONG Port,ULONG Value);
extern void ScsiPortReadRegisterBufferUchar(PUCHAR Dest,PUCHAR Source,U32 sizet);
extern void ScsiPortReadRegisterBufferUlong(PULONG Dest,PULONG Source,U32 sizet);
extern void ScsiPortWriteRegisterBufferUchar(PUCHAR Dest,PUCHAR Source,U32 sizet);
extern void ScsiPortWriteRegisterBufferUlong(PULONG Dest,PULONG Source,U32 sizet);
extern void WriteIDEIndex(U32,U8,U8,U32);



#endif /* __LINUX__ */


#ifdef NT
extern void WriteRegisterBufferUlong(PU32 pTargetAddr,PU32 pSourceAddr, U32 lLen);
extern void ReadRegisterBufferUlong(PU32 pSourceAddr,PU32 pTargetAddr, U32 lLen);


#ifndef _MMMAP_ 
#define ReadATAPort(ATABaseAddress, Offset, Data)\
{\
    Data = ScsiPortReadPortUlong(ATABaseAddress + Offset);\
}
#define WriteATAPort(ATABaseAddress, Offset, Data)\
{\
    ScsiPortWritePortUlong(ATABaseAddress + Offset, Data);\
}

#define ReadSEQPort(SEQBaseAddress, Offset, Data)\
{\
    Data = ScsiPortReadPortUlong(SEQBaseAddress + Offset);\
}
#define WriteSEQPort(SEQBaseAddress, Offset, Data)\
{\
    ScsiPortWritePortUlong(SEQBaseAddress + Offset, Data);\
}

#define CHIP_CONTROL_OFFSET   (0x80 >> 2)

#define WriteChipControlIndex(XorBaseAddress, CID, IndexReg, Data)\
{\
    ULONG indexOffset = ((CID) * 0x10 + INDEX_REGISTER_OFFSET) >> 2;\
    ULONG DataOffset = ((CID) * 0x10 + DATA_REGISTER_OFFSET) >> 2;\
\
    ScsiPortWritePortUlong(XorBaseAddress + indexOffset + CHIP_CONTROL_OFFSET, IndexReg);\
    ScsiPortWritePortUlong(XorBaseAddress + DataOffset + CHIP_CONTROL_OFFSET, Data);\
}

#define ReadChipControlIndex(XorBaseAddress, CID, IndexReg, Data)\
{\
    ULONG indexOffset = ((CID) * 0x10 + INDEX_REGISTER_OFFSET) >> 2;\
    ULONG DataOffset = ((CID) * 0x10 + DATA_REGISTER_OFFSET) >> 2;\
\
    ScsiPortWritePortUlong(XorBaseAddress + indexOffset + CHIP_CONTROL_OFFSET, IndexReg);\
    Data=ScsiPortReadPortUlong(XorBaseAddress + DataOffset + CHIP_CONTROL_OFFSET);\
}

#define WriteChipControlIndexUshort(XorBaseAddress, CID, IndexReg, Data)\
{\
    ULONG indexOffset = ((CID) * 0x10 + INDEX_REGISTER_OFFSET) >> 2;\
    ULONG DataOffset = ((CID) * 0x10 + DATA_REGISTER_OFFSET) >> 2;\
\
    ScsiPortWritePortUlong(XorBaseAddress + indexOffset + CHIP_CONTROL_OFFSET, IndexReg);\
    ScsiPortWritePortUshort((PUSHORT)(XorBaseAddress + DataOffset) + CHIP_CONTROL_OFFSET, Data);\
}

#define ReadChipControlIndexUshort(XorBaseAddress, CID, IndexReg, Data)\
{\
    ULONG indexOffset = ((CID) * 0x10 + INDEX_REGISTER_OFFSET) >> 2;\
    ULONG DataOffset = ((CID) * 0x10 + DATA_REGISTER_OFFSET) >> 2;\
\
    ScsiPortWritePortUlong(XorBaseAddress + indexOffset + CHIP_CONTROL_OFFSET, IndexReg);\
    Data=ScsiPortReadPortUshort((PUSHORT)(XorBaseAddress + DataOffset) + CHIP_CONTROL_OFFSET);\
}

#define ReadHDMAIndex(HDMABaseAddress, CID, IndexReg, Data)\
{\
    ULONG indexOffset = ((CID) * 0x10 + INDEX_REGISTER_OFFSET) >> 2;\
    ULONG DataOffset = ((CID) * 0x10 + DATA_REGISTER_OFFSET) >> 2;\
\
    ScsiPortWritePortUlong(HDMABaseAddress + indexOffset, IndexReg);\
    Data = ScsiPortReadPortUlong(HDMABaseAddress + DataOffset);\
}
#define WriteHDMAIndex(HDMABaseAddress, CID, IndexReg, Data)\
{\
    ULONG indexOffset = ((CID) * 0x10 + INDEX_REGISTER_OFFSET) >> 2;\
    ULONG DataOffset = ((CID) * 0x10 + DATA_REGISTER_OFFSET) >> 2;\
\
    ScsiPortWritePortUlong(HDMABaseAddress + indexOffset, IndexReg);\
    ScsiPortWritePortUlong(HDMABaseAddress + DataOffset , Data);\
}

#define XOR_OFFSET (0x40 >> 2)

#define ReadXORIndex(XORBaseAddress, Port, IndexReg, Data)\
{\
    ULONG indexOffset = ((Port) * 0x10 + INDEX_REGISTER_OFFSET) >> 2;\
    ULONG DataOffset = ((Port) * 0x10 + DATA_REGISTER_OFFSET) >> 2;\
\
    ScsiPortWritePortUlong(XORBaseAddress + indexOffset + XOR_OFFSET, IndexReg);\
    Data = ScsiPortReadPortUlong(XORBaseAddress + DataOffset + XOR_OFFSET);\
}

#define WriteXORIndex(XORBaseAddress, CID, IndexReg, Data)\
{\
    ULONG indexOffset = ((CID) * 0x10 + INDEX_REGISTER_OFFSET) >> 2;\
    ULONG DataOffset = ((CID) * 0x10 + DATA_REGISTER_OFFSET) >> 2;\
\
    ScsiPortWritePortUlong(XORBaseAddress + indexOffset + XOR_OFFSET, IndexReg);\
    ScsiPortWritePortUlong(XORBaseAddress + DataOffset + XOR_OFFSET, Data);\
}



#define ReadIDEIndex(IDEBaseAddress, Channel, Index, Data)\
{\
    ULONG   indexReg=(ULONG)(Index);\
    ULONG   indexOffset=(ULONG)((Channel) * 0x10 + INDEX_REGISTER_OFFSET) >> 2;\
    ULONG   DataOffset=(ULONG)((Channel) * 0x10 + DATA_REGISTER_OFFSET) >> 2;\
\
    ScsiPortWritePortUlong(IDEBaseAddress + indexOffset, indexReg);\
    Data=ScsiPortReadPortUlong(IDEBaseAddress + DataOffset);\
}

#define ReadIDEIndexUchar(IDEBaseAddress, Channel, Index, Data)\
{\
    ULONG   lData;\
    ULONG   indexReg=(ULONG)(Index);\
    ULONG   indexOffset=(ULONG)((Channel) * 0x10 + INDEX_REGISTER_OFFSET) >> 2;\
    ULONG   DataOffset=(ULONG) ((Channel) * 0x10 + DATA_REGISTER_OFFSET) >> 2;\
\
    ScsiPortWritePortUlong(IDEBaseAddress + indexOffset, indexReg);\
    lData=ScsiPortReadPortUlong(IDEBaseAddress + DataOffset);\
    Data = (UCHAR)lData;\
}

#else   /* mem map */
#ifdef WIN95_ONLY
#define ReadATAPort(ATABaseAddress, Offset, Data)\
{\
        ReadRegisterBufferUlong(ATABaseAddress + ((Offset)>>2),&Data,1); \
}
#else
#define ReadATAPort(ATABaseAddress, Offset, Data)\
{\
    ScsiPortReadRegisterBufferUlong(ATABaseAddress + ((Offset)>>2),&Data,1);\
}
#endif
#ifdef WIN95_ONLY
#define WriteATAPort(ATABaseAddress, Offset, Data)\
{\
    U32   tmp=Data;\
    PU32 pTmp=&tmp;\
	WriteRegisterBufferUlong(ATABaseAddress + ((Offset)>>2), pTmp,1); \
}
#else
#define WriteATAPort(ATABaseAddress, Offset, Data)\
{\
    U32   tmp=Data;\
    PU32 pTmp=&tmp;\
    ScsiPortWriteRegisterBufferUlong(ATABaseAddress + ((Offset)>>2), pTmp,1);\
}
#endif

#ifdef WIN95_ONLY
#define ReadSEQPort(SEQBaseAddress, Offset, Data)\
{\
        ReadRegisterBufferUlong(SEQBaseAddress + ((Offset)>>2),&Data,1); \
}
#else
#define ReadSEQPort(SEQBaseAddress, Offset, Data)\
{\
    ScsiPortReadRegisterBufferUlong(SEQBaseAddress + ((Offset)>>2),&Data,1);\
}
#endif
#ifdef WIN95_ONLY
#define WriteSEQPort(SEQBaseAddress, Offset, Data)\
{\
    U32   tmp=Data;\
    PU32 pTmp=&tmp;\
	WriteRegisterBufferUlong(SEQBaseAddress + ((Offset)>>2), pTmp,1); \
}
#else
#define WriteSEQPort(SEQBaseAddress, Offset, Data)\
{\
    U32   tmp=Data;\
    PU32 pTmp=&tmp;\
    ScsiPortWriteRegisterBufferUlong(SEQBaseAddress + ((Offset)>>2), pTmp,1);\
}
#endif

#define CHIP_CONTROL_OFFSET   (0xc0000)

#ifdef WIN95_ONLY
#define WriteChipControlIndex(XorBaseAddress, CID, IndexReg, Data)\
{\
    U32   tmp=Data;\
    PU32 pTmp=&tmp;\
	WriteRegisterBufferUlong(XorBaseAddress + ((CHIP_CONTROL_OFFSET+ (IndexReg))>>2),pTmp,1); \
}
#else
#define WriteChipControlIndex(XorBaseAddress, CID, IndexReg, Data)\
{\
    U32   tmp=Data;\
    PU32 pTmp=&tmp;\
    ScsiPortWriteRegisterBufferUlong(XorBaseAddress + ((CHIP_CONTROL_OFFSET+ (IndexReg))>>2),pTmp,1);\
}
#endif

#ifdef WIN95_ONLY
#define ReadChipControlIndex(XorBaseAddress, CID, IndexReg, Data)\
{\
        ReadRegisterBufferUlong(XorBaseAddress + (((IndexReg) + CHIP_CONTROL_OFFSET)>>2),&Data,1); \
}
#else
#define ReadChipControlIndex(XorBaseAddress, CID, IndexReg, Data)\
{\
    ScsiPortReadRegisterBufferUlong(XorBaseAddress + (((IndexReg) + CHIP_CONTROL_OFFSET)>>2),&Data,1);\
}
#endif
/*
#define WriteChipControlIndexUshort(XorBaseAddress, CID, IndexReg, Data)\
{\
    ULONG indexOffset = ((CID) * 0x10 + INDEX_REGISTER_OFFSET) >> 2;\
    ULONG DataOffset = ((CID) * 0x10 + DATA_REGISTER_OFFSET) >> 2;\
\
    ScsiPortWritePortUlong(XorBaseAddress + indexOffset + CHIP_CONTROL_OFFSET, IndexReg);\
    ScsiPortWritePortUshort((PUSHORT)(XorBaseAddress + DataOffset) + CHIP_CONTROL_OFFSET, Data);\
}
#define ReadChipControlIndexUshort(XorBaseAddress, CID, IndexReg, Data)\
{\
    ULONG indexOffset = ((CID) * 0x10 + INDEX_REGISTER_OFFSET) >> 2;\
    ULONG DataOffset = ((CID) * 0x10 + DATA_REGISTER_OFFSET) >> 2;\
\
    ScsiPortWritePortUlong(XorBaseAddress + indexOffset + CHIP_CONTROL_OFFSET, IndexReg);\
    Data=ScsiPortReadPortUshort((PUSHORT)(XorBaseAddress + DataOffset) + CHIP_CONTROL_OFFSET);\
}
*/
#ifdef WIN95_ONLY
#define ReadHDMAIndex(HDMABaseAddress, CID, IndexReg, Data)\
{\
        ReadRegisterBufferUlong(HDMABaseAddress + ((0xc0100+(IndexReg))>>2), &Data, 1); \
}
#else
#define ReadHDMAIndex(HDMABaseAddress, CID, IndexReg, Data)\
{\
    ScsiPortReadRegisterBufferUlong(HDMABaseAddress + ((0xc0100+(IndexReg))>>2), &Data, 1);\
}
#endif
/* 3 */
#ifdef WIN95_ONLY
#define WriteHDMAIndex(HDMABaseAddress, CID, IndexReg, Data)\
{\
    U32   tmp=Data;\
    PU32 pTmp=&tmp;\
	WriteRegisterBufferUlong(HDMABaseAddress+((0xc0100+(IndexReg))>>2), pTmp, 1); \
}
#else
#define WriteHDMAIndex(HDMABaseAddress, CID, IndexReg, Data)\
{\
    U32   tmp=Data;\
    PU32 pTmp=&tmp;\
    ScsiPortWriteRegisterBufferUlong(HDMABaseAddress+((0xc0100+(IndexReg))>>2), pTmp, 1);\
}
#endif

#define XOR_OFFSET (0x40 >> 2)
/*2*/
#ifdef WIN95_ONLY
#define ReadXORIndex(XORBaseAddress, Port, IndexReg, Data)\
{\
        ReadRegisterBufferUlong(XORBaseAddress+((0xc0180+(IndexReg))>>2), &Data, 1); \
}
#else
#define ReadXORIndex(XORBaseAddress, Port, IndexReg, Data)\
{\
    ScsiPortReadRegisterBufferUlong(XORBaseAddress+((0xc0180+(IndexReg))>>2), &Data, 1);\
}
#endif
/*4*/
#ifdef WIN95_ONLY
#define WriteXORIndex(XORBaseAddress, CID, IndexReg, Data)\
{\
    U32   tmp=Data;\
    PU32 pTmp=&tmp;\
	WriteRegisterBufferUlong(XORBaseAddress+((0xc0180+(IndexReg))>>2), pTmp, 1); \
}
#else
#define WriteXORIndex(XORBaseAddress, CID, IndexReg, Data)\
{\
    U32   tmp=Data;\
    PU32 pTmp=&tmp;\
    ScsiPortWriteRegisterBufferUlong(XORBaseAddress+((0xc0180+(IndexReg))>>2), pTmp, 1);\
}
#endif
#define ATA_CHANNEL_WAVE_LENGTH    0x80
/*many*/
#ifdef WIN95_ONLY
#define ReadIDEIndex(IDEBaseAddress, Channel, Index, Data)\
{\
        ReadRegisterBufferUlong(IDEBaseAddress+((0xc0200+((Channel)*ATA_CHANNEL_WAVE_LENGTH)+(Index))>>2), &Data, 1); \
}
#else
#define ReadIDEIndex(IDEBaseAddress, Channel, Index, Data)\
{\
    ScsiPortReadRegisterBufferUlong(IDEBaseAddress+((0xc0200+((Channel)*ATA_CHANNEL_WAVE_LENGTH)+(Index))>>2), &Data, 1);\
}
#endif
/*many*/
#define ReadIDEIndexUchar(IDEBaseAddress, Channel, Index, Data)\
{\
    ULONG   lData;\
    ULONG   indexReg=(ULONG)(Index);\
    ULONG   indexOffset=(ULONG)((Channel) * 0x10 + INDEX_REGISTER_OFFSET) >> 2;\
    ULONG   DataOffset=(ULONG) ((Channel) * 0x10 + DATA_REGISTER_OFFSET) >> 2;\
\
    ScsiPortWritePortUlong(IDEBaseAddress + indexOffset, indexReg);\
    lData=ScsiPortReadPortUlong(IDEBaseAddress + DataOffset);\
    Data = (UCHAR)lData;\
}

#define WriteIDEIndex(IDEBaseAddress, Channel, Index, Data)\
{\
    ULONG   indexReg=(ULONG)(Index);\
    ULONG   indexOffset=(ULONG)((Channel) * 0x10 + INDEX_REGISTER_OFFSET) >> 2;\
    ULONG   DataOffset=(ULONG) ((Channel) * 0x10 + DATA_REGISTER_OFFSET) >> 2 ;\
\
    ScsiPortWritePortUlong(IDEBaseAddress + indexOffset, indexReg);\
    ScsiPortWritePortUlong(IDEBaseAddress + DataOffset, Data);\
}



#endif /* mem copy */

#endif /* NT */



#ifdef __FreeBSD__

#ifndef bit
	#define bit(x) (x<<1)
#endif

#define ReadIDEIndex(ATABaseAddress,Channel,Index,Data) {U32 indexReg=(U32)(Index); U32 indexOffset=((Channel)*0x10+INDEX_REGISTER_OFFSET); U32 DataOffset=((Channel)*0x10+DATA_REGISTER_OFFSET); outl((ATABaseAddress+indexOffset),indexReg); Data=inl(ATABaseAddress+DataOffset);}

#define WriteIDEIndex(ATABaseAddress,Channel,Index,Data) {U32 indexReg=(U32)(Index); U32 indexOffset=((Channel)*0x10+INDEX_REGISTER_OFFSET); U32 DataOffset=((Channel)*0x10+DATA_REGISTER_OFFSET); outl((ATABaseAddress+indexOffset),indexReg); outl(ATABaseAddress+DataOffset,Data);}

#define ReadATAPort(ATABaseAddress, Offset, Data) { U32 lOffset=Offset<<2; Data = inl(ATABaseAddress + lOffset); }

#define WriteATAPort(ATABaseAddress, Offset, Data) { U32 lOffset=Offset<<2; outl(ATABaseAddress + lOffset,Data); }

#define ReadSEQPort(SEQBaseAddress, Offset, Data) { U32 lOffset=Offset<<2; Data = inl(SEQBaseAddress + lOffset); }

#define WriteSEQPort(SEQBaseAddress, Offset, Data) { U32 lOffset=Offset<<2;  outl(SEQBaseAddress + lOffset,Data); }

#define CHIP_CONTROL_OFFSET   (0x80 >> 2)

#define ReadHDMAIndex(HDMABaseAddress, CID, IndexReg, Data) {U32 indexOffset = ((CID) * 0x10 + INDEX_REGISTER_OFFSET) ; U32 DataOffset = ((CID) * 0x10 + DATA_REGISTER_OFFSET) ;outl(HDMABaseAddress + indexOffset,IndexReg);Data =inl(HDMABaseAddress + DataOffset);}

#define WriteHDMAIndex(HDMABaseAddress, CID, IndexReg, Data){U32 indexOffset = ((CID) * 0x10 + INDEX_REGISTER_OFFSET) ;U32 DataOffset = ((CID) * 0x10 + DATA_REGISTER_OFFSET) ;outl(HDMABaseAddress + indexOffset,IndexReg);outl(HDMABaseAddress + DataOffset,Data);}

#define XOR_OFFSET 0x40

#define ReadXORIndex(XORBaseAddress, Port, IndexReg, Data) {U32 indexOffset = ((Port) * 0x10 + INDEX_REGISTER_OFFSET) ; U32 DataOffset = ((Port) * 0x10 + DATA_REGISTER_OFFSET) ;outl(XORBaseAddress + indexOffset + XOR_OFFSET,IndexReg);Data = inl(XORBaseAddress + DataOffset + XOR_OFFSET);}

#define WriteXORIndex(XORBaseAddress, CID, IndexReg, Data) {U32 indexOffset = ((CID) * 0x10 + INDEX_REGISTER_OFFSET) ;U32 DataOffset = ((CID) * 0x10 + DATA_REGISTER_OFFSET) ;outl(XORBaseAddress + indexOffset + XOR_OFFSET,IndexReg);outl(XORBaseAddress + DataOffset + XOR_OFFSET,Data);}

extern void ReadIDEIndexUshort(unsigned int,unsigned char,unsigned char,unsigned short *);
extern void ReadIDEIndexUchar(unsigned int,unsigned char,unsigned char,unsigned char *);
extern void WriteIDEIndexUchar(unsigned int,unsigned char,unsigned char,unsigned char);
extern U32 ScsiPortReadPortUlong(U32 dest);
extern void ScsiPortReadRegisterBufferUchar(PUCHAR Dest,PUCHAR Source,U32 sizet);
extern void ScsiPortWriteRegisterBufferUchar(PUCHAR Dest,PUCHAR Source,U32 sizet);
extern void WriteChipControlIndex(U32 XorBaseAddress,U32 CID, U32 IndexReg,U32 Data);
extern void ReadChipControlIndex(U32 XorBaseAddress,U32 CID, U32 IndexReg,PU32 Data);

#endif /* __FreeBSD__ */


#ifdef netware
#include "cam_con.h"

#ifndef  _MMMAP_

#define CHIP_CONTROL_OFFSET   0x80 
#define XOR_OFFSET 0x40 

/*--------------Offset ULONG-------------------------------------------*/
#define ReadATAPort(ATABaseAddress, Offset, Data)\
{\
	Data = In32(NULL, (SHORT*)((LONG)ATABaseAddress + (Offset<<2))); \
}

#define WriteATAPort(ATABaseAddress, Offset, Data)\
{\
    Out32(NULL, (SHORT*) ((LONG)ATABaseAddress+(Offset<<2)), Data);\
}

/*------------@@ offset is  the count of ULONG----------------------------------------------*/
#define ReadSEQPort(SEQBaseAddress, Offset, Data)\
{\
   Data = In32(NULL, (SHORT*)((LONG)SEQBaseAddress + (Offset<<2)));\
}

#define WriteSEQPort(SEQBaseAddress, Offset, Data);\
{\
    Out32(NULL, (SHORT*) ((LONG)SEQBaseAddress+(Offset<<2)), Data);\
}

/*---------------@@ BYTE-------------------------------------------*/
#define ReadChipControlIndex(XorBaseAddress, CID, IndexReg, Data)\
{\
    ULONG indexOffset = (CID) * 0x10 + INDEX_REGISTER_OFFSET ;\
    ULONG DataOffset = (CID) * 0x10 + DATA_REGISTER_OFFSET;\
\
   Out32(NULL, (SHORT*) ((LONG)XorBaseAddress + indexOffset + CHIP_CONTROL_OFFSET), IndexReg);\
   Data=In32(NULL, (SHORT*) ((LONG)XorBaseAddress + DataOffset + CHIP_CONTROL_OFFSET));\
}


#define WriteChipControlIndex(XorBaseAddress, CID, IndexReg, Data)\
{\
    ULONG indexOffset = (CID) * 0x10 + INDEX_REGISTER_OFFSET ;\
    ULONG DataOffset = (CID) * 0x10 + DATA_REGISTER_OFFSET ;\
\
    Out32(NULL, (SHORT*) ((LONG)XorBaseAddress + indexOffset + CHIP_CONTROL_OFFSET), IndexReg);\
    Out32(NULL, (SHORT*) ((LONG)XorBaseAddress + DataOffset + CHIP_CONTROL_OFFSET), Data);\
}
/*----------------IndexReg BYTE------------------------------------------*/
#define WriteChipControlIndexUshort(XorBaseAddress, CID, IndexReg, Data)\
{\
    ULONG indexOffset = (CID) * 0x10 + INDEX_REGISTER_OFFSET;\
    ULONG DataOffset = (CID) * 0x10 + DATA_REGISTER_OFFSET;\
\
    Out32(NULL, (SHORT*)((LONG)XorBaseAddress + indexOffset + CHIP_CONTROL_OFFSET), IndexReg);\
    Out16(NULL, (SHORT*)((LONG)XorBaseAddress + DataOffset + CHIP_CONTROL_OFFSET), Data);\
}

#define ReadChipControlIndexUshort(XorBaseAddress, CID, IndexReg, Data)\
{\
    ULONG indexOffset = (CID) * 0x10 + INDEX_REGISTER_OFFSET;\
    ULONG DataOffset = (CID) * 0x10 + DATA_REGISTER_OFFSET;\
\
    Out32(NULL, (SHORT*) ((LONG)XorBaseAddress + indexOffset + CHIP_CONTROL_OFFSET), IndexReg);\
    Data=In16(NULL, (SHORT*)((LONG)XorBaseAddress + DataOffset + CHIP_CONTROL_OFFSET));\
}


/*-------------IndexReg BYTE-----------------------------------------------*/
#define ReadHDMAIndex(HDMABaseAddress, CID, IndexReg, Data)\
{\
    ULONG indexOffset = (CID) * 0x10 + INDEX_REGISTER_OFFSET;\
    ULONG DataOffset = (CID) * 0x10 + DATA_REGISTER_OFFSET;\
\
    Out32(NULL, (SHORT*) ((LONG)HDMABaseAddress + indexOffset), IndexReg);\
    Data = In32(NULL, (SHORT*) ((LONG)HDMABaseAddress + DataOffset));\
}

#define WriteHDMAIndex(HDMABaseAddress, CID, IndexReg, Data)\
{\
    ULONG indexOffset = (CID) * 0x10 + INDEX_REGISTER_OFFSET;\
    ULONG DataOffset = (CID) * 0x10 + DATA_REGISTER_OFFSET;\
\
    Out32(NULL, (SHORT*)((LONG)HDMABaseAddress + indexOffset), IndexReg);\
    Out32(NULL, (SHORT*)((LONG)HDMABaseAddress + DataOffset ), Data);\
}

/*-------------------------------------------------------------*/
#define ReadXORIndex(XORBaseAddress, CID, IndexReg, Data)\
{\
    ULONG indexOffset = (CID) * 0x10 + INDEX_REGISTER_OFFSET;\
    ULONG DataOffset = (CID) * 0x10 + DATA_REGISTER_OFFSET;\
\
    Out32(NULL, (SHORT*)((LONG)XORBaseAddress + indexOffset + XOR_OFFSET), IndexReg);\
    Data = In32(NULL, (SHORT*)((LONG)XORBaseAddress + DataOffset + XOR_OFFSET));\
}

#define WriteXORIndex(XORBaseAddress, CID, IndexReg, Data)\
{\
    ULONG indexOffset = (CID) * 0x10 + INDEX_REGISTER_OFFSET;\
    ULONG DataOffset = (CID) * 0x10 + DATA_REGISTER_OFFSET;\
\
    Out32(NULL, (SHORT*)((LONG)XORBaseAddress + indexOffset + XOR_OFFSET), IndexReg);\
    Out32(NULL, (SHORT*)((LONG)XORBaseAddress + DataOffset + XOR_OFFSET), Data);\
}

/*---------------Index BYTE----------------------------------------------------*/
#define ReadIDEIndex(IDEBaseAddress, Channel, Index, Data)\
{\
    ULONG   indexReg=(ULONG)(Index);\
    ULONG   indexOffset=(ULONG)((Channel) * 0x10 + INDEX_REGISTER_OFFSET);\
    ULONG   DataOffset=(ULONG)((Channel) * 0x10 + DATA_REGISTER_OFFSET);\
\
    Out32(NULL, (SHORT*)((LONG)IDEBaseAddress + indexOffset), indexReg);\
    Data=In32(NULL, (SHORT*)((LONG)IDEBaseAddress + DataOffset));\
}

#define WriteIDEIndex(IDEBaseAddress, Channel, Index, Data)\
{\
    ULONG   indexReg=(ULONG)(Index);\
    ULONG   indexOffset=(ULONG)((Channel) * 0x10 + INDEX_REGISTER_OFFSET) ;\
    ULONG   DataOffset=(ULONG)((Channel) * 0x10 + DATA_REGISTER_OFFSET) ;\
\
    Out32(NULL, (SHORT*)((LONG)IDEBaseAddress + indexOffset), indexReg);\
    Out32(NULL, (SHORT*)((LONG)IDEBaseAddress + DataOffset), Data);\
}
/*-----------------Index BYTE-------------------------------------------------*/

#define ReadIDEIndexUchar(IDEBaseAddress, Channel, Index, Data)\
{\
    ULONG   lData;\
    ULONG   indexReg=(ULONG)(Index);\
    ULONG   indexOffset=(ULONG)((Channel) * 0x10 + INDEX_REGISTER_OFFSET);\
    ULONG   DataOffset=(ULONG) ((Channel) * 0x10 + DATA_REGISTER_OFFSET) ;\
\
    Out32(NULL, (SHORT*)((LONG)IDEBaseAddress + indexOffset), indexReg);\
    lData=In32(NULL, (SHORT*)((LONG)IDEBaseAddress + DataOffset));\
    Data = (UCHAR)lData;\
}

#define WriteIDEIndexUchar(IDEBaseAddress, Channel, Index, Data)\
{\
    ULONG   indexReg=(ULONG)(Index);\
    ULONG   indexOffset=(ULONG)((Channel) * 0x10 + INDEX_REGISTER_OFFSET);\
    ULONG   DataOffset=(ULONG) ((Channel) * 0x10 + DATA_REGISTER_OFFSET);\
\
    Out32(NULL, (SHORT*)((LONG)IDEBaseAddress + indexOffset), indexReg);\
    Out8(NULL, (SHORT*)((LONG)IDEBaseAddress + DataOffset),Data);\
}



#else   /* mem map */

/*-------------Offset: BYTE------------------------------------*/
#define ReadATAPort(MMIOBaseAddress, Offset, Data)\
{\
    CMovB(MMIOBaseAddress + Offset,&Data,4);\
}

#define WriteATAPort(MMIOBaseAddress, Offset, Data)\
{\
    U32   tmp=Data;\
    PU32 pTmp=&tmp;\
    CMovB(pTmp, MMIOBaseAddress + Offset,4);\
}

/*---------------offset BYTE-----------------------------------------------*/
#define ReadSEQPort(MMIOBaseAddress, Offset, Data)\
{\
    CMovB(MMIOBaseAddress + Offset,&Data,4);\
}

#define WriteSEQPort(MMIOBaseAddress, Offset, Data)\
{\
    U32   tmp=Data;\
    PU32 pTmp=&tmp;\
    CMovB(pTmp, MMIOBaseAddress + Offset,4);\
}
/*----------------IndexReg BYTe---------------------------------------------*/

#define CHIP_CONTROL_OFFSET   0xc0000

#define ReadChipControlIndex(MMIOBaseAddress, CID, IndexReg, Data)\
{\
    CMovB(MMIOBaseAddress + IndexReg + CHIP_CONTROL_OFFSET,&Data,4);\
}

#define WriteChipControlIndex(MMIOBaseAddress, CID, IndexReg, Data)\
{\
    U32   tmp=Data;\
    PU32 pTmp=&tmp;\
    CMovB(pTmp,MMIOBaseAddress + IndexReg + CHIP_CONTROL_OFFSET,4);\
}

/*--------------------IndexReg BYTE---------------------------------------*/
#define ReadHDMAIndex(MMIOBaseAddress, CID, IndexReg, Data)\
{\
   CMovB(MMIOBaseAddress + 0xc0100+IndexReg,&Data,4);\
}

#define WriteHDMAIndex(MMIOBaseAddress, CID, IndexReg, Data)\
{\
    U32   tmp=Data;\
    PU32 pTmp=&tmp;\
    CMovB(pTmp,MMIOBaseAddress + 0xc0100+IndexReg,4);\
}
/*--------------------IndexReg BYTE--------------------------------------------*/

#define ReadXORIndex(MMIOBaseAddress, Port, IndexReg, Data)\
{\
    CMovB(MMIOBaseAddress+0xc0180+IndexReg,&Data,4);\
}

#define WriteXORIndex(MMIOBaseAddress, CID, IndexReg, Data)\
{\
    U32   tmp=Data;\
    PU32 pTmp=&tmp;\
    CMovB(pTmp,MMIOBaseAddress+0xc0180+IndexReg,4);\
}

/*------------------------------------------------------------*/
#define ATA_CHANNEL_WAVE_LENGTH    0x80

#define ReadIDEIndex(MMIOBaseAddress, Channel, Index, Data)\
{\
     CMovB(MMIOBaseAddress+0xc0200+(Channel)*ATA_CHANNEL_WAVE_LENGTH+Index,&Data,4);\
}

/*-------------Index IO, not memory map---------------------------------------------*/
#define ReadIDEIndexUchar(IDEBaseAddress, Channel, Index, Data)\
{\
    ULONG   lData;\
    ULONG   indexReg=(ULONG)(Index);\
    ULONG   indexOffset=(ULONG)((Channel) * 0x10 + INDEX_REGISTER_OFFSET);\
    ULONG   DataOffset=(ULONG) ((Channel) * 0x10 + DATA_REGISTER_OFFSET) ;\
\
    Out32(NULL, (SHORT*)((LONG)IDEBaseAddress + indexOffset), indexReg);\
    lData=In32(NULL, (SHORT*)((LONG)IDEBaseAddress + DataOffset));\
    Data = (UCHAR)lData;\
   }

#endif

/*-------------------------------------------------------------------------*/
#define InBuffIDEIndex16(IDEBaseAddress, Channel, Index,buffer,count)\
{\
    ULONG   indexReg=(ULONG)(Index);\
    ULONG   indexOffset=(ULONG)((Channel) * 0x10 + INDEX_REGISTER_OFFSET);\
    ULONG   DataOffset=(ULONG)((Channel) * 0x10 + DATA_REGISTER_OFFSET);\
\
    Out32(NULL, (SHORT*)((LONG)IDEBaseAddress + indexOffset), indexReg);\
    InBuff16(buffer, NULL, (SHORT *)((LONG)IDEBaseAddress + DataOffset), 0x100);\
}
/*------------------------------------------------------------------------*/
#define MyReadChipControlIndex(XorBaseAddress, CID, IndexReg, Data)\
{\
    ULONG indexOffset = (CID) * 0x10 + INDEX_REGISTER_OFFSET ;\
    ULONG DataOffset = (CID) * 0x10 + DATA_REGISTER_OFFSET;\
\
   Out32(NULL, (SHORT*) ((LONG)XorBaseAddress + indexOffset + CHIP_CONTROL_OFFSET), IndexReg);\
   Data=In32(NULL, (SHORT*) ((LONG)XorBaseAddress + DataOffset + CHIP_CONTROL_OFFSET));\
}
/*----------------------------------------------------------------------*/
#define MyReadSEQPort(SEQBaseAddress, Offset, Data)\
{\
   Data = In32(NULL, (SHORT*)((LONG)SEQBaseAddress + (Offset<<2))); \
}

/*-----------------------------------------------------------------*/
#define MyWriteIDEIndexUchar(IDEBaseAddress, Channel, Index, Data)\
{\
    ULONG   indexReg=(ULONG)(Index);\
    ULONG   indexOffset=(ULONG)((Channel) * 0x10 + INDEX_REGISTER_OFFSET);\
    ULONG   DataOffset=(ULONG) ((Channel) * 0x10 + DATA_REGISTER_OFFSET);\
\
    Out32(NULL, (SHORT*)((LONG)IDEBaseAddress + indexOffset), indexReg);\
    Out8(NULL, (SHORT*)((LONG)IDEBaseAddress + DataOffset),Data);\
}

#endif

#define sata_deviceid_read(adapter, deviceid)	sata_enclosure_read_byte((deviceid << 5),adapter )

#define sata_connect_second_bus(adapter, deviceid)	sata_enclosure_control_simple(adapter,(deviceid << 5) | 2)

#define sata_disconnect_second_bus(adapter, deviceid) sata_enclosure_control_simple(adapter,(deviceid << 5) |4)

#define sata_rled_write(adapter, deviceid)	sata_enclosure_control_simple(adapter,(deviceid << 5) | 6)

#define sata_gled_write(adapter,deviceid)	sata_enclosure_control_simple(adapter,(deviceid << 5) | 8)

#define sata_oled_write(adapter,deviceid)	sata_enclosure_control_simple(adapter,(deviceid << 5) | 0xa)

#define sata_yled_on_write(adapter, deviceid)	sata_enclosure_control_simple(adapter,(deviceid << 5) | 0xc)

#define sata_yled_off_write(adapter, deviceid)	sata_enclosure_control_simple(adapter,(deviceid << 5) | 0xe)

#define sata_chip_control_write(adapter, deviceid, controlbyte)	sata_enclosure_write_byte((deviceid << 5) | 0x12,adapter, controlbyte)

#define sata_chip_control_read(adapter, deviceid)	sata_enclosure_read_byte((deviceid << 5) | 0x12,adapter)

#define sata_pwm_offset_write(adapter, deviceid)	sata_enclosure_write_byte((deviceid << 5) | 0x14,adapter, 5)

#define sata_global_led_write(adapter, deviceid)	sata_enclosure_write_byte((deviceid << 5) | 0x16,adapter, 0x10)

#define sata_oled_off_write( adapter,  deviceid)	sata_enclosure_control_simple(adapter,(deviceid << 5) | 0x18)

#endif
