/***************************************************************************
 *
 * Copyright (c) 1995 Promise Technology, Inc.  All rights reserved.
 * No part of this document may be reproduced or transmitted in any form or
 * by any means, electronic or mechanical, for any purpose, without the
 * express written permission of Promise Technology, Inc.
 *
 *
 * ata-3.h - contains ata-3 interface definition and mappings
 *
 ***************************************************************************/


/*
 * ATA Access limitation
 */

#define MAX_DISK_ACCESS_SIZE            0x80    /* in sectors */

#define IDE_COMMAND_SMART				0xb0

/*
 * ATA access opcode
 */

#define ataREAD                         0x20
#define ataREAD_VERIFY                  0x40
#define ataSEEK                         0x70
#define ataWRITE                        0x30
#define ataWRITE_VERIFY                 0x3C
#define ataREAD_LONG					0x22
#define ataWRITE_LONG					0x32
#define ataSTANDBY_IMMEDIATE            0xE0
#define ataIDLE_IMMEDIATE               0xE1
#define ataFLUSH_CACHE                  0xE7
#define ataIDENTIFY_DEVICE              0xEC

#define ataSET_LED						0xf0
#define MODEL_NAME_OFFSET               54


/*
 * bStatus in DTASK
 */
#define tsPRD_TOO_SMALL                 0x00
#define tsDMA_ENGINE_STUCK              0x01
#define tsXFER_ERROR                    0x02
#define tsNO_ERROR                      0x04
#define tsPRD_TOO_LARGE                 0x05
#define tsTIMED_OUT                     0x80    /* bit0~2 from chip status */
#define tsFORCE_RETRY_TASK              0xFD
#define tsFORCE_RETRY_REQ               0xFE
#define tsSELECTION_TIMEOUT             0xFF
#define tsBUS_MASTER_STATUS_MASK        0x07


/*
 * DTASK.ata_reg.cmd.bStstaus ATA Status Register Values
 */
#define ataADDITIONAL_ERROR             0x01    /* bit 7 == 0, ERR */
#define ataCORRECTED_DATA               0x04    /* bit 7 == 0, CORR */
#define ataDATA_REQUEST                 0x08    /* bit 7 == 0 */
#define ataSEEK_COMPLETE                0x10    /* BIT4 */
#define ataDEVICE_WRITE_FAULT           0x20    /* bit 7 == 0 */
#define ataDRIVE_READY                  0x40    /* bit 7,5,3,2,0 == 0, DRDY */
#define ataDRIVE_BUSY                   0x80    /* BSY */
#define ataDRIVE_READY_MASK             0xED    /* bit 4,1 = don't care */

#define ataTASK_LOST                    0xFC
#define ataTASK_NOT_COMPLETED           0xFD
#define ataTASK_NOT_SUBMITTED           0xFE    /* raid engine use */

/*
 * DTASK.ata_reg.cmd.bFeature ATA Status Register Values
 */
#define ataBAD_BLOCK                    bit(7)  /* BBK */
#define ataUNCORRECTABLE_DATA_ERROR     bit(6)  /* UNC */
#define ataSECTOR_ID_NOT_FOUND          bit(4)  /* IDNF */
#define ataCOMMAND_ABORTED              bit(2)  /* ABRT */
#define ataTRACK_0_NOT_FOUND            bit(1)  /* TKNOF */
#define ataADDRESS_MARK_NOT_FOUND       bit(0)  /* AMNF */

