
/***************************************************************************
 *
 * Copyright (c) 1995 Promise Technology, Inc.  All rights reserved.
 * No part of this document may be reproduced or transmitted in any form or
 * by any means, electronic or mechanical, for any purpose, without the
 * express written permission of Promise Technology, Inc.
 *
 *
 * code.h - defines error codes and flag bits and stage 
 *     11/03/97  Q.W   revised chores control flag
 ***************************************************************************/
//Label_bp begin
#include "oem.h"
//Label_bp end
#define  EVENT_LEVEL_ERROR			   0x00	 
#define  EVENT_LEVEL_WARNING		   0x01
#define  EVENT_LEVEL_INFORMATION	   0x02


#define FLAG_REBUILD_START                        (0x040000001)
#define FLAG_CHECKINTEGRITY_START                 (0x050000001)

#define FLAG_ERROR                          (0x80000000l)
#define FLAG_E_UNKNOWN						(0x80000000l)
#define FLAG_E_BUSY                         (0x80000001l)
#define FLAG_E_MEMFULL                      (0x80000002l)
#define FLAG_E_RESFULL                      (0x80000003l)
#define FLAG_E_ECC                          (0x80000004l)
#define FLAG_E_USER                         (0x80001000l)
#define FLAG_E_NOTINTEGRITY                     (FLAG_E_USER)
#define FLAG_E_DISK_SETDOWN              (0x80000100)
#define FLAG_E_DISK_PLUGIN               (0x80000101)
#define FLAG_E_RESERVED_SECTOR_ERROR     (0x80000102)
#define FLAG_E_DISK_OFFLINE				 (0x80000103)	
#define FLAG_E_BADSECTOR				 (0x80000104)
#define FLAG_E_DISK_RETRY				 (0x80000105) 	
#define FLAG_E_REBUILD_COMPLETE			 (0x80000200)
#define FLAG_E_SYNC_COMPLETE			 (0x80000201)
#define FLAG_E_REBUILD_ABORT             (0x80000202)
#define FLAG_E_SYNC_ABORT                (0x80000203)
#define FLAG_E_RETRY_TASK	             (0x80000204)
#define FLAG_E_ARRAY_DOWN                (0x80000205)
#define FLAG_E_ARRAY_DEGRADE             (0x80000206)
#define FLAG_E_DISK_ERROR				 (0x80000207)
#define FLAG_E_SYNC_COMP_ERROR			 (0x80000208)
#define FLAG_E_SMART_ERROR				 (0x80000209)	
#define FLAG_E_ECC_FIX_FAIL				 (0x8000020a)
/* OEM Swap Box - GigaByte */
#define FLAG_E_SWAP_POWERDOWN			 (0x8000020b)
#define FLAG_E_SWAP_POWERUP				 (0x8000020c)
/* power up, but no drive */
#define FLAG_E_SWAP_BADSWAP              (0x8000020d)

#define FLAG_E_CREATE_ARRAY              (0x80000213)

#define FLAG_E_DELETE_ARRAY              (0x80000214)

/*<< swap box error codes for temp, fan, voltage - RamN 09/30/00*/
#define FLAG_E_SWAP_OVER_TEMP			 (0x8000020e)
#define FLAG_E_SWAP_FAN_STOP			 (0x8000020f)
#define FLAG_E_SWAP_12V_OUTOFRANGE		 (0x80000210)
#define FLAG_E_SWAP_5V_OUTOFRANGE		 (0x80000211)

#define FLAG_E_ADDR_MARK_NOT_FOUND       (0x80000301)
#define FLAG_E_TRACK_0_NOT_FOUND         (0x80000302) 
#define FLAG_E_ABORT_COMMAND             (0x80000303) 
#define FLAG_E_ID_NOT_FOUND              (0x80000304) 
#define FLAG_E_CRC_ERROR                 (0x80000305) 


#define  blLogExist					bit(0)	

#define  blREBUILD					0
#define  blSYNC						1
#define	 blOTHER_DISK_ACCESS		2

#define NO_SMART					0
#define SMART_OK					1
#define SMART_ERROR					2
#define NOSUPPORT_SMART				3

/*
 * Firmware Initialization Mode
 */
#define bPOWER_UP                       0x00
#define bHARD_RESET                     0x01
  #define bNO_RESET_NEEDED              0x00
  #define bRESET_SUCCESSFUL             0x00
  #define bRESET_FAILED                 0x01
#define bSOFT_RESET                     0x02


/*
 * RAID Engine initialization return code
 */
#define bINIT_SUCCESSFUL                0x00
#define bNEED_MORE_MEMORY               0x01


/*
 * Channel related stuff
 */
#define bALL_CHANNELS                   0xFF


/*
 * config write reserved sector related stuff
 */
#define bMARKED_ARY                     0x00
#define bALL_BLK_AND_ARY                0x01


/*
 * types of queue entry
 */
#define RESOURCE_FREE_POOL_COUNT        0x0d

#define SMALL_SCRATCH_BUFFER            0x00    /* releasable by STATUS_SEQ */
#define BIG_SCRATCH_BUFFER              0x01    /* releasable by STATUS_SEQ */
#define DISK_TASK                       0x02    /* releasable by STATUS_SEQ */
#define FREE_LOCK                       0x03    /* releasable by STATUS_SEQ */
#define FREE_LOCK1                      0x04    /* releasable by STATUS_SEQ */
#define XOR_BUF                         0x05
#define READ_BUF                        0x06
#define PARITY_BUF                      0x07
#define RECOVER_BUF                     0x08
#define PRD_TBL                         0x09
//added by isaac for dualcard
#define READ_BUF1                       0x0a   
#define PARITY_BUF1                     0x0b
#define RECOVER_BUF1                     0x0c
#define REBUILD_BUF1                     0x0d
//end
#define MAIN_CMD_PACKET                 0x0e
#define EVENT_REQUEST                   0x0f
#define ERRORLOG                        0x10
#define REBUILD_BUF                     0x11
#define REQUEST                         0x12
#define FIRST_DISK_CHANNEL              0x13
#define MAX_QUEUE_SUPPORTED             (FIRST_DISK_CHANNEL+MAX_CHANNEL_SUPPORTED)


#define NVM_FREE_LOCK                   0x0
#define LOCK_TABLE		                0x1                
#define MAX_RAID5_QUEUE_SUPPORTED       (LOCK_TABLE+ACTUAL_ARRAY_SUPPORTED)

/*
 * request error codes
 */
#define recSELECTION_TIMED_OUT          0x0000
#define recNO_ERROR                     0x0001
#define recINVALID_REQUEST              0x0002
#define recINVALID_SUB_REQUEST          0x0003
#define recNOT_READY                    0x0004
#define recHARDWARE_ERROR               0x0005
#define recINVALID_LUN                  0x0006
#define recOUT_OUT_BOUND_ACCESS         0x0007
#define recABORTED_DUE_TO_ERROR         0x0008
#define recENGINE_BUSY                  0x0009
#define recINVALID_PARAMETER            0x000A
#define recMEDIA_ERROR                  0x000B
#define recADDR_MARK_ERROR              0x000C
#define recMAINTENANCE_IN_PROGRESS      0x000D

/*
 * bAdapterStatus copied from NT's srb.h
 */

/*
typedef struct _SCSI_REQUEST_BLOCK {
    USHORT Length;                   offset 0
    UCHAR Function;                  offset 2
    UCHAR SrbStatus;                 offset 3
    UCHAR ScsiStatus;                offset 4
    UCHAR PathId;                    offset 5
    UCHAR TargetId;                  offset 6
    UCHAR Lun;                       offset 7
    UCHAR QueueTag;                  offset 8
    UCHAR QueueAction;               offset 9
    UCHAR CdbLength;                 offset a
    UCHAR SenseInfoBufferLength;     offset b
    ULONG SrbFlags;                  offset c
    ULONG DataTransferLength;        offset 10
    ULONG TimeOutValue;              offset 14
    PVOID DataBuffer;                offset 18
    PVOID SenseInfoBuffer;           offset 1c
    struct _SCSI_REQUEST_BLOCK *NextSrb;  offset 20
    PVOID OriginalRequest;           offset 24
    PVOID SrbExtension;              offset 28
    ULONG QueueSortKey;              offset 2c
    UCHAR Cdb[16];                   offset 30
} SCSI_REQUEST_BLOCK, *PSCSI_REQUEST_BLOCK;

#define SCSI_REQUEST_BLOCK_SIZE sizeof(SCSI_REQUEST_BLOCK)
*/


#define SRB_FUNCTION_EXECUTE_SCSI           0x00
#define SRB_FUNCTION_CLAIM_DEVICE           0x01
#define SRB_FUNCTION_IO_CONTROL             0x02
#define SRB_FUNCTION_RECEIVE_EVENT          0x03
#define SRB_FUNCTION_RELEASE_QUEUE          0x04
#define SRB_FUNCTION_ATTACH_DEVICE          0x05
#define SRB_FUNCTION_RELEASE_DEVICE         0x06
#define SRB_FUNCTION_SHUTDOWN               0x07
#define SRB_FUNCTION_FLUSH                  0x08
#define SRB_FUNCTION_ABORT_COMMAND          0x10
#define SRB_FUNCTION_RELEASE_RECOVERY       0x11
#define SRB_FUNCTION_RESET_BUS              0x12
#define SRB_FUNCTION_RESET_DEVICE           0x13
#define SRB_FUNCTION_TERMINATE_IO           0x14
#define SRB_FUNCTION_FLUSH_QUEUE            0x15
#define SRB_FUNCTION_REMOVE_DEVICE          0x16

#define SRB_STATUS_PENDING                  0x00
#define SRB_STATUS_SUCCESS                  0x01
#define SRB_STATUS_ABORTED                  0x02
#define SRB_STATUS_ABORT_FAILED             0x03
#define SRB_STATUS_ERROR                    0x04
#define SRB_STATUS_BUSY                     0x05
#define SRB_STATUS_INVALID_REQUEST          0x06
#define SRB_STATUS_INVALID_PATH_ID          0x07
#define SRB_STATUS_NO_DEVICE                0x08
#define SRB_STATUS_TIMEOUT                  0x09
#define SRB_STATUS_SELECTION_TIMEOUT        0x0A
#define SRB_STATUS_COMMAND_TIMEOUT          0x0B
#define SRB_STATUS_MESSAGE_REJECTED         0x0D
#define SRB_STATUS_BUS_RESET                0x0E
#define SRB_STATUS_PARITY_ERROR             0x0F
#define SRB_STATUS_REQUEST_SENSE_FAILED     0x10
#define SRB_STATUS_NO_HBA                   0x11
#define SRB_STATUS_DATA_OVERRUN             0x12
#define SRB_STATUS_UNEXPECTED_BUS_FREE      0x13
#define SRB_STATUS_PHASE_SEQUENCE_FAILURE   0x14
#define SRB_STATUS_BAD_SRB_BLOCK_LENGTH     0x15
#define SRB_STATUS_REQUEST_FLUSHED          0x16
#define SRB_STATUS_INVALID_LUN              0x20
#define SRB_STATUS_INVALID_TARGET_ID        0x21
#define SRB_STATUS_BAD_FUNCTION             0x22
#define SRB_STATUS_ERROR_RECOVERY           0x23

#define SRB_STATUS_QUEUE_FROZEN             0x40
#define SRB_STATUS_AUTOSENSE_VALID          0x80

#define SRB_STATUS(Status) (Status & ~(SRB_STATUS_AUTOSENSE_VALID | SRB_STATUS_QUEUE_FROZEN))

#define SRB_FLAGS_QUEUE_ACTION_ENABLE       0x00000002
#define SRB_FLAGS_DISABLE_DISCONNECT        0x00000004
#define SRB_FLAGS_DISABLE_SYNCH_TRANSFER    0x00000008
#define SRB_FLAGS_BYPASS_FROZEN_QUEUE       0x00000010
#define SRB_FLAGS_DISABLE_AUTOSENSE         0x00000020
#define SRB_FLAGS_DATA_IN                   0x00000040
#define SRB_FLAGS_DATA_OUT                  0x00000080
#define SRB_FLAGS_NO_DATA_TRANSFER          0x00000000
#define SRB_FLAGS_UNSPECIFIED_DIRECTION      (SRB_FLAGS_DATA_IN | SRB_FLAGS_DATA_OUT)
#define SRB_FLAGS_NO_QUEUE_FREEZE           0x00000100
#define SRB_FLAGS_ADAPTER_CACHE_ENABLE      0x00000200
#define SRB_FLAGS_IS_ACTIVE                 0x00010000
#define SRB_FLAGS_ALLOCATED_FROM_ZONE       0x00020000
#define SRB_FLAGS_SGLIST_FROM_POOL          0x00040000

#define SRB_SIMPLE_TAG_REQUEST              0x20
#define SRB_HEAD_OF_QUEUE_TAG_REQUEST       0x21
#define SRB_ORDERED_QUEUE_TAG_REQUEST       0x22


/*
 * bAdapterStatus in REQ structure
 */
#define asNO_ERROR                      SRB_STATUS_SUCCESS
#define asSEE_SENSE                     SRB_STATUS_ERROR+SRB_STATUS_AUTOSENSE_VALID
#define asSELECTION_TIMED_OUT           SRB_STATUS_SELECTION_TIMEOUT


/*
 * Firmware Programming Error Codes
 */
#define fpeNO_ERROR                     0x00
#define fpeUNKNOWN_ERROR                0x01
#define fpeILLEGAL_REQUEST              0x03


/*
 * recovery method, in ascending order of seriousness
 */

#define bCONTINUE_REQUEST               0x00
#define bREQUEUE_TASK                   0x01
#define bRETRY_TASK                     0x02
#define bRETRY_REQ                      0x03
#define bMAINTENANCE_ERROR              0x04
#define bRETURN_ERROR_TO_OS             0x05
#define bREPORT_ERROR                   0x06
#define bSKIP_ERROR						0x07

/*
 * type of disk segments
 */

#define bDOWN_BLOCK                     0x00
#define bUP_BLOCK                       0x01
#define bSPARE_OVER                     0x02
#define bDUPLICATE_BLOCK                0x03
#define bSWITCH_STREAM                  0x04
#define bUP_BLOCK1                      0x05
#define bUP_CONV_EXP_BLOCK              0x06
/*
 * chores control flags, in blMyMomSaidI_AmOldEnoughFor and blChoresToDo
 */

#define blDISK_EVENT                    bit(0)  /* on by default */
#define blCONFIG_CYCLE                  bit(1)  /* off by default */
#define blUPDATE_RESERVED_SECTORS       bit(2)  /* off by default */
#define blFIND_HOT_SPARE                bit(3)  /* off by default */
#define blRSVD_SECTOR_CYCLE             bit(4)  /* off by default */
#define blHOT_PLUG                      bit(5)  /*                 11/20/97 Q.W*/
#define blSET_LED                       bit(6)  /* off by default  10/26/97 Q.W    */
#define blMASTER_SLAVE                  bit(7)  /* off by default  10/26/97 Q.W  */

//Label_bp begin
/*
#define LED_OFF			0
#define LED_RED			1
#define LED_GREEN		2
#define LED_ORANGE		3
*/
#ifndef HPQ_BACKPLANE
	#define LED_OFF			0
	#define LED_RED			1
	#define LED_GREEN		2		// during NEC spec, LED_GREEN means driver ready.
	#define LED_ORANGE		3		 // during NEC spec, when rebuild, LED_ORANGE means Red slow blinking, other cases mean LED_OFF
#else
	// Four bit for each LED. // bit(0)-bit(3) for dual while bit(4)-bit(7) for single
	// For the dual color LED
	#define LED_OFF			bit(0)
	#define LED_ORANGE		bit(1)
	#define LED_BLUE		bit(2)		
	// For the single color LED
	#define LED_GREEN		bit(3)
#endif

/* definitions for LED flash */
#ifndef HPQ_BACKPLANE
	#define	FASTFLASH		0x03
	#define	SLOWFLASH		0x02
	#define	NOFLASH			0x00
	#define LED_CHANGE		0x10
#else
	// Based on the current pEnclosure data structure, 
	// I have to use One byte to contain flash information for both single color and dual color LED.
	// bit(7) for LED_CHANGE, bit(0)-bit(2) for dual color, bit(4)-bit(6) for single color
	#define	FASTFLASH		bit(2)
	#define	SLOWFLASH		bit(1)
	#define	NOFLASH			bit(0)

	#define LED_CHANGE		bit(7)
#endif
//Label_bp end

/*
 * maintenance control flags, in blBackgroundMaintenance
 */

#define blMAINTENANCE_WHEN_IDEL         bit(0)
#define blWAIT_IDLE                     bit(1)    /*  11/21/97  Q.W  */

/*
 * event manager events and time intervals
 */

#define bRECONSTRUCT_STREAM             0x00
#define bDUPLICATE_STREAM               0x01
#define bCHECK_INTEGRITY                0x02
#define bCHECK_PLUG                     0x03   /* 11/20/97  Q.W */     
#define bREBUILD                        0x04
#define bCONVEXP_RAID                   0x05
#define bSEC_TICK                       0x06
#define bINIT_CONFIG                    0x07
#define bWRITE_CONFIG                   0x11
#define bRECOVER						0x08
#define bCHANNELRESETDONE				0x09
#define bCLEARDISK_RAID5				0x0a
#define bPBM_REQTIMEDOUT                0x0b


#define hMANUAL_THROTTLE                0x0000
#define hAS_SOON_AS_POSSIBLE            0x0001  /* in number of 55msec ticks */
#define hWHENEVER_IDLE                  0xFFFF
#define hSINGLE_SECOND                  18    
#define hSINGLE_MINUTE                  1091

/*
 * different ways to use p_rqGenerateREQ()
 */

#define bUSE_THEN_DISCARD               0
#define bRECURSIVE_MAINTENANCE          1

/*
 * channel timer related...
 */

#define MSEC_PER_TICK                   128
#define TICK_PER_SEC                    8
#define TICK_INIT						0	

/*
 * blFlag bits
 */
#define blDISPLAY_DEBUG_MSG             bit(0)


/*
 * misc
 */
#define COPYRIGHT_STRING_SIZE           0x50
#define COMPANY_NAME_OFFSET             0x14


#define encGET_BOX_ID                           0x00
#define encUNKNOWN_BOX                        0xFFFFFFFF
#define encFW66                               0x00000001
#define encSW66                               0x00000011
/*#define encFW100                              0x00000002*/
/*#define encSW100                              0x00000012*/
#define encGBOEM							  0x00000010
#define encUNIVERSAL                          0x00000000

/* capability bits for enclosure */

#define encGET_CAPABILITY					  0x05
#define enc_HAS_VOLTAGE						  0x04
#define enc_HAS_FAN_TEMP					  0x08
#define enc_HAS_KEY							  0x40

#define encGET_FAN_STATUS                       0x01
#define encUNKNOWN_FAN                        0xFFFFFFFF
  /* return value in RPM */

#define encGET_TEMP_STATUS                      0x02
#define encUNKNOWN_TEMP                       0xFFFFFFFF
  /* return value in degree C */

#define encGET_POWER_5V_STATUS                  0x03
#define encUNKNOWN_POWER                      0xFFFFFFFF
  /* return value in mV */

#define encGET_POWER_12V_STATUS                 0x04

#define enc_TURN_OFF_POWER						0x06
#define enc_TURN_ON_POWER						0x07
#define encGET_POWER_ONOFF_STATUS				0x08


/*
	Added by crimson. 11/13, Y2001
	For start_conversion_expansion return value.		
*/
#define CONVERSION_EXPANSION_OK   				0x00000000
#define TARGETSIZE_TOOSMALL       				0x80000001
#define SAME_ARRAY_ERROR          				0x80000002
#define ARRAY_NOT_VALID	       					0x80000003
#define DISK_NOT_VALID		 					0x80000004

/*
        Added by isaac. 11/24, Y2002
	For Maintance event Flags
*/
#define REBUILD_IN_PROGRESS                  0x01
#define SYNCHRONIZATION_IN_PROGRESS          0x02
#define CONVEXP_IN_PROGRESS                  0x04
#define RAID5_INITIALIZATION_IN_PROGRESS     0x08
#define REBUILD_STOP                         0x10
#define SYNCHRONIZATION_STOP                 0x20
#define CONVEXP_STOP                         0x40
#define RAID5_INITIALIZATION_STOP            0x80        

