/***************************************************************************
 *
 * Copyright (c) 1995 Promise Technology, Inc.  All rights reserved.
 * No part of this document may be reproduced or transmitted in any form or
 * by any means, electronic or mechanical, for any purpose, without the
 * express written permission of Promise Technology, Inc.
 *
 *
 * constant.h - defines standard typedefs and other useful constants
 *
 ***************************************************************************/

#include "debug.h"

#undef I2O

#ifdef BIOS
  #define app_space __far
  #define buf_space __near
  #define dat_space __near
  #define str_space __far

  #define MAX_CONCURRENT_THREAD         1

  #define _call __cdecl
#endif

#ifdef NT
  #define app_space
  #define buf_space
  #define dat_space
  #define str_space

/* Added by crimson. 10/26, Y2001*/
  #ifdef WIN95_ONLY
    #define MAX_CONCURRENT_THREAD         2/*==it was 8*/  /* modified by Jeff  2001/11/16 */
  #else 
  	#define MAX_CONCURRENT_THREAD         33 /*==it was 8*/
	#define MIN_CONCURRENT_THREAD		  4
  #endif
  #define _call
#endif

#ifdef __LINUX__
  #define app_space
  #define buf_space
  #define dat_space
  #define str_space

  #define MAX_CONCURRENT_THREAD        24  //modified by isaac for dualcard 
  #define MIN_CONCURRENT_THREAD        1   //added by isaac for dualcard
  #define _call
#endif

#ifdef __FreeBSD__
  #define app_space
  #define buf_space
  #define dat_space
  #define str_space

  #define MAX_CONCURRENT_THREAD        2 

  #define _call
#endif

#ifdef OS2
  #define app_space __far
  #define buf_space __near
  #define dat_space __near
  #define str_space __far

  #define MAX_CONCURRENT_THREAD         16

  #define _call __cdecl
#endif

#ifdef Netware
  #define app_space 
  #define buf_space 
  #define dat_space 
  #define str_space 

  #define MAX_CONCURRENT_THREAD         16

  #define _call __cdecl
#endif

#ifdef OS2_MSC                                  /* for jenny's OS/2 compiler */
  #define app_space far
  #define buf_space near
  #define dat_space near
  #define str_space far

  #define MAX_CONCURRENT_THREAD         16

  #define _call __cdecl
#endif
      
typedef unsigned char   ByTE;
typedef unsigned short  HALF;
typedef unsigned long   WORD;
typedef unsigned char   BoOL;

#ifndef U8
typedef unsigned char   U8;
#endif
typedef unsigned short  U16;
typedef unsigned long   U32;

/* 
	Added by crimson. 10/23, Y2001
*/
typedef U8 *	PU8;
typedef U16 *  	PU16;
typedef U32 * PU32;


typedef unsigned char  app_space *apBUF;
typedef unsigned short app_space *aphBUF;
typedef unsigned long  app_space *apwBUF;
typedef unsigned char  app_space *apBoOL;

typedef unsigned char  buf_space *bpBUF;
typedef unsigned short buf_space *bphBUF;
typedef unsigned long  buf_space *bpwBUF;
typedef unsigned char  buf_space *bpBoOL;

typedef unsigned char  dat_space *dpBUF;
typedef unsigned short dat_space *dphBUF;
typedef unsigned long  dat_space *dpwBUF;
typedef unsigned char  dat_space *dpBoOL;

typedef unsigned char  str_space *spBUF;
typedef unsigned short str_space *sphBUF;
typedef unsigned long  str_space *spwBUF;
typedef unsigned char  str_space *spBoOL;



#define kNULL				0

#define TRUE				1
#define ON				1
#define SET				1
#define YES				1
#define OK				1
//#define GOOD				1

#define FALSE				0
#define OFF				0
#define CLEAR				0
#define NO				0
#define SHIT				0
#define BAD				0

#define bit(x)  (1 << x)
#define bits(x) ((1 << (x + 1)) - 1)

#define Max(x,y) (((x) > (y)) ? (x) : (y))
#define Min(x,y) (((x) < (y)) ? (x) : (y))

