/***************************************************************************
 *
 * Copyright (c) 1995 Promise Technology, Inc.  All rights reserved.
 * No part of this document may be reproduced or transmitted in any form or
 * by any means, electronic or mechanical, for any purpose, without the
 * express written permission of Promise Technology, Inc.
 *
 *
 * export.h - function prototypes
 *     S.Zhu      07/21/97     Check integrity for NT
 *
 *
 ***************************************************************************/


/*
 * arequest.c
 */

extern void CheckIntegrity(bpREQ p_rq);
extern void ForceDiskDown(bpREQ p_rq);
extern void ForceDiskSpare(bpREQ p_rq);
extern void ForceDiskUp(bpREQ p_rq);
extern void HeartBeat(bpREQ p_rq);
extern void ManualThrottle(bpREQ p_rq);
extern void ReadPhysical(bpREQ p_rq);
extern void RebuildDisk(bpREQ p_rq);
extern void ReportDevice(bpREQ p_rq);
extern void SaveConfig(bpREQ p_rq);
extern void ScanConfig(bpREQ p_rq);
extern void SyncRedundancy(bpREQ p_rq);
extern void WritePhysical(bpREQ p_rq);

extern bpSEQ p_sqInsertWriteConfigSeq(bpREQ p_rq);


/*
 * chores.c
 */

extern BoOL blGetSomebodyElseToDoIt(bpREQ p_rq);
extern void SetErrorEvent(WORD WarningLevel,bpERLOG p_erlog,WORD id);
extern bpSEQ GetXorData(bpREADMAP p_readmap, bpREQ p_rq,bpSEQ p_sq,U32 wLBA,U16 hSize,U8 bxorline,bpPRD p_prd);
extern BoOL blXORReadprd(bpSEQ p_sq);
extern void SetErrorEvent(U32 WarningLevel,bpERLOG p_erlog,U32 id);
extern void blCheckIfNeedSyncRAID5(void);
extern void ReSG_ToPRD(bpREADMAP p_readmap,bpSECT p_st,U16 hSize);
extern U16 getStripeSize(U8 arrayID);
extern U16 getStripeBlockSize(U8 arrayID);
extern U8 getRaidMode(U8 arrayID);
extern U32 getLastLBA(U8 arrayID);
extern U32 getArrayIdFromDeviceId(U32 DeviceId);

/*
 * config.c
 */

extern BoOL blDiskPresentHere(bpEVENT p_ev);

/*extern void InitRAID_EngineData(WORD wSize);*/
extern void InitRAID_EngineData(WORD wVirSize, WORD wPhySize);
extern void InitConfigData(void);
extern dpSTRM p_smMirrorStream(dpARY p_ary, ByTE  bStrm);
/*extern void SetARY_Status(void);*/
extern void InitRsvdSector(bpDISK p_dsk,ByTE bCh,ByTE bID);
extern void TranslateArrayToLUN(dpARY p_ary,bpLUN p_lun);
extern void TranslateBlock(dpBLOCK p_mem,bpBLOCK p_disk);
extern ByTE bFindAssociatedArray(ByTE bIndex);                  
extern ByTE bFindAssociatedBlock(ByTE bIndex,ByTE bCh,ByTE bID);
extern void SetMappingMode(void);
extern BoOL blReadReservedSector (dpBLOCK p_blk, apBUF p_buf, ByTE bOffset, HALF hSize);
extern BoOL blWriteReservedSector(dpBLOCK p_blk, apBUF p_buf, ByTE bOffset, HALF hSize);
extern bpSEQ p_sqInsertWriteReservedSectorSeq(bpREQ p_rq, bpEVENT p_ev, bpSEQ p_sq, bpSEQ p_sqSave);

extern void SetARY_Status(U8 bConv_exp);
/*
 * crequest.c
 */

extern void Ping(bpREQ p_rq);
extern void Deactivate(bpREQ p_rq);
extern BoOL StartRebuild(ByTE aryID,ByTE bCh,ByTE bID);
extern BoOL StartCheckIntegrity(ByTE aryID);

extern WORD GetEventCount(void);
extern void ReadEventLog(dpwBUF p, WORD EventCount);
extern WORD GetEnclosureStatus(ByTE bSubCmd, ByTE bCh, ByTE bID, ByTE bFanIndex);


// Added by crimson. 11/19 
extern BoOL blRenameArray(U8 arrayID, U8 *ArrayName);
extern void StopRebuild_Conversion(U8 arrayID);
extern  U32 GetOriginalChannelCount(void);
extern  void SetOriginalChannelCount(U32 Value);
extern U32 GetChannelCountThreshold(void);
extern  void SetChannelCountThreshold(U32 Threshold);
extern  void ClearLogEvent(void);
extern  U8 GetHotSwapStaus(void);
extern  void SetHotSwapStaus(U8 Value);
extern  U8  GetPecentageForConversion_Expansion(U8 ArrayID);
extern U16 GetRebuildRate(void);
extern BoOL SetRebuildRate(U8 Value);
extern U16 GetSyncRate(void);
extern BoOL SetSyncRate(U8 Value);
extern U16 GetExpConvRate(void);
extern BoOL SetExpConvRate(U8 Value);
extern void SetHotSpareStaus(U8 Value);
extern U8  GetHotSpareStaus(void);
extern U8 GetTotalDiskNumber(void);
extern U8 GetArrayNumber(void);
extern U32 GetDiskSize(U8 DiskID);
extern U32 GetDiskStatus(U8 DiskID);
extern BoOL DeleteArray(U8 ArrayID);
extern BoOL CreateArray(U8 *ArrayName,U8* idDisk,U32 dwRAID,U8 bNumOfDisk,U32 dwStripeBlockSize,U32 *ArrayID); //modified by isaac for createarray
extern U8 GetDiskNumofArray(U8 ArrayID,U8 *DiskID);
extern U32 GetArrayStatus(U8 ArrayID);
extern U16 GetArrayStripeBlockSize(U8 ArrayID);
extern U32 GetArraySize(U8 ArrayID);
extern U8 GetArrayMode(U8 ArrayID);
extern void InitRAID5Disk(dpARY p_ary);

/*added by Jeff 2001/09/05*/
/* Modified by crimson. 11/13, Y2001 */
/* extern BoOL StartConversion_Expansion(ByTE idArray,*/
extern U32 StartConversion_Expansion(ByTE idArray,
                               U8 NewRaidMode,
                               U8 NewRaidDiskNum,
                               U8 *bDiskID,
                               U8 ConverSectorSize);
                               
/*
	Added by crimson. 11/22, Y2001 
*/
extern void bOEMSwapBoxPowerOnOffDone(U8 Type, U8 bCh, U8 ID);

/* fanru modified 2001-11-22*/
extern void bOEMSwapBoxGetPowerStatusDone(U8 Type, U8 bCh, U8 ID,U8 bOnOff);



/*
 * disk.c
 */
extern void GenRAID5TaskDirectlyFromMap(bpSEQ p_sq,dpARY p_ary,bpMAP p_map,bpREADMAP p_readmap,U8 bCmd,BoOL blFlag);
extern bpSEQ GenRaid5ReadTaskFromMap(bpSEQ p_sq,dpARY p_ary,bpMAP p_map,U8 bCmd,BoOL blFlag);
extern void ConvertOS_REQ_ToInternalREQ(bpREQ p_rq);
extern bpREQ p_rqGenerateREQ(ByTE bType);
extern void ReleaseInternalREQ(bpREQ p_rq);
extern bpDTASK p_tkGenerateDiskAccess(bpSEQ p_sq,ByTE bCh,ByTE bID,ByTE bCmd,BoOL blFlag,WORD wLBA,HALF hCount,bpPRD p_prd);
extern void PrepareDiskAccess(bpSEQ p_sq,dpSTRM p_sm,ByTE bBlkIndex,ByTE bCmd,BoOL blFlag,bpSECT p_st);
extern void PrepareReadDiskTask(bpSEQ p_sq,dpBLOCK p_blk,bpSECT p_xorsect,U8 bCount,U32 wLBA);
extern void WaitTillTaskDone(bpSEQ p_sq);
extern bpSEQ p_sqInsertAccessDiskSeq(bpREQ p_rq, bpEVENT p_ev, bpSEQ p_sq, ByTE bOp, ByTE bCount, BoOL blFlag);
extern BoOL blAccessDisk(ByTE bCmd,ByTE bCh,ByTE bID,ByTE bCount,BoOL blFlag,HALF hSize,WORD wLBA,bpBUF p_buf,bpREQ p_rq);
extern void GenTaskDirectlyFromMap(bpSEQ p_sq,dpARY p_ary,bpMAP p_map,ByTE bCmd,BoOL blFlag);
extern void GenTaskDirectlyFromMapWithLoadBalancing(bpSEQ p_sq,dpARY p_ary,bpMAP p_map,ByTE bCmd,BoOL blFlag);
extern void GenDoubleTaskDirectlyFromMap(bpSEQ p_sq,dpARY p_ary,bpMAP p_map,ByTE bCmd,BoOL blFlag);
extern void SetDiskDown(bpREQ p_rq,ByTE bIndex);
extern void SetDiskUp(ByTE bIndex);
extern void PutDiskToSleep(ByTE bIndex);
extern void WakeUpDisk(ByTE bIndex);
extern ByTE bFindSpare(WORD wSize, ByTE cardnumber); //modified by isaac for dualcard
extern void LEDControl(ByTE bCh,ByTE bID,ByTE color);
extern void PrepareSmartTask(bpSEQ p_sq,ByTE bCh,ByTE bID,ByTE blFlag);
/*   
 * event.c
 */

extern BoOL blNotTooMuchChoresAlready(ByTE bAry);
extern void SubmitEvent(bpEVENT p_ev);
extern BoOL blEventReturn(bpEVENT p_ev);
extern BoOL blRemoveEvent(bpEVENT p_ev);
extern bpEVENT p_evGenerateEvent(ByTE bAry, ByTE bStrm, ByTE bIndex, ByTE bType, HALF hInterval);
extern BoOL blTalkToBusybodies(bpEVENT p_ev);
extern void _call TimerReturn(bpEVENT p_ev);
extern BoOL blRecoverRoutine(bpEVENT p_ev);
#ifdef MSCOMP
  extern BoOL (* _based(_segname("_CODE")) _call blBusybodies[]) (bpEVENT);
#else
  extern BoOL (* const app_space _call blBusybodies[]) (bpEVENT);
#endif

/* 
	Added by crimson. 11/13, Y2001 
*/
extern U16 getTargetStripeSize(U8 arrayID);
/*
	Added by crimson. 11/22, Y2001 
*/
extern void CheckEnclosureIfDiskIdleDone(U8 Type, U8 bCh,U8 bID);
extern void bCheckOEMBoxSwapDone(U8 Type,U8 bCh,U8 bID);


/*
 * global.c
 */
extern void InitGlobal(WORD  wP, bpBUF p_bVir, bpBUF pVirPBMMem, bpBUF pNonPageMem, WORD wPhyPoolSize, WORD wPhyPoolSize1, WORD wVirPoolSize, WORD wPBMPoolSize, WORD wNonPagePoolSize);

/*
 * layer1.c
 */

extern void _call ChannelReturn(bpDTASK p_tk);
extern BoOL  blChannelResetDone(bpEVENT p_ev);
extern void _call SearchTask_restoreREQ(bpSEQ p_sq1,ByTE bCh);
extern void _call EvalTaskStatus(bpDTASK p_tk);
extern void RestartChannel(ByTE bCh);

/*
 * layer2.c
 */

/*extern ByTE _call bInitRAID(ByTE bType, WORD wP, bpBUF p_b, WORD wSize, bpBUF p_bVir);*/
//extern ByTE _call bInitRAID(ByTE  bType, WORD  wP, bpBUF p_b, WORD  wInitInAcceMemSzie, WORD  wInitAcceMemSzie);
extern ByTE _call bInitRAID(ByTE  bType, WORD  wP, bpBUF p_b, bpBUF pPBMBuf, bpBUF pNonPageMem, WORD  wInitInAcceMemSzie, WORD  wInitInAcceMemSzie1, WORD wInitAcceMemSzie, WORD  wInitPBMSize, WORD  wInitNonPageMemSize);
extern void _call SubmitRAID(bpREQ p_rq);
extern BoOL _call RequestTimedOut(bpREQ p_rq);


/*
 * os.c
 */
extern bpBUF p_AllocPhyMem(ByTE bAdapterNumber, WORD hSize);// parameters added by isaac for dualcard
//extern bpBUF p_AllocPhyMem1(WORD hSize);  //added by isaac for dualcard
extern bpBUF p_AllocVirMem(WORD hSize);
extern bpBUF p_AllocMem(WORD wSize);
extern bpBUF allocatePBMMem(WORD wSize);
extern bpBUF allocateNonPagedVirMem( WORD wSize );
extern HALF hByteBlockCompare(apBUF p_A,apBUF p_B,HALF h);
extern void ByteBlockCopy(apBUF p_A,apBUF p_B,HALF h);
extern void ByteBlockClr(apBUF p_A,HALF h);
extern void WordBlockClr(bpwBUF p_A,HALF h);

extern void ByteBlockFill(apBUF p_A, HALF h, ByTE b);
extern void ByteBlockFillPattern(apBUF p_A,HALF h);
extern void WordBlockCopy(bpwBUF p_A, bpwBUF p_B,HALF h);

extern WORD wGetChecksum(bpwBUF p_b,WORD wSize);
extern HALF hSwapHalf(HALF);
extern WORD wSwapWord(WORD);
extern void _call Serialize(bpBUF p,ByTE bCh,ByTE bID);
extern void TimeStamp(bpBUF p);
extern void LoopSec(WORD);
extern void _call Display(apBUF p_b, ...);
extern void DebugTrap(ByTE bLoc, spQ p);


/*
 * process.c
 */

extern void RegisterResource(bpQ p, bpREQ p_rq, ByTE bQID);
extern void ReleaseAllResources(bpREQ p_rq);
extern bpQ  p_GetResource(bpREQ p_rq,ByTE bQID);
extern void CheckForStuckedREQ(void);
extern void AdvanceRequest(bpREQ p_rq);
extern void InitRequest(bpREQ p_rq);
extern void RestoreRequest(bpREQ p_rq);
extern void RestoreSequence(bpSEQ p_sq);
extern void InitSequence(bpREQ p_rq,bpSEQ p_sq,ByTE bSeqType);
extern void StartSequence(bpSEQ p_sq);
extern BoOL blOK_ToProcess(bpREQ p_rq);
extern void ExplainRejection(bpREQ p_rq);
extern void _call LoadStatus(bpREQ p_rq,HALF hError, ...);
extern void SG_ToPRD(bpREQ p_rq,apSG  p_sg, bpSECT p_st, HALF hSize);
extern void SG_ToPRD1(apSG p_sg, bpSECT p_st, HALF hSize); /*07/21/97 S.Zhu*/
extern bpPRD p_prdPushOnePRD(bpREQ p_rq,bpBUF p_b,HALF hSize);
extern void PopOnePRD(bpREQ p_rq);
extern bpPRD p_PushPRD(bpMAP p_map,bpSECT p_st,HALF hHeadSize,HALF hSliceSize);
extern void CopyPRD(bpPRD p_prd,bpCTASK p_ct);
extern BoOL blByteBlockCompare(bpSEQ p_sq);  /*07/21/97 S.Zhu*/
/* added by crimson. 11/13, Y2001 */

extern  BoOL HardWareCompare( bpSEQ p_sq); // Add by David wei 2001 0104 for 621 hardware compare 
extern BoOL bAnyArrayDefined(void);

extern  BoOL   HardWareCompareForRaid5( bpSEQ p_sq);
/*
 * queue.c
 */
/* Modified by crimson 05/27.
extern void CreatePhyQueue(ByTE bQueueID,WORD wEntrySize,HALF bNumberOfEntry);*/
//added by isaac for dualcard
extern void CreatePhyQueue(ByTE bAdapterNumber,ByTE bQueueID,WORD wEntrySize, WORD wControlBlockSize, HALF bNumberOfEntry);
//extern void CreatePhyQueue1(ByTE bQueueID,WORD wEntrySize, WORD wControlBlockSize, HALF bNumberOfEntry); //added by isaac for dualcard
extern void CreateVirQueue(ByTE bQueueID,WORD wEntrySize,HALF bNumberOfEntry);
extern void CreateQueue(ByTE bQueueID,WORD hEntrySize,HALF bNumberOfEntry);
extern void CreateVirNonPagedQueue(ByTE bQueueID,WORD wEntrySize,HALF bNumberOfEntry);
//parameters added by isaac for dualcard
extern void CreateNonPagedPhyQueue(ByTE bAdapterNumber, ByTE bQueueID,WORD wEntrySize,WORD wControlBlockSize,HALF bNumberOfEntry);
extern void CreateNVMQueue(U8 bQueueID, U32 wEntrySize, U8 bNumberOfEntry);
extern void ReleaseLinkToQ(bpQ p_en,ByTE bQueueID);
extern void PutToSortedDiskQ(bpDTASK p_tk, ByTE bQueueID);
extern void PutToQ_Bottom(bpQ p_en,ByTE bQueueID);
extern void PutToQ_Top(bpQ p_en,ByTE bQueueID);
extern bpQ  p_GetFromQ_Top(ByTE bQueueID);
extern bpQ  p_SearchQ_WithLBA(ByTE bQueueID, WORD wLBA, WORD wLBA2);
extern bpQ  p_SearchQ_WithID(ByTE bQueueID, ByTE bID);
extern void RemoveFromQ(bpQ p_en, ByTE bQueueID);
extern bpQ  GetFromNVM_QTop(U8 bQueueID);
extern void RemoveFromNVMQ(bpQ p,U8 bQueueID);
extern void PutToNVM_QTop(bpQ  p_en, U8 bQueueID);
extern bpQ p_SearchQ_WithLBA_ExceptSource(U8  bQueueID,U32 wLBA,U32 wLBA2);




/*
 * recovery.c
 */

extern BoOL blResetChannel(bpDTASK p_tk);
extern ByTE bFindRecoverySolution(bpSEQ p_sq);
extern BoOL blBecomeDeadIfDiskIsSetDown(bpREQ p_rq, bpDTASK p_tk);/* 05/08/97*/
extern void PrepareReadWriteLongTask(bpSEQ p_sq,ByTE blFlag,bpPRD p_prd,ByTE bCh,ByTE bID,WORD wLBA,ByTE bCmd);

/*
 * requests.c
 */

extern void ConvertTo10(bpREQ p_rq);
extern void SwapEndian10(bpREQ p_rq);
extern void FormatUnit(bpREQ p_rq);
extern void Inquiry(bpREQ p_rq);
extern void ModeSelect6(bpREQ p_rq);
extern void ModeSelect10(bpREQ p_rq);
extern void ModeSense6(bpREQ p_rq);
extern void ModeSense10(bpREQ p_rq);
extern void Read6(bpREQ p_rq);
extern void Read10(bpREQ p_rq);
extern void ReadCapacity(bpREQ p_rq);
extern void Release(bpREQ p_rq);
extern void RequestSense(bpREQ p_rq);
extern void Reserve(bpREQ p_rq);
extern void RezeroUnit(bpREQ p_rq);
extern void Seek6(bpREQ p_rq);
extern void Seek10(bpREQ p_rq);
extern void SendDiagnostic(bpREQ p_rq);
extern void StartStopUnit(bpREQ p_rq);
extern void SynchronizeCache(bpREQ p_rq);
extern void TestUnitReady(bpREQ p_rq);
extern void Verify(bpREQ p_rq);
extern void Write6(bpREQ p_rq);
extern void Write10(bpREQ p_rq);
extern void WriteVerify(bpREQ p_rq);
extern void InvalidOpcode(bpREQ p_rq);
extern void InvalidSubOpcode(bpREQ p_rq);


/*
 * segment.c
 */

extern void InsertSegment(dpARY p_ary, ByTE bStrm, ByTE bBlkIndex, ByTE bType);
extern void RemoveSegment(dpARY p_ary, ByTE bStrm, ByTE bBlkIndex, ByTE bType);
extern BoOL blEvalSegment(dpARY p_ary, bpREQ p_rq);
extern BoOL blLockConflict(bpREQ p_rq, dpARY p_ary);
extern void PutSegmentToQ(dpARY p_ary,dpARY p_ary1,bpREQ p_rq,U32 wLBAStart,U32 wLBAEnd,U8 bQID);
extern BoOL blRebuildConflict(bpREQ p_rq,U32 wLBA,U32 wCount);

/*
 * stripe.c
 */
extern BoOL blXORprd(bpSEQ p_sq);
extern void SpanReq(bpREQ p_rq,dpARY p_ary,bpMAP p_map);
extern void SpanReqNonData(bpREQ p_rq,dpARY p_ary,bpMAP p_map);
extern void StripeReq(bpREQ p_rq,dpARY p_ary,bpMAP p_map);
extern void StripeReqNonData(bpREQ p_rq,dpARY p_ary,bpMAP p_map);
extern WORD wReverseStripe(dpARY p_ary, dpBLOCK p_blk, WORD wLBA);
extern void StretchAccessIfNeeded(bpREQ p_rq);
extern void StripeRaid5ReqNonData(bpREQ p_rq,dpARY p_ary,bpMAP p_map);
extern void StripeRaid4ReqNonData(bpREQ p_rq,dpARY p_ary,bpMAP p_map);
extern bpSEQ StripeRAID5WriteReq(bpREQ p_rq,dpARY p_ary,bpMAP p_map);
extern bpSEQ StripeRAID5ReadReq(bpREQ p_rq,dpARY p_ary,bpMAP p_map);
extern bpSEQ StripeRAID4WriteReq(bpREQ p_rq,dpARY p_ary,bpMAP p_map);
extern bpSEQ StripeRAID4ReadReq(bpREQ p_rq,dpARY p_ary,bpMAP p_map);
extern bpSEQ putReadprd_to_XORprd(dpARY p_ary,U16 hStripeBlockSize,U8 bxorline,U32 wLBA,U8 bStream,bpREQ p_rq,bpSEQ p_sq);
extern U8 bGetPStream(U32 wLBA,U16 hStripeSize,U8 bLogicalWidth,U16 hStripeBlockSize);
extern void GetSG(apSG p_sg,bpBUF buffer1,U8 bCount);
extern void InitMap(bpMAP p_map,bpSECT p_st,dpARY p_ary);
extern void InitReadMap(bpREADMAP p_readmap,bpXORMAP p_xormap,dpARY p_ary);
extern U8 GetRecoveryStream(dpARY p_ary,bpREADMAP p_readmap,bpREQ p_rq);
extern void GetReadSGList(bpREADMAP p_readmap,bpREQ p_rq);
extern void GetParitySGList(bpREADMAP p_readmap,bpREQ p_rq);
extern void InitReadMap1(bpXORMAP1 p_xormap1,dpARY p_ary);
extern BoOL PushParityPRD_RMW(bpREADMAP p_readamp,U16 hSize,bpSECT p_st,U8 bxorline,U8 bStream);
extern BoOL p_PushParityPRD(bpREADMAP p_readmap,U16 hSize,bpSECT p_st,U8 bxorindex,U8 bxorline,U8 bStream);
extern void p_PushPRD2(bpMAP p_map,U16 hSize,bpSECT p_st,U8 bxorline); 
extern void putPRD_to_XORprd(bpSECT p_st,bpXORMAP p_xormap,U8 bxorindex,U8 bxorline);
extern void pushParityPRD(bpREADMAP p_readmap,bpSECT p_st,U16 hSize,U8 bxorline,apSG p_sg);
extern U16 GetLockCount(dpARY p_ary,U16 hOffset,U8 bStream,U32 wLBAStart,bpREQ p_rq);
extern bpSEQ ReadParity(bpREQ p_rq,bpSEQ p_sq,bpSECT p_st,U32 wLBA,U16 hSize,U8 bPStream);
extern BoOL CheckingIfRMW(dpARY p_ary,U16 hOffset,U16 hCount,U16 hSize,U8 bStream,U8 bPStream);
extern void HardwareXor(bpXORMAP p_xormap,bpSEQ p_sq,bpREADMAP p_readmap);
extern U8 ReStartConvsionExpansion(U8  bAry);

extern void printInfo(ByTE val);
extern U8 RebuildPercentStatus(U8 iarry);
extern U8 GetPercentageForSync(U8 ArrayID);
//added by isaac for raid5 initialization 
extern U8 GetPercentageForRaid5Init(U8 ArrayID);
extern void UpdateConfigData(void);
extern void ReviseStructure(ByTE channelNum);

/* dispatch.c*/
extern void MaintenenceStopped(void);
