/*****************************************************************************
*   FastTrak Device Driver for Linux(SCSI form)
*   Auther:  Robert Zhang
*   Histroy:
******************************************************************************/

#include <linux/module.h>
#include <linux/init.h>
#include <stdarg.h>
#include <asm/io.h>
#include <asm/string.h>
#include <asm/irq.h>
#include <asm/byteorder.h>
#include <linux/version.h>
#include <linux/string.h>
#include <linux/errno.h>
#include <linux/kernel.h>
#include <linux/ioport.h>
#include <linux/delay.h>
#include <linux/sched.h>
#include <linux/pci.h>
#include <linux/proc_fs.h>
#include <linux/blk.h>
#include <linux/tqueue.h>
#include <linux/types.h>
#include <linux/hdreg.h>
#include <linux/notifier.h>        
#include <linux/reboot.h>
#include "engine/code.h"
#include "engine/constant.h"
#include "engine/struct.h"
#include "engine/global.h"
#include "engine/buf.h"
#include "engine/buf_ioct.h"
#include "engine/export.h"
#include "global.h"
#include "fasttrak.h"
#include "pti_stdev.h"
#include "pti_st.h"

#include "ata.h"
#include "cam_con.h"
#include "cam_def.h"
#include "cam_macr.h"
#include "cam_var.h"

#include "wrapper.h"
#include "cam_patch.h"
#include "cam_export.h"

/*
#include "sd.h"
#include "scsi.h"
#include "hosts.h"*/
//Label_bp begin
#include "engine/oem.h"
#include <sd.h>
#include <scsi.h>
#include <hosts.h>
//Label_bp end

U8 bResetController;

U16 PTIAdapter=0;
U8 blOffHibernation = 0;
UCHAR blSynchronizeRAID5=0;
USHORT RebuildRate=4;
USHORT SyncRate=4;
USHORT ConvExpanRate=4;
UCHAR  HotSwap=1;
USHORT ConvExpLoopCount=0;
USHORT RebuildLoopCount=0;
USHORT SyncLoopCount=0;
USHORT ConvExpanLoopCount=0;
int lNestcli;
int eachChannelCount[8];
int submitHDMACount=0;
int submitXORCount=0;
int ptiMajor;
int ptiDimmSize[MAX_ADAPTER_NUM];
unsigned char g_StopStatus=0xff;
int g_Is_ShutDown=0;


//add by steven
U8  SmartStatus[8][2];
extern ByTE AlarmBuzzerEnabled;
extern ByTE 	SXSMARTEnable;
extern ByTE		WriteCacheEnable;

//added by isaac for array status daemon
U8 DaemonNeedUnload = 0; 
U8 NumOfArrayOffLine = 0;
U8 NumOfArrayNeedRefresh = 0;
U8 FlagArrayOffLine = 0;
U8 FlagArrayNeedRefresh = 0;
//end

/*****************battery backup function *************/
extern U8 CheckBatteryBackmodule(U8 AdapterIndex);
extern U8 CheckBatteryPack(U8 AdapterIndex);
extern U8 initBatteryModule(U8 AdapterIndex);
extern U16 InquiryChargeStatus(U8 AdapterIndex);
extern U16 InquiryChargingCycle(U8 AdapterIndex);
extern U16 InquiryBatteryTemperature(U8 AdapterIndex);
extern U16 InquiryBatteryVoltage(U8 AdapterIndex);
extern U32 GetSysMemNeeded(void);

//Label_bp begin
VOID MapIndex(
           UCHAR bChannel,
	       UCHAR bID,
	       PUCHAR pAdapterNumber,
	       PUCHAR pTargetID);
extern BoOL CheckEnclosureIfDiskIdle(unsigned char bCh,unsigned char bID);
extern BoOL _call CheckEnclosureGlobalStatus(ByTE bAdapterNumber,ByTE bStatus);
void CheckStatusLEDChange(U8 bCh, U8 bID,U8 bForceCheck);
//Label_bp end

int SetWriteCacheEnabled(int enabled);
//extern BoOL ConExpComplete;  //add by isaac for ConExp
//end of add

extern bpQ p_QueueHead[MAX_QUEUE_SUPPORTED];

extern void PTI_handler_wrapper(int irq, void *dev_id, struct pt_regs *regs); 

extern int buf_flush(void);
extern struct timer_list	submit_timer;	// for submit_timer_handler

struct timer_list InitRAID_Timer;

#if LINUX_VERSION_CODE>KERNEL_VERSION(2,3,0)
	static DECLARE_WAIT_QUEUE_HEAD(Wait0);
#else
	static struct wait_queue *WaitQ=NULL;
#endif

struct pti_st_host *pti_st_hostp = {0};

#if LINUX_VERSION_CODE>KERNEL_VERSION(2,3,0)
struct proc_dir_entry proc_scsi_PTI = {		
   0,					// PROC_SCSI_FastTrak,
   8,					// length of "FastTrak" 	
   "FastTrak",				// name of directory entry
   S_IFDIR | S_IRUGO | S_IXUGO,	
   2,				
};
#else
struct proc_dir_entry proc_scsi_PTI = {		
   PROC_SCSI_NOT_PRESENT,		// PROC_SCSI_FastTrak,
   8,					// length of "FastTrak" 	
   "FastTrak",				// name of directory entry
   S_IFDIR | S_IRUGO | S_IXUGO,	
   2,				
};
#endif

unchar *ENGINE;
unchar *PBM_MEM;
/*********************************************************************
 * Function:	unchar InitGDS( void )
 * Description:	Initial Global Data Structure
 *	ft_adapter[FT_Max_Ada]
 *	ft_channel[FT_Max_Ch]
 *	ft_drive[FT_Max_Dev]
 ********************************************************************/
unchar InitGDS( void ) {
   unchar 	uc;
   //initialize dimm window size
   //added by isaac according to jack's suggestion
   for( uc=0 ; uc < PTI_Max_Ada ; uc++)
      {
 	gAdapterConfigInfo.bSDRAMWindowsSize[uc] = 0;
      }	
   // initialize ft_adapter[ada]
   for( uc=0 ; uc < PTI_Max_Ada ; uc++ )	{
   	memset(&PTI_adapter[uc],0,sizeof(PTI_adapter_t));	
   	PTI_adapter[uc].id = uc ;
   	PTI_adapter[uc].pchannel[0] = &PTI_channel[uc*4+0];
   	PTI_adapter[uc].pchannel[1] = &PTI_channel[uc*4+1];
   	PTI_adapter[uc].pchannel[2] = &PTI_channel[uc*4+2];
   	PTI_adapter[uc].pchannel[3] = &PTI_channel[uc*4+3];
   	spin_lock_init( &PTI_adapter[uc].pti_lock );
   }
   // initialize ft_channel[ch]
   for( uc=0 ; uc < PTI_Max_Ch ; uc++ )	{
	memset(&PTI_channel[uc],0,sizeof(PTI_channel_t));
   	PTI_channel[uc].id = uc ;
   	PTI_channel[uc].padapter  = &PTI_adapter[uc/4];
   	PTI_channel[uc].pdrive[0] = &PTI_drive[uc*2+0];
   	PTI_channel[uc].pdrive[1] = &PTI_drive[uc*2+1];
   }
   // initialize ft_drive[dev]
   for( uc=0 ; uc < PTI_Max_Dev ; uc++ ) {	
	memset(&PTI_drive[uc],0,sizeof(PTI_drive_t));
   	PTI_drive[uc].id = uc ;
   	PTI_drive[uc].pchannel = &PTI_channel[uc/2];
	PTI_drive[uc].select   = uc%2 ? 0xB0 : 0xA0 ;   
   }
   return(0);
}
// -------------------------------------------------------------------
int pti_stdev_open(struct inode *inodep, struct file *filep)
{
	if(!pti_st_hostp || 
	   ptiMajor <= 0 ||
	   ptiMajor != MAJOR(inodep->i_rdev))
		return(-ENODEV);

	MOD_INC_USE_COUNT;
	return(0);
}

int pti_stdev_release(struct inode *inodep, struct file *filep)
{
	MOD_DEC_USE_COUNT;
	return(0);
}

void call_pti_buf_flush(void);
void shutdown_call_pti_buf_flush(void);

int pti_stdev_ioctl(struct inode *inodep,
		struct file *filep,
		unsigned int req,
		unsigned long arg)
{
   unchar	*args;

   if( !arg ) {
	DEB(printk("fasttrak_ioctl: Unable to handle NULL pointer.\n"););
   	return(0x10);
   }
   args = (unchar *) arg ;
   switch( req ) {
	// monitor FastTrak Adapter/Array/Drive Status (arg="")
	case IOCTL_FASTTRAK_GETVERSION:{
	       //args[0]=100;
		StrDriverVersion *driverversion=(StrDriverVersion *)arg;
		strcpy(driverversion->timestamp,VERDATE);
                strcpy(driverversion->version, VERSION);
		driverversion->timestamp_length = strlen(driverversion->timestamp);
		driverversion->version_length = strlen(driverversion->version) ;
		
		//*(VERSION)<<24+*(VERSION+1)<<16+*(VERSION+2)<<8+*(VERSION+3);
		return(0);
               }
	case IOCTL_FASTTRAK_ARRAYCOUNT:{
		int i;
		StructNUMBER *buf = (StructNUMBER *)arg;
		buf->number = 0;
		for(i=0;i<PTI_Max_Arr;i++)
			if(aryDef[i].blFlag & blVALID_LUN) (buf->number)++;
		return(0);
	     }
	case IOCTL_FASTTRAK_ADAPTERCOUNT:{
		StructNUMBER *buf = (StructNUMBER *)arg;
		buf->number=PTIAdapter;
		return(0);
	     }
	case IOCTL_FASTTRAK_ARRAYS:{
		Arrays_Buffer_t *buf=(Arrays_Buffer_t *)arg;
		//int i;
		//buf->ReturnCode=sizeof(ARY)*PTI_Max_Arr;
		buf->ReturnCode = 0xFFFF;
        //printk("\nsizeof(ARY)=%ud",sizeof(ARY));
        //printk("\nFOR TEST ARRAY!!");
        /*for(i=0;i<4;i++)
		{
	        printk("\narray[%d].hGeneration=%d",i,aryDef[i].hGeneration);
			printk("\narray[%d].blFlag=%d",i,aryDef[i].blFlag);
			printk("\narray[%d].blRAID=%d",i,aryDef[i].blRAID);
			printk("\narray[%d].bWidth=%d",i,aryDef[i].bWidth);
			printk("\narray[%d].bStripeBlockPower=%d",i,aryDef[i].bStripeBlockPower);
			printk("\narray[%d].bLogicalWidth=%d",i,aryDef[i].bLogicalWidth);
			printk("\narray[%d].bID=%d",i,aryDef[i].bID);
			printk("\narray[%d].wSize=%d",i,aryDef[i].wSize);
			printk("\narray[%d].hCyl=%d",i,aryDef[i].hCyl);
			printk("\narray[%d].bHd=%d",i,aryDef[i].bHd);
			printk("\narray[%d].bSctr=%d",i,aryDef[i].bSctr);
			printk("\narray[%d].wWatermark=%d",i,aryDef[i].wWatermark);
			printk("\narray[%d].hStripeBlockSize=%d",i,aryDef[i].hStripeBlockSize);
			printk("\narray[%d].hStripeSize=%d",i,aryDef[i].hStripeSize);
		    printk("\narray[%d].Name=%s",i,aryDef[i].Name);
			printk("\narray[%d].bInit=%d",i,aryDef[i].bInit);
		}*/
        memcpy(buf->Array,aryDef,sizeof(ARY)*PTI_Max_Arr);
        //printk("\nFOR TEST ARRAY end!!!");
		return(0);
	}	
	case IOCTL_FASTTRAK_ADAPTER:{
		ULONG i,j;
				
		Adapters_Buffer_t *buf =(Adapters_Buffer_t *)arg;

		static HW_ADAPTER_EXTENSION adapter;
	
		i=buf->Adapterindex;
		
		adapter.InterruptLine = gAdapterConfigInfo.IRQ[i];
		adapter.NumberChannels = 4;
//modified by isaac ioctl				
		if (0 == i)
		{
		  for (j=0; j<MAX_CHANNEL_PER_CARD*MAX_DISK_PER_CHANNEL; j++)
		  {
			if(PTI_drive[j].present)
			{
			  memcpy(&adapter.IdentifyData[j],PTI_drive[j].identify,0x200);
			}
			adapter.DevicePresent[j] = PTI_drive[j].present;
	          } 
		}
	        else if (1 == i)
		{	
		  for (j=0; j<MAX_CHANNEL_PER_CARD*MAX_DISK_PER_CHANNEL; j++)
		  {
			  if(PTI_drive[j+MAX_CHANNEL_PER_CARD*MAX_DISK_PER_CHANNEL].present)
			  {
			    memcpy(&adapter.IdentifyData[j],PTI_drive[j+MAX_CHANNEL_PER_CARD*MAX_DISK_PER_CHANNEL].identify,0x200);
			  }
			  adapter.DevicePresent[j] = PTI_drive[j+MAX_CHANNEL_PER_CARD*MAX_DISK_PER_CHANNEL].present;
		  }
				  
		}
//end
		if(i<PTIAdapter)
			{
				buf->ReturnCode= sizeof(HW_ADAPTER_EXTENSION);
				//buf->ReturnCode= 0x1000;
				buf->Controller = adapter;
			}
		else
			 buf->ReturnCode=0;

		return(0);
	}
	case IOCTL_FASTTRAK_BLOCKS:{
		Blocks_Buffer_t *buf=(Blocks_Buffer_t *)arg;
		buf->ReturnCode=sizeof(BLOCK)*PTI_Max_Dev;
		memcpy(buf->Block,blkDisk,buf->ReturnCode);
		return(0);
	}
 	case IOCTL_FASTTRAK_BLOCKCOUNT:{
		int i;
		StructNUMBER *buf = (StructNUMBER *)arg;
		buf->number = 0;
		for (i=0; i<(MAX_BLOCK_PER_CARD+1); i++)
		{
			if (blkDisk[i].blFlag & blVALID_BLK) (buf->number)++;
		}
		return(0);
	}
	case IOCTL_FASTTRAK_CHECKINTEGRITY:{
		IOCTL_FASTTRAK_CHECKINTEGRITY_FRAME *buf= (IOCTL_FASTTRAK_CHECKINTEGRITY_FRAME *)arg;
	
		//added by isaac for maintenance pause problem	 
	         U32 stat;
		 U8 i;
	 	 for (i=0; i<ACTUAL_ARRAY_SUPPORTED; i++)
		 {
			if((stat = GetArrayStatus(i)) == 0xffffffff) continue;
			if((i == buf->bID) && (stat & ARY_STATUS_SYNC_PAUSE) && (buf->ulFlag == UTIL_START)) continue;
			if(stat & (ARY_STATUS_REBUILD_PAUSE+ ARY_STATUS_SYNC_PAUSE + ARY_STATUS_CONVEXP_PAUSE)) 
			 {
		         //printk("<1>stat=%x\n",stat);
			 buf->Status = FALSE;
			 return 0;
			 }		
           	 }      
		//<<change 2002.1.17 steven
		g_syncErrorFlag=0;
		if(buf->ulFlag==UTIL_START)
			buf->Status = StartCheckIntegrity(buf->bID);
		else if (buf->ulFlag==UTIL_PAUSE)
			{
				StopRebuild_Conversion(buf->bID);
				buf->Status = TRUE;
			}
		else if (buf->ulFlag==UTIL_STOP)
			{
			}
		//<<end of change 2002.1.17 steven
		return(0);
	 }
	case IOCTL_FASTTRAK_REBUILD:{
		 IOCTL_FASTTRAK_REBUILD_FRAME *buf= (IOCTL_FASTTRAK_REBUILD_FRAME *)arg;        
	//added by isaac for maintenance pause problem	 
	         U32 stat;
		 U8 i;
	 	 for (i=0; i<ACTUAL_ARRAY_SUPPORTED; i++)
		 {
			if((stat = GetArrayStatus(i)) == 0xffffffff) continue;
			if((i == buf->bID) && (stat & ARY_STATUS_REBUILD_PAUSE) && (buf->ulFlag == UTIL_CONTINUE)) continue;
			if(stat & (ARY_STATUS_REBUILD_PAUSE+ ARY_STATUS_SYNC_PAUSE + ARY_STATUS_CONVEXP_PAUSE)) 
			 {
		        // printk("<1>stat=%x\n",stat);
			 buf->Status = FALSE;
			 return 0;
			 }		
           	 }
		 //printk("\nfot test start Rebuild disk....");
		//<<change 2002.1.17 steven
		if ( (buf->ulFlag==UTIL_START)||(buf->ulFlag == UTIL_CONTINUE) )
			{
				int tempCH,tempID;
				tempCH=blkDisk[aryDef[buf->bID].strm[buf->RebuildDisk].bIndex].bCh;
				tempID=blkDisk[aryDef[buf->bID].strm[buf->RebuildDisk].bIndex].bID;

				buf->Status = StartRebuild(buf->bID,tempCH,tempID);		
			}
			else if (buf->ulFlag == UTIL_PAUSE)
			{
				StopRebuild_Conversion(buf->bID);
				buf->Status = TRUE;
			}
			else if (buf->ulFlag==UTIL_STOP)
			{
			}
		  //<<end of change 2002.1.17 steven	

		return(0);
	}
	
	case IOCTL_FASTTRAK_ARRAYSTATUS:{
			ULONG i;
			//bpEVENT p_ev;
			U32 stat;
			ArrayStatus_Buffer_t *buf = (ArrayStatus_Buffer_t *)arg;
			ULONG REBUILD_LIMIT=40000000;
			/* when rebuild watermark > REBUILD_LIMIT
			 watermark*100 > 0xffffffff, pecentage give the wrong value */
			memset(aryStatus,0,sizeof(ARRAYSTATUS)*ACTUAL_ARRAY_SUPPORTED);
			for (i=0;i<ACTUAL_ARRAY_SUPPORTED;i++)
				{
					stat=GetArrayStatus((U8)i);
					if(stat == ARY_STATUS_OK)
						aryStatus[i].status=ARRAY_STATUS_IDLE;
					else if( (stat == 0xffffffff)||(stat == ARY_STATUS_ERROR) )
					{
						aryStatus[i].status=0xff;
					}
					//<<change 2002.1.17 steven
					else if(stat & ARY_STATUS_REBUILD_PAUSE)
						{
							aryStatus[i].status=ARRAY_STATUS_REBUILD_PAUSE;
							aryStatus[i].runion.Rebuild.percentage = RebuildPercentStatus((U8)i); //2002.1.10
						}
						else if(stat & ARY_STATUS_CONVEXP_PAUSE)
						{
							aryStatus[i].status=ARRAY_STATUS_EXPAN_PAUSE;
							aryStatus[i].runion.ExpanConv.percentage=GetPecentageForConversion_Expansion((U8)i);
						}
						else if(stat & ARY_STATUS_SYNC_PAUSE)
						{
							aryStatus[i].status=ARRAY_STATUS_SYNC_PAUSE;
							aryStatus[i].runion.Verify.percentage=GetPercentageForSync((U8)i);
						}
					//<<end of change 2002.1.17 steven
					else if(stat & ARY_STATUS_EXPANDING)
					{
						aryStatus[i].status=ARRAY_STATUS_EXPANCONV;
						aryStatus[i].runion.ExpanConv.percentage=GetPecentageForConversion_Expansion((U8)i);
					}
				//added by isaac for raid5 initialization
			                else if(stat & ARY_STATUS_RAID5_INITIALIZATION)
					{
						aryStatus[i].status=ARRAY_STATUS_RAID5_INIT;
						aryStatus[i].runion.Raid5Init.percentage=GetPercentageForRaid5Init((U8)i);
					}
				//end
					else if(stat & ARY_STATUS_CHECKING_INTEGRITY)
					{
						aryStatus[i].status=ARRAY_STATUS_VERIFY;
						aryStatus[i].runion.Verify.percentage=GetPercentageForSync((U8)i);
					}
					else if(stat & ARY_STATUS_REBUILDING)
					{
						aryStatus[i].status=ARRAY_STATUS_REBUILD;
						if (aryDef[i].wWatermark > REBUILD_LIMIT)
							aryStatus[i].runion.engRebuild.percentage =
								(char)((ULONG)(aryDef[i].wWatermark ) / (ULONG)(aryDef[i].wSize/100));
						else
							aryStatus[i].runion.engRebuild.percentage =
								(char)((ULONG)(aryDef[i].wWatermark * 100) / (ULONG)aryDef[i].wSize);
					}
					else if( stat & ARY_STATUS_ERROR )
					{
						aryStatus[i].status=0xff;
					}
				   //*((PARRAYSTATUS)((SRB_IO_CONTROL *)(Srb->DataBuffer)+1)+i) = aryStatus[i];
				   //printk("\nArray status Step 6!");
				   memcpy(&(buf->as[i]),&(aryStatus[i]),sizeof(ARRAYSTATUS));
				  //buf->as[i] = aryStatus[i];
			  }
			//printk("\nArray status Step 7!");
			  buf->ReturnCode=sizeof (ARRAYSTATUS) *ACTUAL_ARRAY_SUPPORTED;

			  return(0);
	 }
	case IOCTL_FASTTRAK_GETNOTIFYDATA:{
		FASTTRAKNOTIFICATION *buf = (FASTTRAKNOTIFICATION *)arg;
		//*((PFASTTRAKNOTIFICATION)((SRB_IO_CONTROL *)(Srb->DataBuffer)+1)) = ftNotification;
		memcpy(buf,&ftNotification,sizeof(FASTTRAKNOTIFICATION));
		
		ftNotification.NotifyType = FNT_NOTHING;
		return(0);
	 }
	case IOCTL_FASTTRAK_GETCHCOUNTTHRESHOLD:{
		 StructNUMBER *buf = (StructNUMBER *)arg;
		 buf->number=bChannelCountThre;
		return(0);
	 }
	case IOCTL_FASTTRAK_SETCHCOUNTTHRESHOLD:{
		Io_Buffer_t *buf = (Io_Buffer_t *)arg;
		bChannelCountThre = buf->val;
		return(0);
	 }
	case IOCTL_FASTTRAK_GETCHORGCOUNT:{
		StructNUMBER *buf = (StructNUMBER *)arg;
		 buf->number= bOriginalChannelCount;
		return(0);
	 }
	case IOCTL_FASTTRAK_SETCHORGCOUNT:{
		Io_Buffer_t *buf = (Io_Buffer_t *)arg;
		bOriginalChannelCount = buf->val;
		return(0);
	 }
	case IOCTL_FASTTRAK_SETMAINTLENGTH:{
		 //Io_Buffer_t *buf = (Io_Buffer_t *)arg;	
		 /*MaintenanceLength = buf->val;
	     if (MaintenanceLength>32) MaintenanceLength = 32;*/
		 return(0);
	 }
	case IOCTL_FASTTRAK_GETMAINTLENGTH:{
		//StructNUMBER *buf = (StructNUMBER *)arg;
		 /*buf->number= MaintenanceLength;*/
		return(0);
	 }
	case IOCTL_FASTTRAK_GETLOGCOUNT:{
		 GetLogCount_Buffer_t *buf = (GetLogCount_Buffer_t *)arg;

		 WORD TotalEventCount = 0;
		 TotalEventCount = GetEventCount();

		 if (TotalEventCount)
		 {
			buf->val.EventCount = TotalEventCount;
			/* pFrame->EndNum = pFrame->StartNum + TotalEventCount-1;*/
		 }
		else
			buf->val.EventCount = 0;
		    buf->ReturnCode = sizeof(IOCTL_FASTTRAK_GETNUMQUEUEEVENTFRAME);
		return(0);
	 }
	case IOCTL_FASTTRAK_GETLOGEVENT:{
		 GetLogEvent_Buffer_t *buf = (GetLogEvent_Buffer_t *)arg;
 	     /* ULONG Start = pFrame->StartNum;
				ULONG End = pFrame->EndNum;*/
				if (buf->val.EventCount)
				{
					ReadEventLog((bpwBUF)buf->val.LogEvent,(WORD)buf->val.EventCount);
				}
					// copy events into pFrame->LogEvent

		buf->ReturnCode = sizeof(IOCTL_FASTTRAK_GETEEVENTFRAME);
		return(0);
	 }
	case IOCTL_FASTTRAK_GETSMARTSTATUS:{
		GetSmartStatus_Bffer_t *buf = (GetSmartStatus_Bffer_t *)arg;
		//int i,j;
		
	    if (buf->val.bCh < 4 &&
		buf->val.bID < 2 &&
		buf->val.bController < 2)
	    {
			//printk("\nbCh=%d,bID=%d",buf->val.bCh,buf->val.bID);
			buf->val.bSmartStatus = SmartStatus[buf->val.bController*2+buf->val.bCh][buf->val.bID];
	    }
	    else
		buf->val.bSmartStatus = NO_SMART;
/*
		for(i=0;i<4;i++)
			for(j=0;j<2;j++)
			{
				printk("\nSmartStatus[%d][%d]=%d",i,j,SmartStatus[i][j]);
			}
*/
	
	    buf->ReturnCode = sizeof(IOCTL_FASTTRAK_GETSMARTSTATUSFRAME);
		return(0);
	 }
	case IOCTL_FASTTRAK_GETRAINMAKERTYPE:{
		GetRainMakerType_Buffer_t *buf = (GetRainMakerType_Buffer_t *)arg;

	    buf->val.dwRainmakerType = FastTrakAdapterType[buf->AdapterIndex];
	    buf->val.dwVendorId = 0x105A;
	    buf->val.dwSubsystemId = FASTTRAK66_SUBSYSTEMID;

	    switch(FastTrakAdapterType[buf->AdapterIndex])
	    {
	    case NO_RAINMAKER:
		break;
/*	    case RAINMAKER_33:
		buf->val.dwDeviceId = 0x4D33;
		break;
	    case RAINMAKER_66:
		buf->val.dwDeviceId = 0x4D38;
		break;
	    case RAINMAKER_66B:
		buf->val.dwDeviceId = 0x0D38;
		break;
	    case RAINMAKER_100:
		buf->val.dwDeviceId = 0x4D30;
		break;
		case RAINMAKER_INTEL_100:
		buf->val.dwDeviceId = 0x0D30;
		break;
		case RAINMAKER_268:
		buf->val.dwDeviceId = 0x6268; */
            case RAINMAKER_621:
		 buf->val.dwDeviceId = 0x6621;
		 break;
            case RAINMAKER_622:
                 buf->val.dwDeviceId = 0x6622;		 
			}
		return(0);
	 }
	case IOCTL_FASTTRAK_GETSMARTCHECKENABLED:{
		GetSmartCheckEnabled_Buffer_t *buf =(GetSmartCheckEnabled_Buffer_t *)arg;
		//buf->val.bEnabled = EnableCheckSmartStatus;
		buf->val.bEnabled = SXSMARTEnable;
		return(0);
	 }
	case IOCTL_FASTTRAK_SETSMARTCHECKENABLED:{
		SetSmartCheckEnabled_Buffer_t *buf =(SetSmartCheckEnabled_Buffer_t *)arg;
		//EnableCheckSmartStatus = (UCHAR) buf->val.bEnabled;
		SXSMARTEnable = (UCHAR) buf->val.bEnabled;
		return(0);
	 }
	case IOCTL_FASTTRAK_ENCLOSURE_COMMAND:{
		GetEnclosureType_Buffer_t *buf = (GetEnclosureType_Buffer_t *)arg;
		buf->val.dwValue = GetEnclosureStatus((ByTE)buf->val.bSubCmd, (ByTE)buf->val.bCh, (ByTE)buf->val.bID,(ByTE)buf->val.bFanIndex);
		//printk("\nbuf->val.bSubCmd = %x",buf->val.bSubCmd);
		//printk("\ndwvalue= %ld",buf->val.dwValue);
		
		buf->ReturnCode = 0xFFFF;
		//buf->ReturnCode = sizeof(GetEnclosureType_Buffer_t);
		return(0);
	 }
	case IOCTL_FASTTRAK_CREATE_ARRAY:{
		long smpflag;
		CreateArray_Buffer_t *buf =(CreateArray_Buffer_t *)arg;
		/*ULONG ulPhysIndex=buf->val.bPhysIndex;*/
		int i;
		U8 CreateArrayDiskId[8];
		U32 ArrayID;  //added by isaac for createarray
		for(i=0;i<8;i++)
			{
			CreateArrayDiskId[i]=bFindAssociatedBlock(0,buf->val.DiskID[i]/MAX_ID_PER_CHANNEL,buf->val.DiskID[i]%MAX_ID_PER_CHANNEL);
			}
/*
		for(i=0;i<buf->val.nDisk;i++)
		{
			printk("\nbuf->val.DiskID[%d]=%d",i,buf->val.DiskID[i]);
			printk("\nCreateArrayDiskId[%d]=%d",i,CreateArrayDiskId[i]);
		}	
		printk("\nbuf->val.nDisk=%d",buf->val.nDisk);
		printk("\nbuf->val.nStripeBlockSize=%d",buf->val.nStripeBlockSize);
		printk("\nbuf->val.Arrayname=%s",buf->val.Arrayname);
*/
	spin_lock_irqsave(&PTI_adapter[0].pti_lock,smpflag);
        //added by isaac for initialization
	//printk("<1>buf->val.blRAID=%x\n",buf->val.blRAID);
	buf->val.dwStatus = CreateArray(buf->val.Arrayname,CreateArrayDiskId,(U32)buf->val.blRAID, buf->val.nDisk, (U32)buf->val.nStripeBlockSize, &ArrayID);
	spin_unlock_irqrestore(&PTI_adapter[0].pti_lock,smpflag);
		DefDriveStruct();
	        InitLED();
		buf->ReturnCode = 0xFFFF;
        /*buf->val.bPhysIndex=(UCHAR)ulPhysIndex; */
		buf->val.blRAID = (UCHAR)ArrayID;  //added by isaac for createarray
		return(0);
	 }
	case IOCTL_FASTTRAK_DELETE_ARRAY:{
		long smpflag;
		DeleteArray_Buffer_t *buf =(DeleteArray_Buffer_t *)arg;
		//printk("\n delete array%d start.....",buf->val.bPhysIndex);
		spin_lock_irqsave(&PTI_adapter[0].pti_lock,smpflag);
		call_pti_buf_flush();
		buf->val.dwStatus = DeleteArray(buf->val.bPhysIndex);
		spin_unlock_irqrestore(&PTI_adapter[0].pti_lock,smpflag);
		//printk("\n delete array end");
		DefDriveStruct();
		buf->ReturnCode = 0xFFFF;
		return(0);
	}
	case IOCTL_FASTTRAK_SETSYNCRATE:{
		Rate_Buffer_t *buf = (Rate_Buffer_t *)arg;
		 buf->ReturnCode=SetSyncRate(buf->val.bRate);
		return(0);
		}
	case IOCTL_FASTTRAK_GETSYNCRATE:{
		Rate_Buffer_t *buf = (Rate_Buffer_t *)arg;
		buf->val.bRate = GetSyncRate();
		return(0);
		}
/*	
	case IOCTL_FASTTRAK_SIGNATURE1:
		return(0);
	
	case IOCTL_FASTTRAK_SIGNATURE2:
		return(0);
*/	

case IOCTL_FASTTRAK_SETREBUILDRATE:{
		Rate_Buffer_t *buf = (Rate_Buffer_t *)arg;
		//printk("\nsetrebuildrate:%d",buf->val.bRate);
		buf->ReturnCode=SetRebuildRate(buf->val.bRate);
		//printk("\nafterset:rebuildrate=%d",RebuildRate);
		return(0);
		}

	case IOCTL_FASTTRAK_GETREBUILDRATE:{
		Rate_Buffer_t *buf = (Rate_Buffer_t *)arg;
		buf->val.bRate = GetRebuildRate();
		//printk("\nget:buf->val.bRate=%d",buf->val.bRate);
		return(0);
		}

	case IOCTL_FASTTRAK_EXPANCONV:{
		IOCTL_FASTTRAK_EXPANCONV_FRAME *buf = (IOCTL_FASTTRAK_EXPANCONV_FRAME *)arg;

			U8 		ArrayID;
			U8 		NewRaidMode;
			U8 		NewRaidDiskNum;
			U8  	NewDiskID[MAX_BLOCK_PER_CARD];
			U8 		ConverSectorSize;
			ULONG   stat;
			U8		newnumdisk,i; //add 9.19
						
	//added by isaac for maintenance pause problem	 
	         U32 status;
		 U8 j;
	 	 for (j=0; j<ACTUAL_ARRAY_SUPPORTED; j++)
		 {
			if((status = GetArrayStatus(j)) == 0xffffffff) continue;
			if((j == (U8)buf->nPhysIndex) && (status & ARY_STATUS_CONVEXP_PAUSE) && (buf->ulFlag == UTIL_CONTINUE)) continue;
			if(status & (ARY_STATUS_REBUILD_PAUSE+ ARY_STATUS_SYNC_PAUSE + ARY_STATUS_CONVEXP_PAUSE)) 
			 {
		         buf->Status = ARRAY_NOT_VALID;
			 return 0;
			 }		
           	 }        
			ArrayID=(U8)buf->nPhysIndex;
			NewRaidMode=(U8)buf->nNewRAID;
			NewRaidDiskNum=(U8)buf->nNewDisk;
			//NewDiskID=buf->nNewDiskIDs; //remarked 9.19
			ConverSectorSize=(U8)buf->nStripeBlockSize;
			//add 9.19, convert diskid from ch*2+id to index of blkdisk
			newnumdisk=NewRaidDiskNum-aryDef[ArrayID].bWidth;
			//newnumdisk=NewRaidDiskNum;
			for(i=0;i<newnumdisk;i++)
				{
			//		printk("<1>buf->nNewDiskIDs[%d]=%d\n",i,buf->nNewDiskIDs[i]);
				    NewDiskID[i] = bFindAssociatedBlock(0,buf->nNewDiskIDs[i]/MAX_ID_PER_CHANNEL,buf->nNewDiskIDs[i]%MAX_ID_PER_CHANNEL);			//	    printk("<1>NewDiskID[%d]=%d\n",i,NewDiskID[i]);
				}
//			printk("\nbuf->nPhysIndex=%d",buf->nPhysIndex);
//			printk("\nbuf->nNewRAID=%d",buf->nNewRAID);
//			printk("\nbuf->nNewDisk=%d",buf->nNewDisk);
//			printk("\nbuf->nStripeBlockSize=%d",buf->nStripeBlockSize);
			//printk("\nbuf->ulFlag=%d",buf->ulFlag);
		       
			
			//
			if(buf->ulFlag == UTIL_START)//<<change 2002.1.17 steven
				{
					//isaac modified for ConExp
		//		   if (ConExpComplete) 
		//		   {
				         	stat =	StartConversion_Expansion(
			    			ArrayID,
			    			NewRaidMode,
			    			NewRaidDiskNum,
			    			NewDiskID,
			    			ConverSectorSize);
				         	buf->Status = stat;
	 	//	           }
		//		   else
		//		   {
		//			   buf->Status = ReStartConvsionExpansion(ArrayID);
		//		   } 
				}
		        else if(buf->ulFlag ==UTIL_PAUSE)//<<change 2002.1.17 steven
				{
					StopRebuild_Conversion(ArrayID);
					buf->Status = CONVERSION_EXPANSION_OK;
				}
			else if(buf->ulFlag ==UTIL_CONTINUE)//<<change 2002.1.17 steven
				buf->Status = ReStartConvsionExpansion(ArrayID);
			//printk("\nbuf->Status=%lx",buf->Status);
			//printk("\nstat=%lx",stat);
		return(0);
		}

	case IOCTL_FASTTRAK_SETEXPANCONVRATE:{		
		Rate_Buffer_t *buf = (Rate_Buffer_t *)arg;
		buf->ReturnCode=SetExpConvRate(buf->val.bRate);
		return(0);
		}
	
	case IOCTL_FASTTRAK_GETEXPANCONVRATE:{
		Rate_Buffer_t *buf = (Rate_Buffer_t *)arg;
		buf->val.bRate = GetExpConvRate();
		return(0);
		}

	case IOCTL_FASTTRAK_SETWRITECACHEENABLED:{
		EnableEd_Buffer_t *buf =(EnableEd_Buffer_t *)arg;
		WriteCacheEnable = buf->val.bEnabled;
		//SetWriteCacheEnabled(WriteCacheEnable);
		return(0);
		}
	
	case IOCTL_FASTTRAK_GETWRITECACHEENABLED:{
		EnableEd_Buffer_t *buf =(EnableEd_Buffer_t *)arg;
		buf->val.bEnabled = WriteCacheEnable;
		return(0);
		}
		
	case IOCTL_FASTTRAK_SETHOTSPARESENABLED:{
		EnableEd_Buffer_t *buf =(EnableEd_Buffer_t *)arg;
		SetHotSpareStaus(buf->val.bEnabled);
		return(0);
		}

	case IOCTL_FASTTRAK_GETHOTSPARESENABLED:{
		EnableEd_Buffer_t *buf =(EnableEd_Buffer_t *)arg;
		buf->val.bEnabled = GetHotSpareStaus();
		return(0);
		}

	case IOCTL_FASTTRAK_SETHOTSWAPENABLED:{
		EnableEd_Buffer_t *buf =(EnableEd_Buffer_t *)arg;
		SetHotSwapStaus(buf->val.bEnabled);
		return(0);
		}

	case IOCTL_FASTTRAK_GETHOTSWAPENABLED:{
		EnableEd_Buffer_t *buf =(EnableEd_Buffer_t *)arg;
		buf->val.bEnabled = GetHotSwapStaus();
		return(0);
		}

/*	case IOCTL_FASTTRAK_SETAUTODUPEDATAENABLED:{
		EnableEd_Buffer_t *buf =(EnableEd_Buffer_t *)arg;
		//(buf->val.bEnabled);
		return(0);
		}

	case IOCTL_FASTTRAK_GETAUTODUPEDATAENABLED:{
		EnableEd_Buffer_t *buf =(EnableEd_Buffer_t *)arg;
		//buf->val.bEnabled = ();
		return(0);
		}*/

	case IOCTL_FASTTRAK_SETALARMBUZZERENABLED:{
		EnableEd_Buffer_t *buf =(EnableEd_Buffer_t *)arg;
		AlarmBuzzerEnabled = buf->val.bEnabled;	
		//added by isaac for alarm buzzer
		{
		   int i;
		   for(i=0; i<(PTIAdapter*MAX_ARRAY_PER_CARD); i++)
		   {
		       if(aryDef[i].blFlag & blVALID_LUN)
		       {
			 if((aryDef[i].blFlag & blRECOVERING_LUN) || !(aryDef[i].blFlag & blWORKING_LUN))
			 {
			  if(p_evMaintenanceEvent[i] == NULL)
			  {
			  //        printk("<1>No Maintenance event\n");
				  buzzer_on();   
			  }	  
			  else if(p_evMaintenanceEvent[i]->bFunction != bRECONSTRUCT_STREAM)                          {
			  //   printk("<1>Function=%x\n",p_evMaintenanceEvent[i]->bFunction);	  
	                     buzzer_on();
			  }
			 }			  
		       }
		      //added by isaac for conversion disk offline  
	               if(p_evMaintenanceEvent[i] != NULL)
		       {
		         if(p_evMaintenanceEvent[i]->bFunction == bCONVEXP_RAID)
		         {
		               if((aryDef1[i].blFlag & blRECOVERING_LUN) || !(aryDef[i].blFlag & blWORKING_LUN))	       
			       {
			          buzzer_on();
			       }
		          }
		       }
		       
		   } 
		}
		return(0);
		}

	case IOCTL_FASTTRAK_GETALARMBUZZERENABLED:{
		EnableEd_Buffer_t *buf =(EnableEd_Buffer_t *)arg;
		buf->val.bEnabled = AlarmBuzzerEnabled;
		return(0);
		}

	case IOCTL_FASTTRAK_GETREADTHRESHOLD:{
		StructNUMBER *buf = (StructNUMBER *)arg;
		 buf->number= GetReadThreshold();
		return(0);
		}

	case IOCTL_FASTTRAK_GETWRITETHRESHOLD:{
		StructNUMBER *buf = (StructNUMBER *)arg;
		 buf->number= GetWriteThreshold();
		return(0);
		}

	case IOCTL_FASTTRAK_SETREADTHRESHOLD:{
		Io_Buffer_t *buf = (Io_Buffer_t *)arg;
		buf->ReturnCode=SetReadThreshold(buf->val);
		return(0);
		}

	case IOCTL_FASTTRAK_SETWRITETHRESHOLD:{
		Io_Buffer_t *buf = (Io_Buffer_t *)arg;
		buf->ReturnCode=SetWriteThreshold(buf->val);
		return(0);
		}

	case IOCTL_FASTTRAK_GETSUBMITCHANNELTHRESHOLD:{
		StructNUMBER *buf = (StructNUMBER *)arg;
		 buf->number= GetSubmitChannelThreshold();
		return(0);
		}

	case IOCTL_FASTTRAK_SETSUBMITCHANNELTHRESHOLD:{
		Io_Buffer_t *buf = (Io_Buffer_t *)arg;
		buf->ReturnCode=SetSubmitChannelThreshold(buf->val);
		return(0);
		}

	case IOCTL_FASTTRAK_GETWRITEMODE:{
		StructNUMBER *buf = (StructNUMBER *)arg;
		buf->number = GetWriteMode();
		return(0);
		}

	case IOCTL_FASTTRAK_SETWRITEMODE:{
		Io_Buffer_t *buf = (Io_Buffer_t *)arg;
		buf->ReturnCode=SetWriteMode(buf->val);
		return(0);
		}

	case IOCTL_FASTTRAK_RENAMEARRAY:{
		StrRenameArray_Buffer_t *buf = (StrRenameArray_Buffer_t *)arg;
		int ret;
		ret = blRenameArray(buf->val.arrayid,buf->val.ArrayName);
		buf->ReturnCode = ret;
		return(0);
		}

	case IOCTL_FASTTRAK_CLEARLOG:{
		StructNUMBER *buf = (StructNUMBER *)arg;
		ClearLogEvent();
		buf->number = TRUE;
		return(0);
		}
//modified by isaac for BBM
	case IOCTL_FASTTRAK_CHECKBATTERYBACKMODULE:{
		StructIOCTLBBM *buf = (StructIOCTLBBM *)arg;
		buf->ReturnCode = CheckBatteryBackmodule((U8)(buf->AdapterId));
		return(0);
		}

	case IOCTL_FASTTRAK_CHECKBATTERYPACK:{
		StructIOCTLBBM *buf = (StructIOCTLBBM *)arg;
		buf->ReturnCode = CheckBatteryPack((U8)(buf->AdapterId));
		return(0);
		}

	case IOCTL_FASTTRAK_GETCHARGESTATUS:{
		StructIOCTLBBM *buf = (StructIOCTLBBM *)arg;
		buf->ReturnCode = InquiryChargeStatus((U8)(buf->AdapterId));
		return(0);
		}

	case IOCTL_FASTTRAK_GETCHARGECYCLE:{
		StructIOCTLBBM *buf = (StructIOCTLBBM *)arg;
		buf->ReturnCode = InquiryChargingCycle((U8)(buf->AdapterId));
		return(0);
		}

	case IOCTL_FASTTRAK_GETBATTERYTEMPERATURE:{
		StructIOCTLBBM *buf = (StructIOCTLBBM *)arg;
		buf->ReturnCode = InquiryBatteryTemperature((U8)(buf->AdapterId));
		return(0);
		}

	case IOCTL_FASTTRAK_GETBATTERYVOLTAGE:{
		StructIOCTLBBM *buf = (StructIOCTLBBM *)arg;
		buf->ReturnCode = InquiryBatteryVoltage((U8)(buf->AdapterId));
		return(0);
		}
//end	
	case IOCTL_FASTTRAK_GETDIMMSIZE:{
		StrDriverVersion *buf = (StrDriverVersion *)arg;
		if(buf->version_length)
			buf->timestamp_length = ptiDimmSize[1]*1024*1024; 
		else
			buf->timestamp_length = ptiDimmSize[0]*1024*1024; 
		return(0);
	}
	case IOCTL_FASTTRAK_PTIBUFFLUSH:{
		call_pti_buf_flush();
		return(0);
	}
//added by isaac for array status monitor daemon
        case IOCTL_FASTTRAK_DAEMONSLEEP:{
        StructIOCTLARRAYDAEMON *buf = (StructIOCTLARRAYDAEMON *)arg;
#if LINUX_VERSION_CODE>KERNEL_VERSION(2,3,0)
	interruptible_sleep_on(&Wait0);
#else
	interruptible_sleep_on(&WaitQ);
#endif
        if(DaemonNeedUnload) return (-1);
       // printk("<1>FlagArrayOffline=%x, FlagArrayNeedRefresh=%x\n", FlagArrayOffLine, FlagArrayNeedRefresh);
       //printk("<1>NumOfArrayOffLine=%x,NumOfArrayNeedRefresh=%x\n",NumOfArrayOffLine, NumOfArrayNeedRefresh);
	if(FlagArrayOffLine)
         {
           buf->AdapterId = NumOfArrayOffLine;
           FlagArrayOffLine = 0;
           return(1);
         }
        if(FlagArrayNeedRefresh)  
        {
           buf->AdapterId = NumOfArrayNeedRefresh;
           FlagArrayNeedRefresh = 0;
           return(0);
        }
}     
//Label_bp begin
#ifdef 	HPQ_BACKPLANE
case IOCTL_FASTTRAK_PAMIDENTIFYDRIVE:
			{ 	U8 	bCh;
				U8  enable;

				extern void PAMIdentifyDrive( U8 bCh, U8 enable );

				// I just borrow the DELETE_ARRAY_FRAME;
				// Use bPhysIndex as the channel number while dwStatus as the enable.
				IOCTL_FASTTRAK_DELETE_ARRAY_FRAME *buf =
				(IOCTL_FASTTRAK_DELETE_ARRAY_FRAME*) arg;
				// Change to per card channel number.
				bCh=buf->bPhysIndex;
				enable = (U8)(buf->dwStatus);

				PAMIdentifyDrive(bCh, enable);

				buf->dwStatus = TRUE;
				return (0);
			}
#endif
case IOCTL_FASTTRAK_SET_SMARTERROR:
		{ U8 bCh;
		 // U8 bID;
		 int uStatus;

		  IOCTL_FASTTRAK_SET_SMARTERROR_FRAME *buf =
		 (IOCTL_FASTTRAK_SET_SMARTERROR_FRAME*) arg;

		  bCh = buf->bCh;
		 // bID = 0;
                 uStatus = buf->dwStatus;
		 if(uStatus == 2)
		 {   SmartStatus[bCh][0]=SMART_ERROR;
		     CheckStatusLEDChange(bCh,0,TRUE);
              }     
		 else
		 SmartStatus[bCh][0]==SMART_OK;	
    	  return (0);
}
//Label_bp end
//end    
	default :
	   //printk("fasttrak_ioctl not support the fun (%#x).\n",req);
	   return(-1);
   }
}




/********************************************************************
* Function: input_data
* Desc:
	get identify data of device
	
********************************************************************/	
	
int input_data(unchar dev,void *buffer,unsigned wcount)
{
   ushort *ptr=(ushort *)buffer;   
   while(wcount--) {
	ReadIDEIndexUshort(gAdapterConfigInfo.ATABaseAddress[dev/8],(dev%8)/2,0,ptr);
/*	printk("%x--",*ptr);
	if(wcount%8==0) printk("\n");
*/
	ptr++;
   }
   return(0);
}


/*********************************************************************
 * Function:
 *   unchar identify_device(unchar dev,void *id)
 *
 * Return:
 *   0 	success
 *   1	select time out
 *   2	identify_device(unchar dev,void *id)
*********************************************************************/
unchar identify_device(unchar dev,void *id)
{
   U32	i;
   U8	status=0;
   U8	error = 0xFF ;
   PTI_drive_t *drive=&PTI_drive[dev];
	
   for( i=0 ; i <= 1000 ; i++ ) {	// Confirm drive is non-busy
	ReadIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[dev/8],(dev%8)/2,iNDEXIDEAlternateStatus,&status) ; 
	if ( (status == 0x7f)||(status == 0x00)) continue;
	if( !( status & 0x80 ) )	// BSY=0 
	//   printk("<1>dev=%d, status=%x\n",dev, status);
		break;
	PTI_udelay(1000);
  }
  if( i > 1000 ) 
     return(1);	// drive[] not exist
     
   drive->identify=(PTI_driveid_t *)id;
   WriteIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[dev/8],(dev%8)/2,iNDEXIDEDeviceHead,0xa0);
   for( i=0 ; i <= 100 ; i++ ) {	
	ReadIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[dev/8],(dev%8)/2,iNDEXIDEAlternateStatus,&status) ; 
	if( ( status & 0xD0 ) == 0x50 )		// BSY=0, DRDY=1
	   break;
	PTI_udelay(100);
  }
  if( i >= 100 ) 
     return(1);	// drive[] not exist
 
   status=0;
   DisableInt();

   WriteIDEIndexUchar( gAdapterConfigInfo.ATABaseAddress[dev/8],(dev%8)/2,iNDEXIDEDeviceHead,0xa0) ;
   WriteIDEIndexUchar( gAdapterConfigInfo.ATABaseAddress[dev/8],(dev%8)/2,iNDEXIDECommand,0xEC) ;
   for( i=0 ; i <= 1000 ; i++ ) {	// wait response : 100 ms
	PTI_udelay(100);
	ReadIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[dev/8],(dev%8)/2,iNDEXIDEAlternateStatus,&status) ; 
	if( (status & 0xD0) == 0x50 )	{	// BSY=0 DRDY=1
	   ReadIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[dev/8],(dev%8)/2,iNDEXIDECommand,&status) ; 
   	   input_data(dev,id,512/2);
	   drive->present=1;
	   
	   error = 0 ;
	   break;
	}
   }

//add for supporting 48bit LBA
	if(drive->identify->UDMACommandSupport2&0x4000){
		if(drive->identify->UDMACommandSupport2&0x0400){
			DiskInfo[dev/8][dev/2][dev%2].bSupport48bitLBA=1;
		}
		else
			DiskInfo[dev/8][dev/2][dev%2].bSupport48bitLBA=0;
	}
//end supporting 48bit LBA

   EnableInt();
   return(error);
}

/*********************************
Function: init_ioport
Desc: Initialize I/O port
      fetch base address

*********************************/
U16 init_ioport(int ada)
{
   U8 bus=gAdapterConfigInfo.bus_num[ada];
   //PTI_adapter_t 	*adapter = &PTI_adapter[0] ;
   U8 devfn=gAdapterConfigInfo.devfn[ada];
   U32 base[6];
   U32 ldata,lwindows;   //added by isaac for window size
   ushort uc,command;
//   pcibios_read_config_byte(bus,devfn,PCI_INTERRUPT_LINE,&gAdapterConfigInfo.IRQ[0]);
   for( uc = 0 ; uc < 5 ; uc++ ) {
     pcibios_read_config_dword(bus,devfn,PCI_BASE_ADDRESS_0+4*uc,(unsigned int *)&base[uc]);
     base[uc] = base[uc] & PCI_BASE_ADDRESS_IO_MASK ;
   }

 

   gAdapterConfigInfo.ATABaseAddress[ada] = base[0] ;
   gAdapterConfigInfo.XORBaseAddress[ada] = base[1] ;
   gAdapterConfigInfo.SEQBaseAddress[ada] = base[2] ;
   //added by isaac for window size
   ReadChipControlIndex(base[1], 0, 0x08, &ldata);
   ldata &= 0x03;
   //printk("<1>ldata =%d\n",ldata);
   switch (ldata)
   {
	   case 0:
		   lwindows = 0x8000;
		   break;
	   case 1: lwindows = 0x10000;
         	   break;
	   case 2: lwindows = 0x20000;
		   break;
           default:
	           lwindows = 0x200000;
	           break;
   }
   gAdapterConfigInfo.bSDRAMWindowsSize[ada] = (U8)ldata;
//end    
   gAdapterConfigInfo.MMIOBaseAddress[ada] =(U32)ioremap(base[3],0x100000);
   gAdapterConfigInfo.SDRAMBaseAddress[ada]=ioremap(base[4],lwindows);  //0x100000);

 
   pcibios_read_config_word(bus,devfn,PCI_COMMAND,&command);
   command |= PCI_COMMAND_MASTER | PCI_COMMAND_MEMORY;
   pcibios_write_config_word(bus,devfn,PCI_COMMAND,command);
//   printk("gAdapterConfigInfo.IRQ[0] = %d\n",gAdapterConfigInfo.IRQ[0]);
   if( request_irq(gAdapterConfigInfo.IRQ[ada],PTI_handler_wrapper,SA_INTERRUPT | SA_SHIRQ,"FastTrak","FastTrak")) {
	   printk("FastTrak : adapter request_irq() error.\n");
	   return(2);
   }	

   return(0);
}


/******************************
Function: WaitInitRaid
Desc:	Waiting for BufferInit finished.

*******************************/
void WaitInitRaid(ulong dev)
{
	if(blConfigDoneFlag!=TRUE){
	        init_timer(&InitRAID_Timer);
		InitRAID_Timer.expires=PTI_get_jiffies()+1*HZ;
		InitRAID_Timer.data=dev;
		InitRAID_Timer.function=WaitInitRaid;
		add_timer(&InitRAID_Timer);
		return;
	}

#if LINUX_VERSION_CODE>KERNEL_VERSION(2,3,0)
        wake_up(&Wait0);
#else
        wake_up(&WaitQ);
#endif
	return;
}
void WaitBufFlush(ulong dev)
{
	int i;
	i=buf_flush();
	if(i!=0){
	        init_timer(&InitRAID_Timer);
		InitRAID_Timer.expires=PTI_get_jiffies()+1*HZ;
		InitRAID_Timer.data=0;
		InitRAID_Timer.function=WaitBufFlush;
		add_timer(&InitRAID_Timer);
		return;
	}

#if LINUX_VERSION_CODE>KERNEL_VERSION(2,3,0)
        wake_up(&Wait0);
#else
        wake_up(&WaitQ);
#endif
	return;
}

//added by isaac for array status daemon
void NotifyArrayOffLine(void)
{
    FlagArrayOffLine = 1;
#if LINUX_VERSION_CODE>KERNEL_VERSION(2,3,0)
        wake_up(&Wait0);
#else
        wake_up(&WaitQ);
#endif
          
        return;
}

void NotifyArrayNeedRefresh(void)
{
    FlagArrayNeedRefresh = 1;
#if LINUX_VERSION_CODE>KERNEL_VERSION(2,3,0)
        wake_up(&Wait0);
#else
        wake_up(&WaitQ);
#endif
          
        return;
}
//end

int set_feature(unchar dev,unchar *pio_mode,unchar *dma_mode,unchar *udma_mode)
{
   PTI_drive_t 		*drive 	= &PTI_drive[dev];
   struct PTI_driveid	*id	= drive->identify;
   unchar 		status;
   ushort 		mode; 
   ulong 		i,lData; //modified by isaac for bug
   unchar 		xfermode=0;

  
   DisableInt();	
  //added by isaac for set_feature problem according to edl's advice
   for(i=0; i<20001; i++){
	ReadIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[dev/8],(dev%8)/2,iNDEXIDECommand,&status);
   	if( ! (status & 0x88) ) 
		break;
        PTI_udelay(100);
   }

   if(i>=20000)
   {
      		printk("ide: Promise, Ultra status is %x .\n",status);
                return 1;
   } 
  //end	
    WriteIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[dev/8],(dev%8)/2,iNDEXIDEDeviceHead,(U8)(((dev&0x03)<<04)|0xA0));
   for(i=0;i<20001;i++) {
   	PTI_udelay(100); 		      	
	ReadIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[dev/8],(dev%8)/2,iNDEXIDECommand,&status);
   	//isaac added for sata
	if((status == 0x7f)||(status == 0x00)) continue; 
	if( ! (status & 0x80) ) 
		break;
	else if( i == 20000 )
      		printk("ide: Promise, Ultra device is busy .\n");
   }

   WriteIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[dev/8],(dev%8)/2,iNDEXIDEFeature,0x02); 
   WriteIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[dev/8],(dev%8)/2,iNDEXIDECommand,IDE_COMMAND_SET_FEATURES);

   for(i=0;i<10000;i++) {
	ReadIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[dev/8],(dev%8)/2,iNDEXIDECommand,&status);
   	if(status & 0x80) {
	   //printk("busy..");
	   PTI_udelay(1000);
	}
	else break;
   }

	


   //	--- UDMA & DMA transfer mode
   if( id->capability & 1) {
 	if( (id->field_valid & 4) && (mode=(id->dma_ultra & 0x00FF)) ) {
		//ushort	deviceid = drive->pchannel->padapter->deviceid ;
		mode=mode>>1;
		while(mode) { 	// --- UDMA transfer mode
			xfermode++;
			mode=mode>>1;
		}
		if(xfermode>5) xfermode=5; //not support UDMA6 and upper
		*udma_mode = xfermode ;
		xfermode = 0x40 | *udma_mode ;
	}
	else if( (id->field_valid & 2) && (mode=(id->dma_mword & 0x000F)) ) {
		mode=mode>>1; 
		while(mode) {	// --- MDMA transfer mode
			xfermode++;
			mode=mode>>1;
		}
		*dma_mode = xfermode ;
		xfermode = 0x20 | *dma_mode ;
	}
   }

//Check 80/40 pin:
   ReadIDEIndex(gAdapterConfigInfo.ATABaseAddress[dev/8],(dev%8)/2,iNDEXIDECICR,lData);		
   if(*((UCHAR *)&lData+3) & 0x01) {
	printk("40 pin cable used, please change it\n");
	xfermode &=0xf0;
   }
   PTI_drive[dev].xfermode=xfermode;


   WriteIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[dev/8],(dev%8)/2,iNDEXIDEFeature,0X03);
   WriteIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[dev/8],(dev%8)/2,iNDEXIDESectorCount,xfermode);
   WriteIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[dev/8],(dev%8)/2,iNDEXIDEDeviceHead,(U8)(((dev&0x03)<<04)|0xA0));
   WriteIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[dev/8],(dev%8)/2,iNDEXIDECommand,IDE_COMMAND_SET_FEATURES);
	

   for(i=0;i<20000;i++) {
	ReadIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[dev/8],(dev%8)/2,iNDEXIDEAlternateStatus,&status);
	if(status & 0x80){
		//printk("busy--------");
		PTI_udelay(100);
	}
	else {
		ReadIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[dev/8],(dev%8)/2,iNDEXIDECommand,&status);
		break;
	}
   }
   
   if( i >= 20000 ) {	
	printk("FastTrak : PROMISE Set_Feature time out.\n");
        EnableInt();
	return(1);
   }
   EnableInt();
   // get new inquiry data after set feature for data structure
   if( identify_device(dev,PTI_drive[dev].identify) ) {	
   	printk("FastTrak: Set Feature Fail.(Drive%d)\n",dev+1);
   	return(1);
   }

     return(0);
}

/*********************************************************************
 * Function:
 *   int PTI_proc_info(char *, char **, off_t, int, int, int)
 *
 * Description:
 *   in user space , user can view "/proc/scsi/FastTrak/x" 
 *   to run PTI_proc_info() in kernel space.
 * PS: 
 *   the rebuilding information reported under the condition of
 *   one MIRROR array , not support two MIRROR array concurrently.
*********************************************************************/
int PTI_proc_info(char *buffer, char **start, off_t offset,
			int length, int hostno, int func)
{
   static char	mybuf[4000] ;
   int		size ;
   static char	StopFlag = 0 ;
   unsigned long pti_smp_flag;

   if( StopFlag-- )	return(0);
  /*
   *	below is general information about 
   *		- Adapter
   *		- Array
   *		- Drive
   *		- SwapBox
   */
  
   if(offset != 0) 
   	return 0;
   spin_lock_irqsave(&PTI_adapter[0].pti_lock,pti_smp_flag);
   size = GetProcInfo(PAGE_SIZE-100,(char *)&mybuf);   // PAGE_SIZE = 1024 * 4
   //modified by isaac for PROC 03-08-14	
   if(size <= length)
   	memcpy(buffer,mybuf,size);	   
   spin_unlock_irqrestore(&PTI_adapter[0].pti_lock,pti_smp_flag);

   if(start){
  	*start = buffer;
   }	
   //end
   StopFlag = 1;
   
	return(size);		// Two Drives , total size about 1950
}

/**********************************
Function: SetWriteCacheEnabled
Desc: To Set writecache enable or disable
parameter list:
   enabled:		1      enable
   				0	   disable	

***********************************/
int SetWriteCacheEnabled(int enabled)
{
	unchar	status;
	unsigned char enablecommand;
	int i,dev;  //modified by isaac for bug

	if (enabled)
		enablecommand = 0x02;
	else
		enablecommand = 0x82;
for(dev = 0;dev<PTI_Max_Dev;dev ++)
  {
  	WriteIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[dev/8],(dev%8)/2,iNDEXIDEDeviceHead,(U8)(((dev&0x03)<<04)|0xA0));
   	for(i=0;i<20001;i++)
   		{
   		PTI_udelay(100); 		      	
		ReadIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[dev/8],(dev%8)/2,iNDEXIDECommand,&status);
   		if( ! (status & 0x80) )
			break;
		else if( i == 20000 )
    		printk("ide: Promise, Ultra device is busy .\n");
   		}

 	  WriteIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[dev/8],(dev%8)/2,iNDEXIDEFeature,enablecommand);
   	WriteIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[dev/8],(dev%8)/2,iNDEXIDECommand,IDE_COMMAND_SET_FEATURES);
	}
	return 0;
}

/***********************************************************
 * Function:
 *   fasttrak_bios_param
 *
 * Description:
 *   This function returns unit geometry in cylinders/heads/sectors
***********************************************************/
int fasttrak_bios_param(Disk *disk, kdev_t dev, int Geometry[])
{
   Geometry[0]=64;  		// heads
   Geometry[1]=32;  		// sectors
   Geometry[2]=disk->capacity / (Geometry[0]*Geometry[1]);  // cylinders
 
   if (disk->capacity > 0x200000) {	// 1GB
  	Geometry[0]=255;	// heads
  	Geometry[1]=63;  	// sectors
  	Geometry[2]=disk->capacity/(Geometry[0]*Geometry[1]); // cylinders
 
	// capacity larger than 526GB(C/H/S = 65535/255/63)
  	if (Geometry[2] > 65535) {
   	   Geometry[2] = 65535;
   	   Geometry[1] = disk->capacity / (Geometry[2]*Geometry[0]);
  	}  
   }
 
   return 0;
}
/**********************************
Function: ptisx_ioctl
Desc: Ioctl interface
	command list:

***********************************/
int ptisx_ioctl(Scsi_Device *device,int cmd,void *arg)
{
   return 0;
}


//extern BOOLEAN InitSDRAMController_62X(void);
//extern UCHAR   CheckMultipleChip_62x(void);
extern unsigned long wFreeLocalPoolSize[MAX_ADAPTER];
/*********************************************************************
 * Function:
 *   fasttrak_detect
 *
 * Description:
 *   Try to detect , initialize and register an FastTrak adapter.
 *   Return non-zero number on detection.
 *   The driver only support one FastTrak adapter now.
*********************************************************************/
int ptisx_detect(Scsi_Host_Template *template) {
   ushort class,result;
   U16 dev,i;
   struct Scsi_Host *shpnt;
   //U32 	lSysMemSize;
   int	Speed, Size ;
#if LINUX_VERSION_CODE>=KERNEL_VERSION(2,4,0)
	struct pci_dev *ft_pci_dev=NULL;
#else
	struct pci_dev *ft_pci_dev=pci_devices;
#endif	

   template->proc_dir=&proc_scsi_PTI;
   template->proc_info=PTI_proc_info;
	
  /*	
   *	Initial Global Data Structure : 
   *		PTI_adapter[PTI_Max_Ada]
   *		PTI_channel[PTI_Max_Ch]
   *		PTI_drive[PTI_Max_Dev]
   */
   
   
   /*{
	   ULONG i;
	   i = jiffies + 1000;
	   while(jiffies < i)
	   {
		schedule();
	   }
   }*/	   
   
   if( InitGDS() ) {	// Linus Chen
   	printk("<1>FastTrak: Initial Global Data Structure fail.\n");
   	return(0);
   }
   Initialization();

  /*	
   *	Find Adapter :
   *		1. find controller
   *		2. request ioports and irq , and then fill out structure
   */	
   class=0;
   while(PTI_DEVID[class]){
	while ((ft_pci_dev=pci_find_device(PCI_VENDOR_ID_PROMISE,PTI_DEVID[class],ft_pci_dev))){
	   //PTI_adapter_t *pada=&PTI_adapter[PTIAdapter];
	   if(ft_pci_dev->class>>8==0x0104){	
		if(PTIAdapter>=PTI_Max_Ada){
			printk("<1>Too many cards presents\n");
		        
			//modified by isaac for alarm buzzer
                        if(AlarmBuzzerEnabled) buzzer_on();
			
			return(PTIAdapter);
		}
		if ( DID621 == PTI_DEVID[class]) {
			FastTrakAdapterType[PTIAdapter] = RAINMAKER_621;
		}
	        else if ( DID622 ==PTI_DEVID[class]) {
			FastTrakAdapterType[PTIAdapter] = RAINMAKER_622;
		}
		gAdapterConfigInfo.bus_num[PTIAdapter]=ft_pci_dev->bus->number;
		gAdapterConfigInfo.devfn[PTIAdapter]=ft_pci_dev->devfn;
		PTI_adapter[PTIAdapter].deviceid=PTI_DEVID[class];
		PTI_adapter[PTIAdapter].present=1;
		PTI_adapter[PTIAdapter].irq=ft_pci_dev->irq;
		gAdapterConfigInfo.IRQ[PTIAdapter]=ft_pci_dev->irq;
		PTIAdapter++;	
	   }
	}
	class++;
   }
   
   //modified by isaac for SX150 support
   printk("<1>Promise %s Linux Driver " VERSION " " VERDATE "\n", FastTrakAdapterName[FastTrakAdapterType[0]]);
   template->name = FastTrakAdapterName[FastTrakAdapterType[0]];
   
   DBO(printk("<1>ptisx_detect: PTIAdapter=%d\n",PTIAdapter));
   if(!PTIAdapter){
	printk("<1>Promise card is not exist!\n");
	return 0;
   }
   /* INIT ioport  */
   for(i=0;i<PTIAdapter;i++){
		if(init_ioport(i)){
			printk("Init ioport error! \n");
			return 0;
		}
   
		if( InitSX4000LocalDIMM(i,&Speed,&Size) ) {	// Linus Chen
			
			printk("<1>Init %s Local DIMM Fail !! \n", FastTrakAdapterName[FastTrakAdapterType[i]]);
		   
			//modified by isaac for alarm buzzer
			if(AlarmBuzzerEnabled) buzzer_on();
			return 0;
		}
		printk("<1>FastTrak: Installed %s Local DIMM - %dMB",FastTrakAdapterName[FastTrakAdapterType[i]], Size);
	    printk("%s\n",( Speed == 100 ) ? "" : ".." );

        //Label_bp begin
	  //	CAM_InitSBOX((U8)i);
	     InitEnclosure();
	    //Label_bp end

		ptiDimmSize[i]=Size;
   }	
	    /* Init RAID Engine */
	//	lSysMemSize=GetSysMemNeeded()+0x400;
		ENGINE = (unchar *) vmalloc((wVIR_BUFFER_SIZE)+4);
	//	ENGINE = (unchar *) __get_free_pages(GFP_ATOMIC|GFP_DMA, 6); // 6(0x4000 bytes)
		PBM_MEM = (unchar *) vmalloc(wVIR_PBM_BUFFER_SIZE);
	//	PBM_MEM = (unchar *) __get_free_pages(GFP_ATOMIC, 6); // 6(0x4000 bytes)
	        DBO(printk("<1>ptisx_detect:ENGINE=%lx, PBM_MEM=%lx \n",ENGINE, PBM_MEM));
		if(!ENGINE) {
			printk("<1>FastTrak : System does not allocate ");
			printk("enough memory to FastTrak !!\n");
		   
			//modified by isaac for alarm buzzer
                        if(AlarmBuzzerEnabled) buzzer_on();
		
			return(0);
		}
	    if(!PBM_MEM) {
			printk("<1>FastTrak : System does not allocate ");
			printk("enough memory to FastTrak !!\n");
		        
			//modified by isaac for alarm buzzer
                        if(AlarmBuzzerEnabled) buzzer_on();
			
			return(0);
		}
	    //memset(ENGINE,0,lSysMemSize);
	//   	memset(ENGINE,0,0x40000);
	//    	memset(PBM_MEM,0,0x40000);
                memset(ENGINE,0,(wVIR_BUFFER_SIZE)+4);
		memset(PBM_MEM,0,wVIR_PBM_BUFFER_SIZE);


#if 0
//set PLL's timing
{
	U32 tmpData;
	ReadChipControlIndex(gAdapterConfigInfo.XORBaseAddress[0],0, 0x08, &tmpData);
	tmpData &=0x00ffffff;
	tmpData |=0x8c000000;
	WriteChipControlIndex(gAdapterConfigInfo.XORBaseAddress[0], 0, 0x08, tmpData);
}
#endif
   
	
   shpnt = scsi_register(template,sizeof(struct pti_st_host));
   pti_st_hostp=(struct pti_st_host *)shpnt->hostdata;
   shpnt -> max_channel = 0 ;		// channel: primary 
   shpnt -> max_id = 8 ;		// dev : array[0-3]
   shpnt -> max_lun = 1 ;		// one device
   if(PTIAdapter==2){
	struct Scsi_Host	*shpnt2;
	shpnt2=scsi_register(template,sizeof(struct pti_st_host));
	shpnt2 ->max_channel=0;
	shpnt2 ->max_id =0;
	shpnt2 ->max_lun=0;
   }

   /* find device  set feature of device*/	
   for( dev = 0 ; dev < PTI_Max_Dev; dev++ ) {
	unchar  	pio, dma, udma;
	PTI_drive_t	*drive = &PTI_drive[dev];
	//added by isaac for dualcard
	if( (PTIAdapter == 1) && (dev > 7))
	{
	   PTI_drive[dev].present=0;
           continue;	   
	}
	   if(dev%2) {
	   PTI_drive[dev].present=0;
	   continue;
	}
	drive->identify = kmalloc(512,GFP_ATOMIC);
	result = identify_device(dev,drive->identify) ;
//	printk("<1>ptisx_detect:dev=%d, result=%x\n",dev, result);
	if( dev%2 == 1 ) {		// release unused I/O ports
	   if(PTI_drive[dev-1].present == 0) {
		if(PTI_drive[dev].present == 0) {
   		   WriteIDEIndexUchar(gAdapterConfigInfo.ATABaseAddress[0],dev/2,iNDEXIDEDeviceHead,0xA0);
	}  } 	}
	if( result==1 || result==2 ) 
	   continue;	// drive not exist
	DEB(printk("FastTrak : Drive[%d] Exist.\n",dev););
	pio = dma = udma = 0xFF;
	if( set_feature(dev,&pio,&dma,&udma) )	
	   return(0);
	ReadingReservedSector++;
   }

   memset(p_QueueHead,0,sizeof(bpQ)*MAX_QUEUE_SUPPORTED);	

   // Linus Chen: PBM Data cache = 3.5MB (match with buf_init() in isr.c)
//    bInitRAID(bPOWER_UP, 0x380000, ENGINE, PBM_MEM, NULL, (wFreeLocalPoolSize[0]-0x380000), (wFreeLocalPoolSize[1]-0x380000), (wVIR_BUFFER_SIZE)+4, wVIR_PBM_BUFFER_SIZE, wMIN_NON_PAGED_BUFFER_SIZE);
    {
        U32 p1 = wFreeLocalPoolSize[0]-0x380000;
        U32 p2 = wFreeLocalPoolSize[1]-0x380000;
        U32 v1 = (wVIR_BUFFER_SIZE)+4;
        U32 v2 = wVIR_PBM_BUFFER_SIZE; 	
        //added by isaac for dualcard
        if(PTIAdapter == 1) p2 = wFreeLocalPoolSize[1] = 0;
        //printk("<1>ptisx_detect: p1=%lx,p2=%lx,v1=%lx,v2=%lx\n",p1,p2,v1,v2);
	bInitRAID(bPOWER_UP,0x380000,ENGINE,PBM_MEM,NULL,p1,p2,v1,v2,0);	
    }	
//	bInitRAID(bPOWER_UP,0x38,ENGINE,PBM_MEM,NULL,0x380,0x380,4,4,4);	

 //  buzzer_on();
   init_timer(&InitRAID_Timer);
   InitRAID_Timer.expires=PTI_get_jiffies()+1*HZ;
   InitRAID_Timer.data=dev;
   InitRAID_Timer.function=WaitInitRaid;
   add_timer(&InitRAID_Timer);
   #if LINUX_VERSION_CODE>KERNEL_VERSION(2,3,0)
	interruptible_sleep_on(&Wait0);
   #else
	interruptible_sleep_on(&WaitQ);
   #endif
   buzzer_off();
	DefDriveStruct();
{
	
		int i;
		 for(i=0;i<PTI_Max_Dev;i++){
			 //added by isaac for dualcard
			if( (PTIAdapter == 1)&&(i >= PTI_Max_Dev/2)) continue; 
			 CheckEnclosureIfDiskIdle(i/2,i%2);
		}
}

	
  /*
   *	Initialize SwapBox/PTI LED : 
   *		Drive Fail - red light
   *		Normal	   - green light
   *		Critical   - orange light
   */
   InitLED();
   InitQueueBuffer();
   return(PTIAdapter);		
}
/***********************************************************
 * Function:
 *   PTI_queuecommand
 *
 * Description:
 *   cmd - SCSI command.
 *   fn  - function called on completion.
***********************************************************/
extern int pti_do_queuecommand(ScsiEngReq_t *p);	
int ptisx_queuecommand(Scsi_Cmnd *cmd, void (*fn)(Scsi_Cmnd *))
{
   ScsiEngReq_t	CurScsiReq;
   ushort	us;
   int          iret;
   memset(&CurScsiReq,0,sizeof(ScsiEngReq_t));
   CurScsiReq.cmd = (void *)cmd ;
   CurScsiReq.fn  = (void *)fn ;
   CurScsiReq.target = cmd->target ;
//robert
//   CurScsiReq.target &=0x0f;
   DBO(printk("<1>ptisx_queuecommand: cmd->target=%x\n",cmd->target));
//   printk("<1>ptisx_queuecommand: cmnd=%x,cmd->target=%x\n",cmd->cmnd[0],cmd->target);
   CurScsiReq.use_sg = cmd->use_sg ;
   CurScsiReq.buffer = (unchar *)cmd->buffer ;
   CurScsiReq.sense  = (unchar *)cmd->sense_buffer ;
  // printk("scsi cmnd[0]=%x %x %x %x %x %x %x %x %x %x\n",cmd->cmnd[0],cmd->cmnd[1],cmd->cmnd[2],cmd->cmnd[3],cmd->cmnd[4],cmd->cmnd[5],cmd->cmnd[6],cmd->cmnd[7],cmd->cmnd[8],cmd->cmnd[9]);
   for( us=0 ; us < 12 ; us ++ )
   	CurScsiReq.cmnd[us] = cmd->cmnd[us] ;
   if(cmd->use_sg) {
	struct scatterlist *sgpnt;
	sgpnt = (struct scatterlist *) cmd->request_buffer;
	for( us=0 ; us < cmd->use_sg ; us++ ) {
   	   CurScsiReq.WStartAddr[us] = virt_to_bus(sgpnt[us].address) ;
   	   CurScsiReq.WCount[us]     = sgpnt[us].length ;
	}
	CurScsiReq.WCount[us] |= (1<<31);	// EOT=1
   }

   iret=pti_do_queuecommand( &CurScsiReq )  ;
   return iret;
}

/***********************************************************
 * Function:
 *   EndRequest(unchar id,int result)
 *
 * Description:
 *   End SCSI request and return to SCSI high/middle level
***********************************************************/
char EndRequest(void *cmnd,void *fun,int result) 
{
   Scsi_Cmnd	     *cmd  = (Scsi_Cmnd *)cmnd ;
   void	(*fn)(Scsi_Cmnd *) = (void *)fun ;
   cmd->result = result ;
   cmd->scsi_done = fn ;
   fn(cmd);
   DEB(printk("End SCSI request .\n"));
   return(0);
}
ulong wV2P(unchar *p_b,unchar *p_wCount)
{
   ulong	addr;

   DebEngFun(printk("DebEngFun : wV2P(0x%-lx)\n",(ulong)p_b););
   addr = virt_to_bus(p_b);
   return((ulong)cpu_to_le32(addr));
}
ulong wV2P2(unchar *p_b)
{
   ulong	addr;

   addr = virt_to_bus(p_b);
   return(addr);
}
void printinfo15(ByTE i)
{
}

BoOL bCheckATA5(ByTE bCh,ByTE bID)
{
	return FALSE;
}
BoOL blCheckSmartStauts(ByTE bCh,ByTE bID)
{
	return FALSE;
}
/***********************************************************
 * Function:
 *   ptisx_abort
 *
 * Description:
 *   cmd - SCSI command.
***********************************************************/
int ptisx_abort(Scsi_Cmnd *cmd)
{
   // This is called when a scsi cmnd timesout at the os level
   // Returning SCSI_ABORT_ERROR will cause the os to call our
   // reset routine. This is how miniport handles timeouts.
   printk("fasttrak_abort: returning SCSI_ABORT_ERROR\n");
   return SCSI_ABORT_ERROR;
}
int ptisx_abort_eh(Scsi_Cmnd *cmd)
{
   printk("ptisx_abort_eh: returning SCSI_ABORT_ERROR\n");
   return SCSI_ABORT_ERROR;	// 0x05
}


VOID ScsiPortStallExecution(IN ULONG Delay)
{

	if(Delay>1000){
		int i,iTime;
		iTime=Delay/1000;
		for(i=0;i<iTime;i++)
			PTI_udelay(1000);
	}
	else{
		PTI_udelay(Delay);
	}
}




/***********************************************************
 * Function:
 *   ptisx_reset
 *
 * Description:
 *   cmd - SCSI command.
 *   reset_flags - reset flags.
***********************************************************/
extern int reset_controller(void);
int ptisx_reset(Scsi_Cmnd *cmd, unsigned int reset_flags)
{
   printk("fasttrak_reset: returning SCSI_RESET_SUCCESS\n");
   reset_controller();
   return SCSI_RESET_SUCCESS;
}
int ptisx_reset_eh(Scsi_Cmnd *cmd)
{
   printk("ptisx_reset_eh: returning SCSI_RESET_SUCCESS\n");
   reset_controller();
   return SCSI_RESET_SUCCESS;	// 0x02
}

int blCheckSmartStatus(int bCh,int bID)
{
	return(0);
}
// -----------------------------------------------
unchar *p_P2V(ulong wAddr,ushort hCount)
{
   DebEngFun(printk("DebEngFun : p_P2V(0x%-lx)\n",wAddr););
   return((unchar *)bus_to_virt(wAddr));
}


/*added by isaac according to dingo's advice*/

static int power_off_notifier_func(struct notifier_block *pnb,unsigned long code, void *unused)
{
     shutdown_call_pti_buf_flush();
     return NOTIFY_DONE;
}

static struct notifier_block pti_power_off_nb={
	power_off_notifier_func, NULL, 0
};

/*end*/

#ifdef MODULE
#ifdef __SUSE__
MODULE_LICENSE("GPL");
#endif
Scsi_Host_Template driver_template = PTISX;
#include <linux/module.h>

int init_module(void)
{
	int major;
	driver_template.module = &__this_module;
	scsi_register_module(MODULE_SCSI_HA, &driver_template);
	if (!(driver_template.present)||
      		(major = register_blkdev(0, PTCNTL_DEV_NAME, (struct block_device_operations *)&pti_stdev_fops)) < 0)
 	{

		scsi_unregister_module(MODULE_SCSI_HA, &driver_template);
		return -ENODEV;
	}
	pti_st_hostp->major=major;
  	pti_st_hostp->counter = 0;
	ptiMajor=major;
	
 /*added by isaac according to dingo's advice */
        if(register_reboot_notifier(&pti_power_off_nb)){
		printk(KERN_ERR"pti_sx: Can not register power notifer notifer!\n");
		return -1;
          }        
 /*end */
        return 0;
        
}
//added by isaac for shutdown buf flush 03-08-15
void shutdown_call_pti_buf_flush(void)
{
	int 	i;
	int	count=0 ;
	i=buf_flush();
	while (i!=0){
		count++ ;
		if( !(count%5) )
		   printk("FastTrak: Waiting for flushing buffer ...\n");
		init_timer(&InitRAID_Timer);
		InitRAID_Timer.expires=PTI_get_jiffies()+1*HZ;
		InitRAID_Timer.data=0;
		InitRAID_Timer.function=WaitBufFlush;
		add_timer(&InitRAID_Timer);
#if LINUX_VERSION_CODE>KERNEL_VERSION(2,3,0)
		interruptible_sleep_on(&Wait0);
#else
		interruptible_sleep_on(&WaitQ);
#endif
		i=buf_flush();
	}
	del_timer(&submit_timer);
	return;
}
//end

void call_pti_buf_flush(void)
{
	int 	i;
	int	count=0 ;
	i=buf_flush();
	while (i!=0){
		count++ ;
		if( !(count%5) )
		   printk("FastTrak: Waiting for flushing buffer ...\n");
		init_timer(&InitRAID_Timer);
		InitRAID_Timer.expires=PTI_get_jiffies()+1*HZ;
		InitRAID_Timer.data=0;
		InitRAID_Timer.function=WaitBufFlush;
		add_timer(&InitRAID_Timer);
#if LINUX_VERSION_CODE>KERNEL_VERSION(2,3,0)
		interruptible_sleep_on(&Wait0);
#else
		interruptible_sleep_on(&WaitQ);
#endif
		i=buf_flush();
	}
	//removed by isaac for common buf flush 03-08-15
	//del_timer(&submit_timer);
	return;
}


void cleanup_module(void)
{
	int i,dev;

/*added by isaac for array status daemon
        DaemonNeedUnload = 1;

#if LINUX_VERSION_CODE>KERNEL_VERSION(2,3,0)
        wake_up(&Wait0);
#else
        wake_up(&WaitQ);
#endif
end */

       	//modified by isaac for Maintanance	
	for (i=0; i<ACTUAL_ARRAY_SUPPORTED; i++)
	{
		if((PTIAdapter == 1)&&(i >= MAX_ARRAY_PER_CARD)) continue;
		StopRebuild_Conversion(i);
	}
   {
	   ULONG i;
	   i = jiffies + 100;
	   while(jiffies < i)
	   {
		schedule();
	   }
   }	   
   //end

        unregister_reboot_notifier(&pti_power_off_nb); //added by isaac according to dingo's advice 
	shutdown_call_pti_buf_flush();

        vfree(ENGINE);
	vfree(PBM_MEM);
// 	free_pages((ulong)ENGINE, 6);
//	free_pages((ulong)PBM_MEM, 6);
	//added by isaac for memory leak
	for (dev=0; dev<PTI_Max_Dev/2; dev++)
	{
	    //printk("<1>PTI_drive[%d].identify=%lx\n",dev,PTI_drive[dev].identify);
	    if(dev%2) continue;	
	    if(PTI_drive[dev].identify) kfree(PTI_drive[dev].identify);
	}	    
	//end
	free_irq(gAdapterConfigInfo.IRQ[0],"FastTrak");
	iounmap((char *)gAdapterConfigInfo.MMIOBaseAddress[0]);
	iounmap((char *)gAdapterConfigInfo.SDRAMBaseAddress[0]);
	if(PTIAdapter == 2)
	{	
	 //added by isaac for memory leak
   	 for (dev=PTI_Max_Dev/2; dev<PTI_Max_Dev; dev++)
	 {
	    //printk("<1>PTI_drive[%d].identify=%lx\n",dev,PTI_drive[dev].identify);
	    if(dev%2) continue;	
	    if(PTI_drive[dev].identify) kfree(PTI_drive[dev].identify);
	 }	    
	 //end
	  free_irq(gAdapterConfigInfo.IRQ[1],"FastTrak");
	  iounmap((char *)gAdapterConfigInfo.MMIOBaseAddress[1]);
	  iounmap((char *)gAdapterConfigInfo.SDRAMBaseAddress[1]);
	}
	unregister_blkdev(ptiMajor,PTCNTL_DEV_NAME);
	scsi_unregister_module(MODULE_SCSI_HA, &driver_template);
}

//Label_bp begin

/* Xinhai: unused code removed since 1.0.70.20*/
/*void MapTargetIDIndex(IN UCHAR TargetID,OUT PUCHAR pbChannel,OUT PUCHAR pbID)*/



VOID MapIndex(IN  UCHAR bChannel,
	      IN  UCHAR bID,
	      OUT PUCHAR pAdapterNumber,
	      OUT PUCHAR pTargetID)
/*++

Routine Description:

   This routine convert the index of Raid Engine to OS and Channel Driver index

Arguments:

    bChannel       - channel number,

    bID            - ID Number, - Master or Slave

    pAdapterNumber - pointer to the Adapter Number, use to index

    pTargetID      - pointer to the TargetID


Return Value:

    None
--*/
{
 
   bID &= 0x01;

   
    if (bChannel>3)
    	*pAdapterNumber = 1;
    else	
    	*pAdapterNumber = 0;


   *pTargetID = bChannel * 2 + bID;

   return;

}
//Label_bp end

#endif




