/*++

Copyright (c) 1995-7   Promise Technology Inc 


Module Name:

    fasttrak.h

Abstract:

    This module contain structures defined in rainmker.h,struct.h
	the defination of those structures should be exact same as the original one

Author:

	 /Steven

Revision History:
	05/25/2001	steven	Create
--*/

#ifndef _PTISX_H
#define _PTISX_H

#include <linux/version.h>
#include "linuxdef.h"
//Label_bp
#include "engine/oem.h"
#include "cam_patch.h"
//Label_bp
// -----------------------------------------------
/********************define********************************/
#define MAX_DRIVE_PER_ADAPTER			0x08
#define MAX_DISK_SUPPORTED			0x10
#define NT_MAX_CONCURRENT_THREAD     8                 // it was 8
#define MAX_ADAPTER						0x02
#define ARRAY_STATUS_IDLE			(0x00)
#define ARRAY_STATUS_ENGINREBUILD		(0x01)
#define ARRAY_STATUS_REBUILD			(0x02)
#define ARRAY_STATUS_VERIFY			(0x03)
#define ARRAY_STATUS_EXPANCONV			(0x04)//
//<<add 2002.1.17 steven
#define ARRAY_STATUS_REBUILD_PAUSE				(0x00000005)
#define ARRAY_STATUS_EXPAN_PAUSE				(0x00000006)
#define ARRAY_STATUS_SYNC_PAUSE				(0x00000007)
//<<end of add
//added by isaac for raid5 initialization
#define ARRAY_STATUS_RAID5_INIT                 (0x00000008)
//end
#define ARRAY_STATUS_ERROR			(0xff)
#define ARRAY_STATUS_INVALID			(0xff)

//<<add 2002.1.16 steven
#define UTIL_START 0
#define UTIL_PAUSE 3
#define UTIL_STOP 4
#define UTIL_CONTINUE 5
//<<end of add

#define FASTTRAK66_SUBSYSTEMID          0x4D33 
#define FASTTRAK66_BASECLASS            0x01            // storage device
#define FASTTRAK66_SUBCLASS                     0x04            // other storage device type

#define ACTUAL_ARRAY_SUPPORTED			0x08
#define MAX_CHANNEL_PER_APAPTER			0x04
#define MAX_STREAM_PER_ARRAY			0x08
#define MAX_CHANNEL_SUPPORTED			0x08
//#define MAX_ID_PER_CHANNEL				0x02//because sx4 is 1 disk per channel
#define MAX_ID_PER_CHANNEL				0x02
#define MAX_DISK_PER_CHANNEL			MAX_ID_PER_CHANNEL
#define MAX_DISK_PER_APAPTER			(MAX_DISK_PER_CHANNEL*MAX_CHANNEL_PER_APAPTER)
#define MAX_BLOCK_PER_DISK				0x01
#define MAX_BLOCK_PER_CARD              (MAX_CHANNEL_SUPPORTED*MAX_ID_PER_CHANNEL*MAX_BLOCK_PER_DISK)

#define SERIAL_SIZE						0x08
#define IOCTL_SCSI_BASE				0x00000004

#define dat_space
#define buf_space


// Notification type
#define FNT_NOTHING					(0x00)
#define FNT_HOTPLUG					(0x01)
/*
typedef struct logevent{
  ULONG id;
  ULONG TimeStamp;
  ULONG SequenceNum;
  ULONG NumOfParams;
  ULONG WarningLevel;
  ULONG ParamList[6];
}LOGEVENT, buf_space *bpLOGEVENT; 
*/
#define MAX_LOGEVENT  20

#define NO_SMART					0
#define SMART_OK					1
#define SMART_ERROR					2
#define NOSUPPORT_SMART				3

#define NO_RAINMAKER               0x00
#define RAINMAKER_33               0x01
#define RAINMAKER_66               0x02
#define RAINMAKER_66B              0x03
#define RAINMAKER_100			     0x04
#define RAINMAKER_INTEL_100        0x05 /* twn crippled version, devid 0D30=CuteRAID*/
#define RAINMAKER_268              0x06

#define encGET_BOX_ID                           0x00
#define encUNKNOWN_BOX                        0xFFFFFFFF
#define encFW66                               0x00000001
#define encSW66                               0x00000011
//#define encFW100                              0x00000002
//#define encSW100                              0x00000012
#define encGBOEM							  0x00000010
#define encUNIVERSAL                          0x00000000

/* capability bits for enclosure */

#define encGET_CAPABILITY					  0x05
#define enc_HAS_VOLTAGE						  0x04
#define enc_HAS_FAN_TEMP					  0x08
#define enc_HAS_KEY							  0x40

#define encGET_FAN_STATUS                       0x01
#define encUNKNOWN_FAN                        0xFFFFFFFF
  /* return value in RPM */

#define encGET_TEMP_STATUS                      0x02
#define encUNKNOWN_TEMP                       0xFFFFFFFF
  /* return value in degree K */

#define encGET_POWER_5V_STATUS                  0x03
#define encUNKNOWN_POWER                      0xFFFFFFFF
  /* return value in mV */

#define encGET_POWER_12V_STATUS                 0x04

#define enc_TURN_OFF_POWER						0x06
#define enc_TURN_ON_POWER						0x07
#define encGET_POWER_ONOFF_STATUS				0x08

/* Temp threshold in deg C */
#define OVERTEMP_LIMIT  47
/* Fan RPM drop below this value */
/* with new resolution, min rpm value is ~43 */
#define FAN_STOP_RPM 50
/* Voltage threshold in percent */
#define OVER_UNDER_VOLT_THRESHOLD 5


//#define bit(x)			(0x00000001<<x)
//#define bits(x)			((0x00000001<<(x+1))-1)

#define blVALID_BLK                     bit(0)  /* BLOCK.blFlag */
#define blWORKING_BLK                   bit(1)
#define blASSIGNED_BLK                  bit(2)
#define blSPARE_BLK                     bit(3)
#define blDUPLICATE_BLK                 bit(4)
#define blREDIRECT_BLK                  bit(5)
#define blMARK_FOR_DOWN                 bit(6)
#define blNEED_HOT_SPARE                bit(6)
#define blMARK_FOR_UP                   bit(7)

#define blVALID_LUN                     bit(0)  /* ARY.blFlag */
#define blWORKING_LUN                   bit(1)
#define blINITIALIZED_LUN               bit(2)
#define blARY_READY                     bit(3)
#define blRECOVERING_LUN                bit(4)
#define blMARKED_LUN                    bit(5)

#define blMIRROR                        bit(0)  /* blRAID */
#define blPARITY                        bit(1)
#define blDISTRIBUTED                   bit(2)
#define blSPAN                          bit(3)
#define blRAID0                         0 
#define blRAID1                         blMIRROR
#define blRAID4                         blPARITY

#ifndef blRAID5
#define blRAID5                         blPARITY+blDISTRIBUTED
#endif
/*============  IOCTL COMMAND DEFINE HERE =========*/
#define IOCTL_FASTTRAK_GETVERSION		0x00004001		//05/19/97 S.Zhu
#define IOCTL_FASTTRAK_ARRAYCOUNT		0x00004002
#define IOCTL_FASTTRAK_ADAPTERCOUNT		0x00004003
#define IOCTL_FASTTRAK_ARRAYS			0x00004004
#define IOCTL_FASTTRAK_ADAPTER			0x00004005
#define IOCTL_FASTTRAK_BLOCKS  			0x00004006
#define IOCTL_FASTTRAK_BLOCKCOUNT		0x00004007
#define IOCTL_FASTTRAK_CHECKINTEGRITY	0x00004008
#define IOCTL_FASTTRAK_REBUILD				0x00004009              // 11/06/97 S.Zhu
#define IOCTL_FASTTRAK_ARRAYSTATUS			0x0000400a				//12/16/97 S.Zhu
#define IOCTL_FASTTRAK_GETNOTIFYDATA		0x0000400b				//01/05/98 S.Zhu
#define IOCTL_FASTTRAK_GETCHCOUNTTHRESHOLD	0x0000400c
#define IOCTL_FASTTRAK_SETCHCOUNTTHRESHOLD	0x0000400d
#define IOCTL_FASTTRAK_GETCHORGCOUNT		0x0000400e
#define IOCTL_FASTTRAK_SETCHORGCOUNT		0x0000400f

// 11/29/99 RamN
#define IOCTL_FASTTRAK_SETMAINTLENGTH		0x00004010
#define IOCTL_FASTTRAK_GETMAINTLENGTH		0x00004011
#define IOCTL_FASTTRAK_GETLOGCOUNT		    0x00004012
#define IOCTL_FASTTRAK_GETLOGEVENT  		0x00004013
#define IOCTL_FASTTRAK_GETSMARTSTATUS       0x00004014
#define IOCTL_FASTTRAK_GETRAINMAKERTYPE     0x00004015
#define IOCTL_FASTTRAK_GETSMARTCHECKENABLED 0x00004016
#define IOCTL_FASTTRAK_SETSMARTCHECKENABLED 0x00004017
#define IOCTL_FASTTRAK_ENCLOSURE_COMMAND    0x00004018
// 09/30/00 RamN
#define IOCTL_FASTTRAK_CREATE_ARRAY			0x00004019
#define IOCTL_FASTTRAK_DELETE_ARRAY			0x0000401A

// 03/26/01 KeithH
#define IOCTL_FASTTRAK_SETSYNCRATE			0x0000401B
#define IOCTL_FASTTRAK_GETSYNCRATE			0x0000401C

//added by steven
#define IOCTL_FASTTRAK_SETREBUILDRATE			0x0000401D
#define IOCTL_FASTTRAK_GETREBUILDRATE			0x0000401E
#define IOCTL_FASTTRAK_EXPANCONV				0x0000401F
#define IOCTL_FASTTRAK_SETEXPANCONVRATE			0x00004020
#define IOCTL_FASTTRAK_GETEXPANCONVRATE			0x00004021

#define IOCTL_FASTTRAK_SETWRITECACHEENABLED		0x00004023
#define IOCTL_FASTTRAK_GETWRITECACHEENABLED		0x00004024
#define IOCTL_FASTTRAK_SETHOTSPARESENABLED		0x00004025
#define IOCTL_FASTTRAK_GETHOTSPARESENABLED		0x00004026
#define IOCTL_FASTTRAK_SETHOTSWAPENABLED		0x00004027
#define IOCTL_FASTTRAK_GETHOTSWAPENABLED		0x00004028
//#define IOCTL_FASTTRAK_SETAUTODUPEDATAENABLED	0x00004029
//#define IOCTL_FASTTRAK_GETAUTODUPEDATAENABLED	0x0000402A
#define IOCTL_FASTTRAK_SETALARMBUZZERENABLED	0x0000402B
#define IOCTL_FASTTRAK_GETALARMBUZZERENABLED	0x0000402C

#define IOCTL_FASTTRAK_GETREADTHRESHOLD			0x0000402D
#define IOCTL_FASTTRAK_GETWRITETHRESHOLD		0x0000402E
#define IOCTL_FASTTRAK_SETREADTHRESHOLD			0x0000402F
#define IOCTL_FASTTRAK_SETWRITETHRESHOLD		0x00004030
#define IOCTL_FASTTRAK_GETSUBMITCHANNELTHRESHOLD	0x00004031
#define IOCTL_FASTTRAK_SETSUBMITCHANNELTHRESHOLD		0x00004032
#define IOCTL_FASTTRAK_GETWRITEMODE				0x00004033
#define IOCTL_FASTTRAK_SETWRITEMODE				0x00004034

#define IOCTL_FASTTRAK_RENAMEARRAY				0x00004035

//add 10.29 to support battery
#define IOCTL_FASTTRAK_CHECKBATTERYBACKMODULE	0x00004036
#define IOCTL_FASTTRAK_CHECKBATTERYPACK				0x00004037
#define IOCTL_FASTTRAK_GETCHARGESTATUS				0x00004038
#define IOCTL_FASTTRAK_GETCHARGECYCLE				0x00004039
#define IOCTL_FASTTRAK_GETBATTERYTEMPERATURE				0x00004040
#define IOCTL_FASTTRAK_GETBATTERYVOLTAGE				0x00004041
//
#define IOCTL_FASTTRAK_CLEARLOG				0x00004042 //add 11.01
#define IOCTL_FASTTRAK_GETDIMMSIZE			0x00004043 //add 2002.01.08 by steven
#define IOCTL_FASTTRAK_PTIBUFFLUSH			0x00004050 //add 2002.06.03 by robert
#define IOCTL_FASTTRAK_DAEMONSLEEP                      0x00004051 //add 2002.09.26 by isaac

#define FASTTRAK_IOCTL_SIGNATURE1	0x54534146
#define FASTTRAK_IOCTL_SIGNATURE2	0x4b415254

//Label_bp begin
#ifdef HPQ_BACKPLANE
#define IOCTL_FASTTRAK_PAMIDENTIFYDRIVE			0x00004100
#endif
#define IOCTL_FASTTRAK_SET_SMARTERROR            0x00004101
//Label_bp end



/*============ END OF IOCTL COMMAND DEFINE HERE =========*/

/*============ FLAG DEFINE HERE =========*/
#define FLAGS_THROTTLE				(0x7f000000l)
#define FLAG_THROTTLEONGOING		(0x01000000l)
#define FLAG_THROTTLEDONE			(0x02000000l)
#define FLAG_THROTTLESTOP			(0x03000000l)
#define FLAG_REBUILD_START          (0x040000001)
#define FLAG_CHECKINTEGRITY_START   (0x050000001)
#define FLAG_COPY_ON_COMPARE        (0x060000001)
#define FLAG_IGNORE_ON_COMPARE      (0x070000001)
// set the following bit if re-start synchronize or rebuild
#define FLAG_RESTART                (0x000001000)
// set if break ECC
#define FLAG_BREAK_ECC				(0x000002000)

// event ID For Error Codes
#define FLAG_ERROR					(0x80000000l)
#define FLAG_E_UNKNOWN				(0x80000000l)
#define	FLAG_E_BUSY					(0x80000001l)
#define FLAG_E_MEMFULL				(0x80000002l)
#define FLAG_E_RESFULL				(0x80000003l)
#define FLAG_E_ECC					(0x80000004l)
#define FLAG_E_USER					(0x80001000l)

// user flag
#ifndef FLAG_E_ECC_FIX_FAIL

#define FLAG_E_NOTINTEGRITY			(FLAG_E_USER)
#define FLAG_E_USERABORT			(FLAG_E_USER + 1) //07/14/98

#define FLAG_E_DISK_SETDOWN					(0x80000100)
#define FLAG_E_DISK_PLUGIN					(0x80000101)
#define FLAG_E_RESERVED_SECTOR_ERROR		(0x80000102)
#define FLAG_E_DISK_OFFLINE					(0x80000103)	
#define FLAG_E_BADSECTOR					(0x80000104)
#define FLAG_E_DISK_RETRY					(0x80000105) 	
#define FLAG_E_REBUILD_COMPLETE				(0x80000200)
#define FLAG_E_SYNC_COMPLETE				(0x80000201)
#define FLAG_E_REBUILD_ABORT				(0x80000202)
#define FLAG_E_SYNC_ABORT					(0x80000203)
#define FLAG_E_RETRY_TASK					(0x80000204)
#define FLAG_E_ARRAY_DOWN					(0x80000205)
#define FLAG_E_ARRAY_DEGRADE				(0x80000206)
#define FLAG_E_DISK_ERROR					(0x80000207)
#define FLAG_E_SYNC_COMP_ERROR			    (0x80000208)
#define FLAG_E_SMART_ERROR					(0x80000209)
#define FLAG_E_ECC_FIX_FAIL                 (0x8000020A)
/* OEM Swap Box - GigaByte */
#define FLAG_E_SWAP_POWERDOWN			 (0x8000020B)
#define FLAG_E_SWAP_POWERUP				 (0x8000020C)
/* power up, but no drive */
#define FLAG_E_SWAP_BADSWAP              (0x8000020D)

/* swap box error codes for temp, fan, voltage - RamN 09/30/00*/
#define FLAG_E_SWAP_OVER_TEMP			 (0x8000020e)
#define FLAG_E_SWAP_FAN_STOP			 (0x8000020f)
#define FLAG_E_SWAP_12V_OUTOFRANGE		 (0x80000210)
#define FLAG_E_SWAP_5V_OUTOFRANGE		 (0x80000211)

#define FLAG_E_ADDR_MARK_NOT_FOUND       (0x80000301)
#define FLAG_E_TRACK_0_NOT_FOUND         (0x80000302) 
#define FLAG_E_ABORT_COMMAND             (0x80000303) 
#define FLAG_E_ID_NOT_FOUND              (0x80000304) 
#define FLAG_E_CRC_ERROR                 (0x80000305) 

#define FLAG_RESET					(0x0)

#endif
/*============END OF FLAG DEFINE HERE =========*/


// -----------------------------------------------
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,4,0)
#define PTISX {	next: NULL,		proc_dir: NULL,		proc_info: NULL,	name: "FastTrak SX4000",	detect: ptisx_detect, ioctl: ptisx_ioctl,	command: NULL,				queuecommand: ptisx_queuecommand,		abort: ptisx_abort,			reset: ptisx_reset,	eh_abort_handler: ptisx_abort_eh,		eh_device_reset_handler: ptisx_reset_eh,	slave_attach: NULL,			bios_param: fasttrak_bios_param,	can_queue: Can_Queue,	/* max simultaneous cmds      */	this_id: 15,		/* scsi id of host adapter    */	sg_tablesize: Max_SG_Table,	/* max scatter-gather cmds    */	cmd_per_lun: 1,		/* cmds per lun (linked cmds) */	unchecked_isa_dma: 0,	/* no memory DMA restrictions */	use_clustering: 0,	    use_new_eh_code: 0, 	/* enable this field next time*/        emulated: 0, 				      proc_name: "FastTrak"				} 
#else
#define PTISX {	next: NULL,		proc_dir: NULL, 	proc_info: NULL, 	name: "FastTrak SX4000",	detect: ptisx_detect,				ioctl: ptisx_ioctl,				info: NULL,					    	command: NULL,						queuecommand: ptisx_queuecommand,			eh_abort_handler : ptisx_abort_eh,				eh_device_reset_handler : ptisx_reset_eh,	abort: ptisx_abort,			reset: ptisx_reset,				slave_attach: NULL,			bios_param: fasttrak_bios_param,		can_queue: Can_Queue,	/* max simultaneous cmds      */this_id: 15,		/* scsi id of host adapter    */sg_tablesize: Max_SG_Table,	/* max scatter-gather cmds    */cmd_per_lun: 1,		/* cmds per lun (linked cmds) */	present: 0,					unchecked_isa_dma: 0,	/* no memory DMA restrictions */	use_clustering: 0,					    use_new_eh_code: 0, 	/* enable this field next time*/     emulated: 0,} 
#endif
// -----------------------------------------------
/*******************end of define****************************/


/*******************struct  define****************************/
//#pragma pack(1)
// -----------------------------------------------

//
// IDE register definition
//
/*
typedef unsigned short USHORT;
typedef unsigned char UCHAR;
*/
typedef struct _PTISX_IDE_REGISTERS_1 {
    USHORT Data;
    UCHAR BlockCount;
    UCHAR BlockNumber;
    UCHAR CylinderLow;
    UCHAR CylinderHigh;
    UCHAR DriveSelect;
    UCHAR Command;
} PTISX_IDE_REGISTERS_1,  *PTISX_PIDE_REGISTERS_1;

typedef struct _PTISX_IDE_REGISTERS_2 {
   UCHAR AlternateStatus;
   UCHAR DriveAddress;
}  PTISX_IDE_REGISTERS_2,  *PTISX_PIDE_REGISTERS_2;


/**/



#if 1
typedef struct _HW_ADAPTER_EXTENSION {

    //
    // Indicate DTask
    //
   //bpDTASK pDiskTask;

    //
    // Indicate DTask in the other channel, used for Reset.
    //
     //bpDTASK pDiskTaskInOtherChannel ;
     //
     // Use to indicate the address of Scather Gather Table address.
     // One adapter one pointer.
     //
     PUCHAR BusMasterBase;

	 //
	 // IRQ level
	 //
	 ULONG InterruptLine; //05/19/97 S.Zhu

	 //
	 // Slot number of this adapter
	 //
	 ULONG lSlotNum;  //05/19/97 S.Zhu

	 //
	 // Expansion Rom address
	 //
	 ULONG ExpansionROM; //05/19/97 S.Zhu

    //
    // Base register locations
    //

    PTISX_PIDE_REGISTERS_1 BaseIoAddress1[2];
    PTISX_PIDE_REGISTERS_2 BaseIoAddress2[2];


    //
    // Data buffer pointer.
    //

    PUSHORT DataBuffer;

    //
    // Data words left.
    //

    //ULONG WordsLeft;

    //
    // Number of channels being supported by one instantiation
    // of the device extension. Normally (and correctly) one, but
    // with so many broken PCI IDE controllers being sold, we have
    // to support them.
    //

    ULONG NumberChannels;


    //
    //
    //
 //   BOOLEAN blPIOMaster[MAX_DRIVE_PER_ADAPTER];


    //
    // Identify data for device
    //

    struct PTI_driveid IdentifyData[MAX_CHANNEL_SUPPORTED];

    //
    // Indicates device is present
    //

    BOOLEAN DevicePresent[MAX_CHANNEL_SUPPORTED];

    //
    // Indicates expecting an interrupt
    //

//    BOOLEAN AdapterExpectingInterrupt;

//    BOOLEAN DriveExpectingInterrupt[4];

    UCHAR BlockCount;

	    // operation mode
	    // multiple sector support
// walen 7/18/97 not support it
//    UCHAR PromiseMultipleModeLength[MAX_DRIVE_PER_ADAPTER];

//    UCHAR PromisePIOSpeed[MAX_DRIVE_PER_ADAPTER];

//    UCHAR PromiseIordy[MAX_DRIVE_PER_ADAPTER];

//    UCHAR PromiseDMASpeed[MAX_DRIVE_PER_ADAPTER];

//    ULONG PromiseWordsPerInterrupt[MAX_DRIVE_PER_ADAPTER]; // 256 * n

    //UCHAR ReadCommand[MAX_DRIVE_PER_ADAPTER];

    //UCHAR WriteCommand[MAX_DRIVE_PER_ADAPTER];

}  HW_ADAPTER_EXTENSION,  *PHW_ADAPTER_EXTENSION;

#endif

// structure for array status 12/16/97
typedef struct _tagArrayStatus
{
	char	status;
	union {
		struct {
			char res[3];
		} idle;

		struct {
			char percentage;
		} engRebuild;

		struct {
			char percentage;
		} Rebuild;

		struct {
			char percentage;
		} ExpanConv;
		
		struct {
			char percentage;
			char integrity;
		} Verify;
		//added by isaac for raid5 initialization
		struct {
			char percentage;
		} Raid5Init;
		//end
	}runion;
}ARRAYSTATUS,*PARRAYSTATUS;

typedef struct _tagFastTrakNotification
{
	char NotifyType;
	union {
		struct {
			char bCh;
			char bId;
		} HotPlug;
	}runion;
}  FASTTRAKNOTIFICATION,  *PFASTTRAKNOTIFICATION;
/*************************struct define end*******************/

///============  IOCTL STRUCT DEFINE HERE =========
typedef struct tag_IOCTL_FASTTRAK_ARRAY_FRAME 
{
	ULONG	ulIndex;
}  IOCTL_FASTTRAK_ARRAY_FRAME,  *PIOCTL_FASTTRAK_ARRAY_FRAME;

typedef IOCTL_FASTTRAK_ARRAY_FRAME IOCTL_FASTTRAK_ADAPTER_FRAME, *PIOCTL_FASTTRAK_ADAPTER_FRAME;
typedef IOCTL_FASTTRAK_ARRAY_FRAME IOCTL_FASTTRAK_BLOCK_FRAME, *PIOCTL_FASTTRAK_BLOCK_FRAME;
typedef struct tagIOCTL_FASTTRAK_CHECKINTEGRITY_FRAME
{
	USHORT	bID;
	USHORT	Status;
	ULONG	Percentage;
	ULONG	ulFlag;
	ULONG	reserved[12];
	ULONG	bIntegrity;
} IOCTL_FASTTRAK_CHECKINTEGRITY_FRAME,  *PIOCTL_FASTTRAK_CHECKINTEGRITY_FRAME;

typedef struct tagIOCTL_FASTTRAK_REBUILD_FRAME
{
	USHORT	bID;
	USHORT	Status;
	ULONG	Percentage;
	ULONG	ulFlag;
	ULONG	reserved[12];
	ULONG   RebuildDisk;
} IOCTL_FASTTRAK_REBUILD_FRAME,  *PIOCTL_FASTTRAK_REBUILD_FRAME;

// retrieve the max and min event ID currently in buffer
typedef struct tagIOCTL_FASTTRAK_GETNUMQUEUEEVENTFRAME
{
	ULONG	EventCount; // Sequence Num of start
/*	ULONG   EndNum; */  // Sequence Num of end
}  IOCTL_FASTTRAK_GETNUMQUEUEEVENTFRAME,  *PIOCTL_FASTTRAK_GETNUMQUEUEEVENTFRAME;


// retrieve events with specified range of seq numbers
typedef struct tagIOCTL_FASTTRAK_GETEEVENTFRAME
{
    ULONG EventCount;  // starting seq num, <= ending
    LOGEVENT LogEvent[MAX_LOGEVENT];
}  IOCTL_FASTTRAK_GETEEVENTFRAME,  *PIOCTL_FASTTRAK_GETEEVENTFRAME;



typedef struct tagIOCTL_FASTTRAK_GETSMARTSTATUSFRAME
{
    UCHAR bController;
    UCHAR bCh;
    UCHAR bID;
    UCHAR bSmartStatus;  // 1 = OK, 0 = Fail
}  IOCTL_FASTTRAK_GETSMARTSTATUSFRAME,
   *PIOCTL_FASTTRAK_GETSMARTSTATUSFRAME;



typedef struct tagIOCTL_FASTTRAK_GETRAINMAKERTYPEFRAME
{
    ULONG dwRainmakerType;
    ULONG dwVendorId;     // notused
    ULONG dwDeviceId;     // notused
    ULONG dwSubsystemId;  // notused
    ULONG dwClassCode;    // notused
}  IOCTL_FASTTRAK_GETRAINMAKERTYPEFRAME,
  *PIOCTL_FASTTRAK_GETRAINMAKERTYPEFRAME;

typedef struct tagIOCTL_FASTTRAK_GETSMARTCHECKENABLEDFRAME
{
    ULONG bEnabled;
}  IOCTL_FASTTRAK_GETSMARTCHECKENABLEDFRAME,
  *PIOCTL_FASTTRAK_GETSMARTCHECKENABLEDFRAME;

typedef struct tagIOCTL_FASTTRAK_SETSMARTCHECKENABLEDFRAME
{
    ULONG bEnabled;
}  IOCTL_FASTTRAK_SETSMARTCHECKENABLEDFRAME,
  *PIOCTL_FASTTRAK_SETSMARTCHECKENABLEDFRAME;


typedef struct tagIOCTL_FASTTRAK_ENCLOSURE_COMMAND_FRAME
{
    // [IN]
    UCHAR bSubCmd;
    UCHAR bCh;
    UCHAR bID;
    UCHAR bFanIndex;
    // [OUT]
    ULONG dwValue;
}  IOCTL_FASTTRAK_ENCLOSURE_COMMAND_FRAME,
  *PIOCTL_FASTTRAK_ENCLOSURE_COMMAND_FRAME;

typedef struct tagIOCTL_FASTTRAK_CREATE_ARRAY_FRAME
{
    // [IN]
	//UCHAR bPhysIndex;
        //modified by isaac for initialize and GIGA boundary
	ULONG blRAID;
	UCHAR nDisk;
	UCHAR DiskID[8];
	UCHAR nStripeBlockSize;
	char Arrayname[32];
    // [OUT]
    LONG dwStatus;  // 0=ok, -1=error
}  IOCTL_FASTTRAK_CREATE_ARRAY_FRAME,
  *PIOCTL_FASTTRAK_CREATE_ARRAY_FRAME;

typedef struct tagIOCTL_FASTTRAK_DELETE_ARRAY_FRAME
{
    // [IN]
	UCHAR bPhysIndex;
    // [OUT]
    LONG dwStatus;  // 0=ok, -1=error
}  IOCTL_FASTTRAK_DELETE_ARRAY_FRAME,
  *PIOCTL_FASTTRAK_DELETE_ARRAY_FRAME;

typedef struct tagIOCTL_FASTTRAK_ENABLEDFRAME
{
    ULONG bEnabled;
}  IOCTL_FASTTRAK_ENABLEDFRAME,
  *PIOCTL_FASTTRAK_ENABLEDFRAME;

//added to support get/set synchronization,rebuild and expansion&conversion rate ioctl by reevyn
typedef struct tagIOCTL_FASTTRAK_RATEFRAME
{
	UCHAR bController;
    UCHAR bCh;
    UCHAR bID;
    UCHAR bRate;  // 0 - 31
}  IOCTL_FASTTRAK_RATEFRAME,
   *PIOCTL_FASTTRAK_RATEFRAME;

//added to support expansion/conversion ioctl by reevyn
typedef struct tagIOCTL_FASTTRAK_EXPANCONV_FRAME
{
	USHORT	nPhysIndex;
	ULONG	Status;
	ULONG	Percentage;
	ULONG	ulFlag;
    USHORT nNewRAID;
	USHORT nNewDisk;
	USHORT nNewDiskIDs[MAX_CHANNEL_SUPPORTED*MAX_ID_PER_CHANNEL];
	USHORT nStripeBlockSize;
}  IOCTL_FASTTRAK_EXPANCONV_FRAME,
  *PIOCTL_FASTTRAK_EXPANCONV_FRAME;

//add 9.20
typedef struct tagIOCTL_FASTTRAK_RENAMEARRAY_FRAME
{
	ULONG arrayid;
	UCHAR ArrayName[64];
} IOCTL_FASTTRAK_RENAMEARRAY_FRAME, *PIOCTL_FASTTRAK_RENAMEARRAY_FRAME;

//Label_bp begin
typedef struct tagIOCTL_FASTTRAK_SET_SMARTERROR_FRAME
{
	UCHAR bCh;
	//UCHAR bID;
       int dwStatus;  // 1=ok, 2=error
}  IOCTL_FASTTRAK_SET_SMARTERROR_FRAME,
  *PIOCTL_FASTTRAK_SET_SMARTERROR_FRAME;
//Label_bp end

/////////////////////////////////////////////////////////
typedef struct Arrays_Buffer{
	ULONG ReturnCode;
	ARY Array[PTI_Max_Arr];
} Arrays_Buffer_t;

typedef struct Adapters_Buffer{
	ULONG Adapterindex;
	ULONG ReturnCode;
	HW_ADAPTER_EXTENSION Controller;
} Adapters_Buffer_t;

typedef struct Blocks_Buffer{
	ULONG ReturnCode;
	BLOCK Block[PTI_Max_Dev];
} Blocks_Buffer_t;

typedef struct GetLogCount_Buffer
{
	ULONG ReturnCode;
	IOCTL_FASTTRAK_GETNUMQUEUEEVENTFRAME val;
}   GetLogCount_Buffer_t;

typedef struct  GetSmartStatus_Bffer
{
	ULONG ReturnCode;
	IOCTL_FASTTRAK_GETSMARTSTATUSFRAME val;
}  GetSmartStatus_Bffer_t;

typedef struct ArrayStatus_Buffer
{
	ULONG ReturnCode;
	ARRAYSTATUS as[ACTUAL_ARRAY_SUPPORTED];
}  ArrayStatus_Buffer_t;

typedef struct GetRainMakerType_Buffer
{
        //modified by isaac for dualcard
	ULONG AdapterIndex;
	ULONG ReturnCode;
	IOCTL_FASTTRAK_GETRAINMAKERTYPEFRAME val;
}  GetRainMakerType_Buffer_t;

typedef struct GetLogEvent_Buffer
{
	ULONG ReturnCode;
	IOCTL_FASTTRAK_GETEEVENTFRAME val;
}  GetLogEvent_Buffer_t;

typedef struct GetSmartCheckEnabled_Buffer
{
	ULONG ReturnCode;
	IOCTL_FASTTRAK_GETSMARTCHECKENABLEDFRAME val;
}  GetSmartCheckEnabled_Buffer_t;

typedef struct SetSmartCheckEnabled_Buffer
{
	ULONG ReturnCode;
	IOCTL_FASTTRAK_SETSMARTCHECKENABLEDFRAME val;
}  SetSmartCheckEnabled_Buffer_t;

typedef struct GetEnclosureType_Buffer
{
	ULONG ReturnCode;
	IOCTL_FASTTRAK_ENCLOSURE_COMMAND_FRAME val;
}  GetEnclosureType_Buffer_t;

typedef struct CreateArray_Buffer
{
	ULONG ReturnCode;
	IOCTL_FASTTRAK_CREATE_ARRAY_FRAME val;
}  CreateArray_Buffer_t;

typedef struct DeleteArray_Buffer
{
	ULONG  ReturnCode;
	IOCTL_FASTTRAK_DELETE_ARRAY_FRAME val;
}  DeleteArray_Buffer_t;

typedef struct Rate_Buffer
{
	ULONG ReturnCode;
	IOCTL_FASTTRAK_RATEFRAME val;
}  Rate_Buffer_t;

typedef struct EnableEd_Buffer
{
	ULONG ReturnCode;
	IOCTL_FASTTRAK_ENABLEDFRAME val;
}  EnableEd_Buffer_t;

//add bu steven on 07/31/2001
typedef struct _DriverVersion
{
	ULONG version_length;
	char version[50];
	ULONG timestamp_length;
	char timestamp[50];
}  StrDriverVersion;

typedef struct Io_Buffer
{
		ULONG ReturnCode;
		ULONG val;
}  Io_Buffer_t;

typedef struct _NUMBER{
   ULONG 		number;//number of array,apapters
}   StructNUMBER;

//added by isaac for BBM
typedef struct IOCTL_BBM{
	ULONG  AdapterId;
	ULONG  ReturnCode;
}  StructIOCTLBBM;
//end

//added by isaac for array status monitor daemon
typedef struct IOCTL_ARRAY_DAEMON{
        ULONG  AdapterId;
} StructIOCTLARRAYDAEMON; 
//end

typedef struct _StrString{
   CString cstr;//a string
}   StrString;

typedef struct StrRenameArray_Buffer
{
	ULONG ReturnCode;
	IOCTL_FASTTRAK_RENAMEARRAY_FRAME val;
} StrRenameArray_Buffer_t;

//end of add
//#pragma pack()


///============  GLOBAL VARIBALE DEFINE HERE =========
//12/16/97 for array status
ARRAYSTATUS aryStatus[ACTUAL_ARRAY_SUPPORTED];

//01/05/98 for notification
FASTTRAKNOTIFICATION ftNotification;
//UCHAR  SmartStatus[4][2];/*08/07/2001 steven*/


#endif /* _PTISX_H */ 
