/*********************************************************************
* global.h
* 08/07/00 	Frank Tiernan
* 	This file contains all structures and definitions for global 
* data shared between the OS driver and Channel Driver. All structures 
* are system independent.
* 10/30/00	Linus Chen
* 	Merge all header file except wrapper.h and adding some structures 
* and global data type for Adapter or SWAP-BOX for IOCTL interface.
* 11/08/00	Linus Chen
*	Add field "MIC" to typedef struct PTI_swapbox_t
* 11/24/00	Linus Chen
*	Support two FastTrak adapter and Adding DID26x definition
*********************************************************************/
#include <linux/blk.h>
#include <linux/pci.h>
#ifndef _GLOBAL_H_
#define _GLOBAL_H_
#ifdef _NEC
#define VERSION	"Version 1.01.70.24"
#elif _HPQ
#define VERSION	"Version 1.01.30.24"
#else
#define VERSION "Version 1.01.00.24"
#endif
#define VERDATE "(9.Oct.2003)"
//#define VERDATE ""

#define PTI_Max_Arr	8

#define ChPAda		2	
#define DevPCh		2	

// Define PDC2026x Device ID
#define DID621	        0x6621
//added by isaac for SX150 support
#define DID622          0x6622 
extern unsigned short 	PTI_DEVID[5] ;

#define NUMBER_OF_ADAPTER_TYPE_SUPPORTED 2
extern char* FastTrakAdapterName[NUMBER_OF_ADAPTER_TYPE_SUPPORTED+1];

//#define TYPE_OF_SX4000  0
//#define TYPE_OF_SX150   1


#define PTI_Max_Ada	 2
#define PTI_Max_Ch		8	
#define PTI_Max_Dev	 16 	
#define	Can_Queue       8 	
#define Max_SG_Table	16	// Engine : max bSG_Count = 32


extern int FastTrakAdapterType[PTI_Max_Ada];

#define DEB(x)  		//	Display messages
#define	DEBFUN(x) 	  	//	DEBUG Function	
#define	DebPTIFun(x)  		//	DEBUG FastTrak Function	
#define	DebEngFun(x)   		//	DEBUG Engine   Function	
#define	DebScsiFun(x) 		//	DEBUG SCSI     Function	

#define DBO(x)                // debug os driver
#define DBC(x)                // debug channel driver
//* Identify device information according to ATA3 SPEC.*/
struct PTI_driveid {
	unsigned short	config;		
	unsigned short	cyls;		/* "physical" cyls */
	unsigned short	word2;	
	unsigned short	heads;		/* "physical" heads */
	unsigned short	words4[2];	/* reserved words 4-5 */
	unsigned short	sectors;	/* "physical" sectors per track */
	unsigned short	words7[3];	/* reserved words 7-9 */
	unsigned char	serial_no[20];	/* word10 - word19 */
	unsigned short	words20[3];	/* reserved words 20-22 */
	unsigned char	fw_rev[8];	
	unsigned char	model[40];	/* word27 - word46 */
	unsigned short	words47[2];	/* reserved words 47-48 */
	unsigned char	byte49;	
	unsigned char	capability;	/* word49: bit8-bit15*/
	unsigned short	word50[3];	/* reserved words 50-52 */
	unsigned short	field_valid;	/* word53 */
	unsigned short	cur_cyls;	/* logical cylinders */
	unsigned short	cur_heads;	/* logical heads */
	unsigned short	cur_sectors;	/* logical sectors per track */
	unsigned short	words57[2];	/* reserved words 57-58 */
	unsigned short	mult_sect;	
	unsigned int	lba_capacity;	
	unsigned short	word62;
	unsigned short	dma_mword;	/* word63 */
	unsigned short  word64[3]; 	/* reserved words 64-66 */
	unsigned short  eide_pio;       /* word67 */
	unsigned short  eide_pio_iordy; /* word68 */
        unsigned short UDMAReserved[2];         /* (word 69 - 70)*/
        unsigned short UDMAReceipt2Release;             /* (word 71)*/
        unsigned short UDMAService2Busy;                /* (word 72)*/
        unsigned short UDMAQueue;                       /* (word 73)*/
        unsigned short UDMAReserved2[6];                /* (word 74 - 79)*/
        unsigned short UDMAMajor;                       /* (word 80)*/
        unsigned short UDMAMinor;                       /* (word 81)*/
        unsigned short UDMACommandSupport;              /* (word 82)*/
        unsigned short UDMACommandSupport2;             /* (word 83)*/
        unsigned short UDMACommandExt;          /* (word 84)*/
        unsigned short UDMACommandEnable;               /* (word 85)*/
        unsigned short UDMACommandEnable2;              /* (word 86)*/
        unsigned short UDMACommandExtEnable;    /* (word 87)*/
        unsigned short  dma_ultra;	/* word88 */
	unsigned short	words89[11];	/* reserved words 89-99 */
	unsigned short  max_48LBA[2];	/* max LBA address for 48bit */
	unsigned short  words102[24];	/* reserved words 104-125 */
	unsigned short	last_lun;	/* word 126 */
	unsigned short	word127;	/* word 127 */
	unsigned short	dlf;		/* device lock function */
	unsigned short  csfo;		/* current set features options */
	unsigned short	words130[26];	/* reserved words 130-155 */
	unsigned short	words156[4];	/* reserved words 156-159 */
        //modified by isaac for bug according Amay's advice
	unsigned short	words160[96];	/* reserved words 160-255 */	
};
#if 0
struct PTI_driveid{
    USHORT GeneralConfiguration;        /* 00*/
    USHORT NumberOfCylinders;           /* 02*/
    USHORT Reserved1;                   /* 04*/
    USHORT NumberOfHeads;               /* 06*/
    USHORT UnformattedBytesPerTrack;    /* 08       obsolete*/
    USHORT UnformattedBytesPerSector;   /* 0A       obsolete*/
    USHORT SectorsPerTrack;             /* 0C*/
    USHORT VendorUnique1[3];            /* 0E*/
    USHORT SerialNumber[10];            /* 14*/
    USHORT BufferType;                  /* 28*/
    USHORT BufferSectorSize;            /* 2A*/
    USHORT NumberOfEccBytes;            /* 2C*/
    USHORT FirmwareRevision[4];         /* 2E*/
    USHORT ModelNumber[20];             /* 36*/
    UCHAR  MaximumBlockTransfer;        /* 5E*/
    UCHAR  VendorUnique2;               /* 5F*/
    USHORT DoubleWordIo;                /* 60*/
    USHORT Capabilities;                /* 62*/
    USHORT Reserved2;                   /* 64*/
    UCHAR  VendorUnique3;               /* 66*/
    UCHAR  PioCycleTimingMode;          /* 67*/
    UCHAR  VendorUnique4;               /* 68*/
    UCHAR  DmaCycleTimingMode;          /* 69*/
/*    USHORT TranslationFieldsValid:1;    // 6A*/
/*    USHORT SpeedFieldsValid:1;          // 6A*/
/*    USHORT UDMASupportValid:1;            // 6A*/
/*    USHORT Reserved3:13;*/
    USHORT ValidBit;                        /* 6A (word 53)*/
    USHORT NumberOfCurrentCylinders;    /* 6C*/
    USHORT NumberOfCurrentHeads;        /* 6E*/
    USHORT CurrentSectorsPerTrack;      /* 70*/
    U32  CurrentSectorCapacity;       /* 72*/
    USHORT Reserved4[2];                /* 76*/
    USHORT Reserved4_1[1];              /* 7A*/
    USHORT SingleDMAModeSupport;    /* 7c*/
    USHORT MultiDMAModeSupport;     /* 7e*/
    USHORT AdvicePIOModeSupport;    /* 80*/
    USHORT MinDMACycletime;         /* 82*/
    USHORT DMACycletime;            /* 84*/
    USHORT PIOCycletime;            /* 86 (word 67)*/
    USHORT PIOCycletimeIORDY;               /* 88 (word 68)*/
    USHORT UDMAReserved[2];         /* (word 69 - 70)*/
    USHORT UDMAReceipt2Release;             /* (word 71)*/
    USHORT UDMAService2Busy;                /* (word 72)*/
    USHORT UDMAQueue;                       /* (word 73)*/
    USHORT UDMAReserved2[6];                /* (word 74 - 79)*/
    USHORT UDMAMajor;                       /* (word 80)*/
    USHORT UDMAMinor;                       /* (word 81)*/
    USHORT UDMACommandSupport;              /* (word 82)*/
    USHORT UDMACommandSupoort2;             /* (word 83)*/
    USHORT UDMACommandExt;          /* (word 84)*/
    USHORT UDMACommandEnable;               /* (word 85)*/
    USHORT UDMACommandEnable2;              /* (word 86)*/
    USHORT UDMACommandExtEnable;    /* (word 87)*/
    USHORT UDMAMode;                        /* (word 88)*/
    USHORT words89[167];	/* reserved words 89-255 */
};
#endif
typedef struct PTI_driveid PTI_driveid_t;

// -------------------------------------------------------------------
//#define memcpy(unsigned char *d,unsigned char *s,int size) { int i; for(i=0;i<size;i++) *d++=*s++;} 
typedef struct PTI_adapter PTI_adapter_t ;
typedef struct PTI_channel PTI_channel_t ;
typedef struct PTI_drive   PTI_drive_t ;

// -------------------------------------------------------------------
struct PTI_adapter {
   unsigned char	id; 
   unsigned char	present; 
   unsigned short	deviceid;
   unsigned char 	bus;
   unsigned char       	device_fun;
   unsigned char	irq; 
   spinlock_t		pti_lock;
   unsigned int		rom_base;
   PTI_channel_t		*pchannel[4];	
}  ;
// -------------------------------------------------------------------
struct PTI_channel {
   PTI_adapter_t 	*padapter ;	
   unsigned char	id;
   unsigned short	base;
   unsigned short	ctrl;
   unsigned short	bm;
   PTI_drive_t		*pdrive[2];   	
}  ;
// -------------------------------------------------------------------
//The Main disk structure for each drive
struct PTI_drive {
   PTI_channel_t		*pchannel;	
   unsigned char	id;
   unsigned char	select;
   unsigned char	present;
   unsigned char	cpending;
   unsigned char 	xfermode;
   struct PTI_driveid	*identify;
   unsigned char	arr;
   unsigned char	strm;
   unsigned char	rebuilding;
}  ;
// -------------------------------------------------------------------
//The SwapBox structure for IOCTL (0X3803)
typedef struct {
   unsigned char	present;
   unsigned char 	BoxID;
   unsigned short	MIC;	// monitor IC
   unsigned long	RPM;
   unsigned short	TmpC;
   unsigned short	TmpF;
   unsigned short	Vcc;	// (mv)
   unsigned short	V12;	// (mv)
}  PTI_swapbox_t ;
// -------------------------------------------------------------------
//The Main Adapter structure for IOCTL(0x3801)
typedef struct {
   unsigned short	deviceid;
   unsigned char	irq;
   unsigned short	base[5];
   unsigned int 	rom;
}  PTI_ladainfo_t ;
// -------------------------------------------------------------------
//The Array structure for PTI_info_t - IOCTL(0x3801)
typedef struct {
   unsigned char	ID;
   unsigned char	Flag;
   unsigned char 	RAID;
   unsigned char	StripeBlockPower;
   unsigned short	Cyl;
   unsigned char	Hd;
   unsigned char	Sctr;
   unsigned int		Size;
   unsigned int		Watermark;
   unsigned char	strm;
}  PTI_larrinfo_t ;
// -------------------------------------------------------------------
//The Main Information structure for IOCTL (0x3801)
typedef struct {
   unsigned char	ver[30];
   PTI_ladainfo_t	adainfo[PTI_Max_Ada];
   PTI_larrinfo_t	arrinfo[PTI_Max_Arr];
   unsigned char	rebdev;
}  PTI_info_t ;
// -----------------------------------------------
struct	scsiengreq {	// SCSI - Engine request
   void			*cmd;
   void			*fn;
   unsigned char	target;
   unsigned char	use_sg;
   unsigned char	*buffer;
   unsigned char	*sense;
   unsigned char	cmnd[12];
   unsigned long	WStartAddr[Max_SG_Table];
   unsigned long	WCount[Max_SG_Table];   
} ; 
typedef	struct	scsiengreq ScsiEngReq_t ;

extern 	PTI_adapter_t 	PTI_adapter[PTI_Max_Ada];
extern 	PTI_channel_t 	PTI_channel[PTI_Max_Ch];
extern 	PTI_drive_t 	PTI_drive[PTI_Max_Dev];
extern	PTI_swapbox_t 	PTI_box[PTI_Max_Dev];
extern	PTI_info_t 	PTI_info;
extern 	unsigned long   DEVBUSY[PTI_Max_Dev] ;
extern 	unsigned char 	blConfigDoneFlag;

#define bPOWER_UP		0x00
#define bHARD_RESET		0x01
#define bSOPTI_RESET		0x02

unsigned char 	identify_device(unsigned char dev,void *id) ;

//extern U8 bInitRAID(U8 bType,U32 wP,bpBUF p_b,bpBUF pPBMBuf,bpBUF pNonPageMem,WORD  wInitInAcceMemSzie,U32  wInitInAcceMemSzie1,WORD  wInitAcceMemSzie,WORD  wInitPBMSize,U32  wInitNonPageMemSize);

//unsigned char  	bInitRAID(unsigned char bType,unsigned long wP, unsigned char *p_b, unsigned long wSize, unsigned long p_bVir); removed by isaac 


//extern ByTE _call bInitRAID(ByTE  bType, WORD  wP, bpBUF p_b, WORD  wInitInAcceMemSzie, WORD  wInitAcceMemSzie);

// fasttrak
//int set_speed(unsigned char dev, unsigned char pio_mode, unsigned char dma_mode, unsigned char udma_mode);
int set_feature(unsigned char dev, unsigned char *pio_mode, unsigned char *dma_mode, unsigned char *udma_mode);

// PTIlog
extern void 	log_event(int eventid, int ArrayID, int dev, unsigned long LBA, int percent, short command, short status);
extern void     EnableInt(void);
extern void	DisableInt(void);
extern unsigned char	SCSIRequestFlag ;
extern unsigned long	StartRebJiffies ;
extern unsigned char	DisMirrorSync   ;
void 			InitQueueBuffer(void) ;

// sdram
int InitSX4000LocalDIMM(int bAdapterNumber,int *Speed,int *Size) ;
	
char 	DefDriveStruct (void) ;
void 	SWAP_STATE(unsigned char fun,unsigned char dev) ;
void	SwapSubFun(unsigned char fun,unsigned short port) ;
unsigned char RW_Byte(unsigned char fun,unsigned char val,unsigned short port);
unsigned char RWWinReg(unsigned char fun,unsigned char dev,unsigned char index,unsigned char data) ;
void 	GetSwapInfo (unsigned char dev) ;
extern  void 	InitLED(void) ;
int 	GetProcInfo( int maxsize , char *mybuf );
int 	RepArrInfo (void *buffer) ;
char 	GetAllSwapInfo (void);


//event log struct provided thru ioctl
typedef struct {
   int sequence;
   int eventid;
   int arrayid;
   int diskid;
} snmp_log_t;

extern  snmp_log_t	snmp_log[50];
extern  int		snmp_log_index;

extern void buzzer_on(void);
extern void buzzer_off(void);
//added by isaac for identify card number
extern unsigned char ARRAYID2CARDNUM(unsigned char array_id);

//#define ARRAYID2CARDNUM( Array_ID ) ( (blkDisk[aryDef[Array_ID].strm[0].bIndex].bCh) < 4 ? 0:1)
#endif
