

struct pti_st_host 
{
  int                   major;            /* control device's major */
  int                   counter;          /*counter of using control device*/
};

extern struct pti_st_host *pti_st_hostp;


//---------------------------------------------------------------------------
// I960RP Memory-Mapper Register PCI Addressing Offset 
#define ARSR_OFFSET   0       //APICReg
#define AWR_OFFSET    0x08    //APCIWinReg
#define IMR0_OFFSET   0x10    //InboundMsgReg0
#define IMR1_OFFSET   0x14    //InboundMsgReg1
#define OMR0_OFFSET   0x18    //OutboundMsgReg0
#define OMR1_OFFSET   0x1c    //OutboundMsgReg1
#define IDR_OFFSET    0x20    //InboundDBellReg
#define IISR_OFFSET   0x24    //InboundIntStatusReg
#define IIMR_OFFSET   0x28    //InboundIntMaskReg
#define ODR_OFFSET    0x2c    //OutboundDBellReg
#define OISR_OFFSET   0x30    //OutboundIntStatusReg
#define OIMR_OFFSET   0x34    //OutboundIntMaskReg
#define INBOUNDQPORT  0x40
#define OUTBOUNDQPORT 0x44
#define MUCR_OFFSET   0x50    //MUConfReg
#define QBAR_OFFSET   0x54    //QueueBaseAddReg

//---------------------------------------------------------------------------
// Bit Definition for InboundIntStatusReg (IISR)
#define APICW_Status      0x100  //APIC Window Interrupt (R/C)
#define APICR_Status      0x80   //APIC Register Select Interrupt (R/C)
#define IR_Status         0x40   //Index Register Interrupt (R/C)
#define OBFQ_OF_Status    0x20   //Outbound Free Queue OverFlow Interrupt (R/C)
#define IBPQ_Status       0x10   //Inbound Post Queue Interrupt (R/C)
#define NMI_DB_Status     0x08   //NMI Doorbell Interrupt (R/O)
#define IB_DB_Status      0x04   //Inbound Doorbell Interrupt (R/O)
#define IB_MSG1_Status    0x02   //Inbound Message 1 Interrupt (R/C)
#define IB_MSG0_Status    0x01   //Inbound Message 0 Interrupt (R/C)

// Bit Definition for InboundIntMaskReg (IIMR)
#define APICW_Mask        0x100  //APIC Windows Interrupt Mask (R/W)
#define APICRSI_Mask      0x80   //APIC Register Select Interrupt Mask (R/W)
#define IR_Mask           0x40   //Index Register Interrupt Mask (R/W)
#define OBFQ_OF_Mask      0x20   //Outbound Free Queue Overflow Interrupt Mask (R/W)
#define IBPQ_Mask         0x10   //Inbound Post Queue Interrupt Mask (R/W)
#define NMI_DB_Mask       0x08   //NMI Doorbell Interrupt Mask (R/W)
#define IB_DB_Mask        0x04   //Inbound DoorbellInterrupt Mask (R/W)
#define IB_MSG1_Mask      0x02   //Inbound Message 1 Interrupt Mask (R/W)
#define IB_MSG0_Mask      0x01   //Inbound Message 0 Interrupt Mask (R/W)

// Bit Definition for Outbound Interrupt Status Register (OISR)
#define PCI_INT_D_Status  0x80   //PCI Interrupt D (RO)
#define PCI_INT_C_Status  0x40   //PCI Interrupt C (RO)
#define PCI_INT_B_Status  0x20   //PCI Interrupt B (RO)
#define PCI_INT_A_Status  0x10   //PCI Interrupt A (RO)
#define OBPQ_INT_Status   0x08   //Outbound Post Queue Interrupt (RO)
#define OBDB_INT_Status   0x04   //Outbound Doorbell Interrupt (RO)
#define OBMSG1_INT_Status 0x02   //Outbound Message 1 Interrupt (PCI R/C)
#define OBMSG0_INT_Status 0x01   //Outbound Message 0 Interrupt (PCI R/C)

// Bit Definition for Outbound Interrupt Mask Register
#define PCI_INT_D_Mask    0x80   //PCI Interrupt D (RW)
#define PCI_INT_C_Mask    0x40   //PCI Interrupt C (RW)
#define PCI_INT_B_Mask    0x20   //PCI Interrupt B (RW)
#define PCI_INT_A_Mask    0x10   //PCI Interrupt A (RW)
#define OBPQ_INT_Mask     0x08   //Outbound Post Queue Interrupt Mask (RW)
#define OBDB_INT_Mask     0x04   //Outbound Doorbell Interrupt Mask (RW)
#define OBMSG1_INT_Mask   0x02   //Outbound Message 1 Interrupt Mask (RW)
#define OBMSG0_INT_Mask   0x01   //Outbound Message 0 Interrupt Mask (RW)

//---------------------------------------------------------------------------
// IOP Status
#define IOPSTATE_INIT     0x01
#define IOPSTATE_RESET    0x02
#define IOPSTATE_HOLD     0x04
#define IOPSTATE_READY    0x05
#define IOPSTATE_OP       0x08
#define IOPSTATE_FAILED   0x10
#define IOPSTATE_FAULTED  0x11




